"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _PaginationSize = _interopRequireDefault(require("../_PaginationSize"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var BriefPagination = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(BriefPagination, _Component);
  var _super = _createSuper(BriefPagination);
  function BriefPagination(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, BriefPagination);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePageChange", function (page) {
      _this.setState({
        page: page
      }, function () {
        var _this$props = _this.props,
          onPageChange = _this$props.onPageChange,
          onChange = _this$props.onChange;
        onPageChange && onPageChange(page);
        onChange && onChange({
          page: page,
          pageSize: _this.state.pageSize
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePageSizeChange", function (pageSize) {
      var pageSizeValueField = _this.props.pageSizeValueField,
        originPageSizeValue = _TableCalculation["default"].getPageSizeValue(_this.state.pageSize, pageSizeValueField),
        pageSizeValue = _TableCalculation["default"].getPageSizeValue(pageSize, pageSizeValueField);
      if (pageSizeValue && originPageSizeValue !== pageSizeValue) {
        var _this$props2 = _this.props,
          onPageSizeChange = _this$props2.onPageSizeChange,
          onChange = _this$props2.onChange;
        onPageSizeChange && onPageSizeChange(pageSizeValue);
        var totalPage = Math.ceil(_this.props.total / pageSizeValue),
          page = _Valid["default"].range(_this.state.page, 0, totalPage - 1);
        if (page !== _this.state.page) {
          var onPageChange = _this.props.onPageChange;
          onPageChange && onPageChange(page);
          onChange && onChange({
            page: page,
            pageSize: pageSizeValue
          });
        } else {
          onChange && onChange({
            page: _this.state.page,
            pageSize: pageSizeValue
          });
        }
      }
    });
    _this.state = {
      page: props.page,
      pageSize: props.pageSize
    };
    return _this;
  }
  (0, _createClass2["default"])(BriefPagination, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props3 = this.props,
        total = _this$props3.total,
        page = _this$props3.page,
        pageSize = _this$props3.pageSize,
        pageSizes = _this$props3.pageSizes,
        pageSizeRightIconCls = _this$props3.pageSizeRightIconCls,
        pageSizeValueField = _this$props3.pageSizeValueField,
        pageSizeDisplayField = _this$props3.pageSizeDisplayField,
        totalVisible = _this$props3.totalVisible,
        selectedCount = _this$props3.selectedCount,
        selectionVisible = _this$props3.selectionVisible,
        pageSizeVisible = _this$props3.pageSizeVisible,
        prevIconCls = _this$props3.prevIconCls,
        nextIconCls = _this$props3.nextIconCls,
        selectionRenderer = _this$props3.selectionRenderer,
        totalRenderer = _this$props3.totalRenderer,
        parentEl = _this$props3.parentEl,
        totalPage = Math.ceil(total / pageSize),
        startNumber = _Valid["default"].range(page * pageSize + 1, 0, total),
        stopNumber = _Valid["default"].range((page + 1) * pageSize, 0, total);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "brief-pagination"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "brief-pagination-left"
      }, selectionVisible ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "brief-pagination-selected"
      }, selectionRenderer ? selectionRenderer(selectedCount, total, page, totalPage, pageSize, pageSizes) : "Selected: ".concat(selectedCount)) : null, totalVisible ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "brief-pagination-total"
      }, totalRenderer ? totalRenderer(total, page, totalPage, pageSize, pageSizes) : "Total: ".concat(total)) : null), /*#__PURE__*/_react["default"].createElement("div", {
        className: "brief-pagination-right"
      }, pageSizeVisible ? /*#__PURE__*/_react["default"].createElement(_PaginationSize["default"], {
        pageSize: pageSize,
        pageSizes: pageSizes,
        valueField: pageSizeValueField,
        displayField: pageSizeDisplayField,
        parentEl: parentEl,
        rightIconCls: pageSizeRightIconCls,
        onPageSizeChange: this.handlePageSizeChange
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "brief-pagination-info"
      }, "".concat(startNumber, "-").concat(stopNumber, " of ").concat(total)), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        iconCls: prevIconCls,
        disabled: page <= 0,
        onClick: function onClick() {
          return _this2.handlePageChange(page - 1);
        }
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        iconCls: nextIconCls,
        disabled: page >= totalPage - 1,
        onClick: function onClick() {
          return _this2.handlePageChange(page + 1);
        }
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        page: _ComponentUtil["default"].getDerivedState(props, state, 'page'),
        pageSize: _ComponentUtil["default"].getDerivedState(props, state, 'pageSize')
      };
    }
  }]);
  return BriefPagination;
}(_react.Component);
BriefPagination.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The total of data.
   */
  total: _propTypes["default"].number,
  /**
   * The valid page.
   */
  page: _propTypes["default"].number,
  /**
   * The number of per page.
   */
  pageSize: _propTypes["default"].number,
  /**
   * The array of pageSize.
   */
  pageSizes: _propTypes["default"].array,
  /**
   * The value field name of PageSize. (default: "value")
   */
  pageSizeValueField: _propTypes["default"].string,
  /**
   * The display field name of PageSize. (default: "text")
   */
  pageSizeDisplayField: _propTypes["default"].string,
  /**
   * The total count of selected.
   */
  selectedCount: _propTypes["default"].number,
  /**
   * If true, the selectedCount will show.
   */
  selectionVisible: _propTypes["default"].bool,
  /**
   * If true, the total will show.
   */
  totalVisible: _propTypes["default"].bool,
  /**
   * If false, the pageSize choice box will not show.
   */
  pageSizeVisible: _propTypes["default"].bool,
  /**
   * Use this property to set page size right icon.
   */
  pageSizeRightIconCls: _propTypes["default"].string,
  /**
   * Use this property to set prev button icon.
   */
  prevIconCls: _propTypes["default"].string,
  /**
   * Use this property to set next button icon.
   */
  nextIconCls: _propTypes["default"].string,
  selectionRenderer: _propTypes["default"].func,
  totalRenderer: _propTypes["default"].func,
  parentEl: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  onPageChange: _propTypes["default"].func,
  onPageSizeChange: _propTypes["default"].func
};
BriefPagination.defaultProps = {
  total: 0,
  page: 0,
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  pageSizeValueField: 'value',
  pageSizeDisplayField: 'text',
  selectedCount: 0,
  selectionVisible: false,
  totalVisible: true,
  pageSizeVisible: true,
  pageSizeRightIconCls: 'fas fa-angle-down',
  prevIconCls: 'fas fa-angle-left',
  nextIconCls: 'fas fa-angle-right'
};
var _default = BriefPagination;
exports["default"] = _default;