"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Dropdown = _interopRequireDefault(require("../Dropdown"));
var _ButtonRadioGroup = _interopRequireDefault(require("../ButtonRadioGroup"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "style", "triggerClassName", "triggerStyle", "popupClassName", "popupStyle", "theme", "popupTheme", "activatedTheme", "idField", "valueField", "displayField", "descriptionField", "data", "renderer", "onItemClick"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ButtonRadioSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ButtonRadioSelect, _Component);
  var _super = _createSuper(ButtonRadioSelect);
  function ButtonRadioSelect(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ButtonRadioSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.openPopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.closePopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var autoClose = _this.props.autoClose;
      if (autoClose) {
        _this.closePopup();
      }
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getTriggerValue", function () {
      var _this$props = _this.props,
        placeholder = _this$props.placeholder,
        triggerRenderer = _this$props.triggerRenderer,
        renderer = _this$props.renderer,
        valueField = _this$props.valueField,
        displayField = _this$props.displayField,
        value = _this.state.value;
      if (triggerRenderer) {
        return typeof triggerRenderer === 'function' ? triggerRenderer(value) : triggerRenderer;
      }
      if (!value) {
        return placeholder;
      }
      return renderer ? renderer(value) : _Util["default"].getTextByDisplayField(value, displayField, valueField);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var _this$props2 = _this.props,
        data = _this$props2.data,
        valueField = _this$props2.valueField,
        displayField = _this$props2.displayField,
        value = _this.state.value;
      if (!value) {
        return data;
      }
      return data.filter(function (item) {
        return item && _Util["default"].getValueByValueField(item, valueField, displayField) !== _Util["default"].getValueByValueField(value, valueField, displayField);
      });
    });
    _this.dropdown = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      value: _props.value
    };
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(ButtonRadioSelect, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        triggerClassName = _this$props3.triggerClassName,
        triggerStyle = _this$props3.triggerStyle,
        popupClassName = _this$props3.popupClassName,
        popupStyle = _this$props3.popupStyle,
        theme = _this$props3.theme,
        popupTheme = _this$props3.popupTheme,
        activatedTheme = _this$props3.activatedTheme,
        idField = _this$props3.idField,
        valueField = _this$props3.valueField,
        displayField = _this$props3.displayField,
        descriptionField = _this$props3.descriptionField,
        data = _this$props3.data,
        renderer = _this$props3.renderer,
        onItemClick = _this$props3.onItemClick,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props3, _excluded),
        value = this.state.value;
      return /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        className: (0, _classnames["default"])('button-radio-select', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        triggerClassName: (0, _classnames["default"])('button-radio-select-trigger', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName)),
        triggerStyle: triggerStyle,
        popupClassName: (0, _classnames["default"])('button-radio-select-popup', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        popupStyle: popupStyle,
        theme: theme,
        activatedTheme: activatedTheme,
        popupTheme: popupTheme,
        position: _Dropdown["default"].Position.RIGHT,
        autoPopupWidth: false,
        triggerValue: this.getTriggerValue()
      }), /*#__PURE__*/_react["default"].createElement(_ButtonRadioGroup["default"], {
        theme: theme,
        activatedTheme: theme,
        data: this.filterData(),
        value: value,
        idField: idField,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: onItemClick,
        onChange: this.handleChange
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return ButtonRadioSelect;
}(_react.Component);
(0, _defineProperty2["default"])(ButtonRadioSelect, "Theme", _Theme["default"]);
ButtonRadioSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The ButtonCheckbox theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The CSS class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * Override the styles of the trigger element.
   */
  triggerStyle: _propTypes["default"].object,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The ButtonCheckbox theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The ButtonCheckbox activated theme.
   */
  activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The hidden input name for form submit.
   */
  name: _propTypes["default"].string,
  /**
   * Data for ButtonRadioGroup.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    className: _propTypes["default"].string,
    style: _propTypes["default"].object,
    label: _propTypes["default"].any,
    value: _propTypes["default"].any,
    disabled: _propTypes["default"].bool
  })).isRequired,
  /**
   * Set one of the button activation.
   */
  value: _propTypes["default"].any,
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  triggerRenderer: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
  rightIconCls: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is open.
   */
  onOpenPopup: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is close.
   */
  onClosePopup: _propTypes["default"].func,
  onItemClick: _propTypes["default"].func,
  onChange: _propTypes["default"].func
};
ButtonRadioSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  activatedTheme: _Theme["default"].PRIMARY,
  data: [],
  placeholder: 'Please select ...',
  disabled: false,
  tipPosition: _Position["default"].BOTTOM,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: true
};
var _default = ButtonRadioSelect;
exports["default"] = _default;