"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Checkbox = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Checkbox, _Component);
  var _super = _createSuper(Checkbox);
  function Checkbox(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Checkbox);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clickHandler", function (e) {
      var _this$props$beforeCha, _this$props;
      if (((_this$props$beforeCha = (_this$props = _this.props).beforeChange) === null || _this$props$beforeCha === void 0 ? void 0 : _this$props$beforeCha.call(_this$props)) === false) {
        return;
      }
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        onClick = _this$props2.onClick;
      if (disabled) {
        return;
      }
      onClick && onClick(e);
      var checked = !_this.state.checked;
      _this.setState({
        checked: checked
      }, function () {
        var _this$props3 = _this.props,
          onChange = _this$props3.onChange,
          onCheck = _this$props3.onCheck,
          onUncheck = _this$props3.onUncheck;
        onChange && onChange(checked);
        if (checked) {
          onCheck && onCheck(e);
        } else {
          onUncheck && onUncheck(e);
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "mouseDownHandler", function (e) {
      if (_this.props.disabled) {
        return;
      }
      _this.checkboxIconInstance && _this.checkboxIconInstance.startRipple(e);
      _this.clickHandler();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "mouseUpHandler", function () {
      if (_this.props.disabled) {
        return;
      }
      _this.checkboxIconInstance && _this.checkboxIconInstance.endRipple();
    });
    _this.checkboxIcon = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      checked: !!props.checked
    };
    return _this;
  }
  (0, _createClass2["default"])(Checkbox, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkboxIconInstance = this.checkboxIcon && this.checkboxIcon.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props4 = this.props,
        className = _this$props4.className,
        style = _this$props4.style,
        theme = _this$props4.theme,
        name = _this$props4.name,
        label = _this$props4.label,
        value = _this$props4.value,
        disabled = _this$props4.disabled,
        disableTouchRipple = _this$props4.disableTouchRipple,
        indeterminate = _this$props4.indeterminate,
        uncheckedIconCls = _this$props4.uncheckedIconCls,
        checkedIconCls = _this$props4.checkedIconCls,
        indeterminateIconCls = _this$props4.indeterminateIconCls,
        tip = _this$props4.tip,
        tipPosition = _this$props4.tipPosition,
        checked = this.state.checked;
      return /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        position: tipPosition
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('checkbox', (_classNames = {
          activated: checked,
          indeterminated: !checked && indeterminate
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled
      }, name ? /*#__PURE__*/_react["default"].createElement("input", {
        className: "hidden-checkbox",
        type: "checkbox",
        name: name,
        value: value,
        checked: checked,
        onChange: function onChange() {}
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "checkbox-icon-wrapper",
        onClick: this.clickHandler
      }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        ref: this.checkboxIcon,
        className: "checkbox-bg-icon",
        iconCls: uncheckedIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "checkbox-indeterminate-icon",
        iconCls: indeterminateIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "checkbox-icon",
        iconCls: checkedIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      })), label ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "checkbox-label",
        onMouseDown: this.mouseDownHandler,
        onMouseUp: this.mouseUpHandler,
        onMouseLeave: this.mouseUpHandler
      }, label) : null));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        checked: _ComponentUtil["default"].getDerivedState(props, state, 'checked')
      };
    }
  }]);
  return Checkbox;
}(_react.Component);
(0, _defineProperty2["default"])(Checkbox, "Theme", _Theme["default"]);
Checkbox.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The Checkbox theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The name of the checkbox.
   */
  name: _propTypes["default"].string,
  /**
   * Label for checkbox.
   */
  label: _propTypes["default"].any,
  /**
   * Value for checkbox.
   */
  value: _propTypes["default"].any,
  /**
   * If true,the checkbox will be checked.
   */
  checked: _propTypes["default"].bool,
  indeterminate: _propTypes["default"].bool,
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,
  indeterminateIconCls: _propTypes["default"].string,
  /**
   * If true, the checkbox will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the element's ripple effect will be disabled.
   */
  disableTouchRipple: _propTypes["default"].bool,
  tip: _propTypes["default"].any,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * Callback function fired when the checkbox status change.
   */
  onChange: _propTypes["default"].func,
  beforeChange: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onCheck: _propTypes["default"].func,
  onUncheck: _propTypes["default"].func
};
Checkbox.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  value: '',
  checked: false,
  indeterminate: false,
  uncheckedIconCls: 'far fa-square',
  checkedIconCls: 'fas fa-check-square',
  indeterminateIconCls: 'fas fa-minus-square',
  disabled: false,
  disableTouchRipple: false,
  tipPosition: _Position["default"].BOTTOM
};
var _default = Checkbox;
exports["default"] = _default;