"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CheckboxGroup = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CheckboxGroup, _Component);
  var _super = _createSuper(CheckboxGroup);
  function CheckboxGroup(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CheckboxGroup);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (item) {
      var _this$props = _this.props,
        valueField = _this$props.valueField,
        labelField = _this$props.labelField;
      var value = (0, _cloneDeep["default"])(_this.state.value);
      if (!value || !(0, _isArray["default"])(value)) {
        value = [item];
      } else {
        var index = value.findIndex(function (v) {
          return _Util["default"].getValueByValueField(v, valueField, labelField) === _Util["default"].getValueByValueField(item, valueField, labelField);
        });
        if (index > -1) {
          value.splice(index, 1);
        } else {
          value.push(item);
        }
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props$onChange, _this$props2;
        return !_this.props.disabled && ((_this$props$onChange = (_this$props2 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props2, value));
      });
    });
    _this.state = {
      value: props.value
    };
    return _this;
  }
  (0, _createClass2["default"])(CheckboxGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var data = this.props.data;
      if (!data) {
        return null;
      }
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        theme = _this$props3.theme,
        name = _this$props3.name,
        disabled = _this$props3.disabled,
        idField = _this$props3.idField,
        valueField = _this$props3.valueField,
        labelField = _this$props3.labelField,
        uncheckedIconCls = _this$props3.uncheckedIconCls,
        checkedIconCls = _this$props3.checkedIconCls,
        indeterminateIconCls = _this$props3.indeterminateIconCls,
        _onCheck = _this$props3.onCheck,
        _onUncheck = _this$props3.onUncheck,
        value = this.state.value;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('checkbox-group', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, data && data.map(function (item, index) {
        var itemValue = _Util["default"].getValueByValueField(item, valueField, labelField);
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          key: item && idField in item ? item[idField] : index,
          className: item.className ? item.className : '',
          style: item.style,
          theme: item.theme || theme,
          uncheckedIconCls: item.uncheckedIconCls || uncheckedIconCls,
          checkedIconCls: item.checkedIconCls || checkedIconCls,
          indeterminateIconCls: item.indeterminateIconCls || indeterminateIconCls,
          name: name,
          label: _Util["default"].getTextByDisplayField(item, labelField, valueField),
          value: itemValue,
          disabled: disabled || item.disabled,
          checked: (value === null || value === void 0 ? void 0 : value.findIndex(function (v) {
            return _Util["default"].getValueByValueField(v, valueField, labelField) === itemValue;
          })) > -1,
          tip: item.tip,
          tipPosition: item.tipPosition,
          onChange: function onChange() {
            return _this2.handleChange(item);
          },
          onCheck: function onCheck(e) {
            return _onCheck === null || _onCheck === void 0 ? void 0 : _onCheck(item, e);
          },
          onUncheck: function onUncheck(e) {
            return _onUncheck === null || _onUncheck === void 0 ? void 0 : _onUncheck(item, e);
          }
        });
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return CheckboxGroup;
}(_react.Component);
(0, _defineProperty2["default"])(CheckboxGroup, "Theme", _Theme["default"]);
CheckboxGroup.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  /**
   * The CheckboxGroup theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  name: _propTypes["default"].string,
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    className: _propTypes["default"].string,
    style: _propTypes["default"].object,
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    label: _propTypes["default"].any,
    value: _propTypes["default"].any,
    disabled: _propTypes["default"].bool,
    tip: _propTypes["default"].any,
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"]))
  })).isRequired,
  value: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  idField: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  valueField: _propTypes["default"].string,
  labelField: _propTypes["default"].string,
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,
  indeterminateIconCls: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  onCheck: _propTypes["default"].func,
  onUncheck: _propTypes["default"].func
};
CheckboxGroup.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  disabled: false,
  idField: 'id',
  valueField: 'value',
  labelField: 'label'
};
var _default = CheckboxGroup;
exports["default"] = _default;