"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CircularLoading = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CircularLoading, _Component);
  var _super = _createSuper(CircularLoading);
  function CircularLoading(props) {
    (0, _classCallCheck2["default"])(this, CircularLoading);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    return _super.call.apply(_super, [this, props].concat(restArgs));
  }
  (0, _createClass2["default"])(CircularLoading, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        size = _this$props.size,
        theme = _this$props.theme,
        type = _this$props.type,
        weight = _this$props.weight,
        border = {
          borderWidth: weight
        };
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('circular-loading', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "circular-loading-size-".concat(size), size), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        type: type,
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "spinner"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(theme, " circle left border-").concat(type)
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(type ? type : 'solid'),
        style: border
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "gap"
      }, /*#__PURE__*/_react["default"].createElement("div", null)), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(theme, " circle right border-").concat(type)
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(type ? type : 'solid'),
        style: border
      }))));
    }
  }]);
  return CircularLoading;
}(_react.Component);
(0, _defineProperty2["default"])(CircularLoading, "Size", {
  DEFAULT: '',
  SMALL: 'small',
  LARGE: 'large'
});
(0, _defineProperty2["default"])(CircularLoading, "Theme", _Theme["default"]);
CircularLoading.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Set the size of loading,can use small or large.
   */
  size: _propTypes["default"].oneOf(_Util["default"].enumerateValue(CircularLoading.Size)),
  /**
   * Set the theme of loading,can use highlight,success,error,warning.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * Set the CircularLoading border-width.
   */
  weight: _propTypes["default"].number,
  /**
   * Set the border style of CircularLoading,can use solid,dotted.
   */
  type: _propTypes["default"].string
};
CircularLoading.defaultProps = {
  size: CircularLoading.Size.DEFAULT,
  theme: '',
  width: '1',
  type: 'solid'
};
var _default = CircularLoading;
exports["default"] = _default;