"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _PositionPop = _interopRequireDefault(require("../_PositionPop"));
var _Paper = _interopRequireDefault(require("../Paper"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _contains = _interopRequireDefault(require("dom-helpers/contains"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _PopManagement = _interopRequireDefault(require("../_vendors/PopManagement"));
var _excluded = ["className", "depth", "isBlurClose", "isEscClose", "onRender", "onRequestClose", "drawerVisibleHandler"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Drawer = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Drawer, _Component);
  var _super = _createSuper(Drawer);
  function Drawer(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Drawer);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "drawerVisibleHandler", function (el, drawerEl, currentVisible, isBlurClose) {
      // el is missing
      if (el && !(0, _contains["default"])(document, el)) {
        return currentVisible;
      }
      if (drawerEl && el && (0, _contains["default"])(drawerEl, el)) {
        return currentVisible;
      }
      return isBlurClose ? false : currentVisible;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClose", function (e) {
      var _this$drawerContent;
      var _this$props = _this.props,
        visible = _this$props.visible,
        isBlurClose = _this$props.isBlurClose,
        drawerVisibleHandler = _this$props.drawerVisibleHandler;
      if (!visible) {
        return;
      }
      var drawerEl = (0, _reactDom.findDOMNode)((_this$drawerContent = _this.drawerContent) === null || _this$drawerContent === void 0 ? void 0 : _this$drawerContent.current);
      var currVisible;
      if (drawerVisibleHandler) {
        currVisible = drawerVisibleHandler(e.target, drawerEl, visible, isBlurClose);
      } else if (!_Dom["default"].isParent(e.target)) {
        currVisible = _this.drawerVisibleHandler(e.target, drawerEl, visible, isBlurClose);
      }
      if (currVisible === false) {
        var _this$props$onRequest, _this$props2;
        (_this$props$onRequest = (_this$props2 = _this.props).onRequestClose) === null || _this$props$onRequest === void 0 ? void 0 : _this$props$onRequest.call(_this$props2, e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props$onRender, _this$props3;
      _PopManagement["default"].push((0, _assertThisInitialized2["default"])(_this), {
        shouldLockBody: _this.props.showModal
      });
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      (_this$props$onRender = (_this$props3 = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call.apply(_this$props$onRender, [_this$props3].concat(args));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function () {
      var _this$props$onDestroy, _this$props4;
      _PopManagement["default"].pop((0, _assertThisInitialized2["default"])(_this));
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      (_this$props$onDestroy = (_this$props4 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call.apply(_this$props$onDestroy, [_this$props4].concat(args));
    });
    _this.drawerContent = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }
  (0, _createClass2["default"])(Drawer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (!prevProps.visible && this.props.visible) {
        _Event["default"].addEvent(document, 'click', this.handleClose);
      } else if (prevProps.visible && !this.props.visible) {
        _Event["default"].removeEvent(document, 'click', this.handleClose);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'click', this.handleClose);
      _PopManagement["default"].pop(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        className = _this$props5.className,
        depth = _this$props5.depth,
        isBlurClose = _this$props5.isBlurClose,
        isEscClose = _this$props5.isEscClose,
        onRender = _this$props5.onRender,
        onRequestClose = _this$props5.onRequestClose,
        drawerVisibleHandler = _this$props5.drawerVisibleHandler,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props5, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('drawer', (0, _defineProperty2["default"])({}, className, className)),
        container: /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
          ref: this.drawerContent
        }),
        depth: depth,
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }));
    }
  }]);
  return Drawer;
}(_react.Component);
(0, _defineProperty2["default"])(Drawer, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(Drawer, "Position", _Position["default"]);
Drawer.propTypes = {
  /**
   * The css class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The css class name of the modal.
   */
  modalClassName: _propTypes["default"].string,
  /**
   * The styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * The drawer alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  /**
   * If true,the element will disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,drawer box will display.
   */
  visible: _propTypes["default"].bool,
  /**
   * If true,the pop-up box will be displayed in the mask layer, or the pop-up box will appear below the element.
   */
  showModal: _propTypes["default"].bool,
  /**
   * If true,when press down mouse the pop-up box will closed.
   */
  isBlurClose: _propTypes["default"].bool,
  isEscClose: _propTypes["default"].bool,
  /**
   * The function of drawer render.
   */
  onRender: _propTypes["default"].func,
  onDestroy: _propTypes["default"].func,
  drawerVisibleHandler: _propTypes["default"].func,
  /**
   * The function that trigger when click submit.
   */
  onRequestClose: _propTypes["default"].func
};
Drawer.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].LEFT,
  depth: 2,
  disabled: false,
  visible: false,
  showModal: true,
  isBlurClose: true,
  isEscClose: true
};
var _default = Drawer;
exports["default"] = _default;