"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _List = _interopRequireDefault(require("../List"));
var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));
var _GroupList = _interopRequireDefault(require("../GroupList"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var EditableSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(EditableSelect, _Component);
  var _super = _createSuper(EditableSelect);
  function EditableSelect(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, EditableSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChangeValue", function (value) {
      var _this$props = _this.props,
        useFilter = _this$props.useFilter,
        onChange = _this$props.onChange;
      _this.setState({
        value: value,
        filter: useFilter ? value : _this.state.filter,
        listValue: ''
      }, function () {
        var _this$popup, _this$popup$current, _this$popup$current$r;
        onChange && onChange(value);
        (_this$popup = _this.popup) === null || _this$popup === void 0 ? void 0 : (_this$popup$current = _this$popup.current) === null || _this$popup$current === void 0 ? void 0 : (_this$popup$current$r = _this$popup$current.resetPosition) === null || _this$popup$current$r === void 0 ? void 0 : _this$popup$current$r.call(_this$popup$current);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "showPopup", function () {
      _this.setState({
        popupVisible: true
      }, function () {
        _this.props.onTriggerClick && _this.props.onTriggerClick(_this.state.popupVisible);
        _this.props.onFocus && _this.props.onFocus();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.setState({
        popupVisible: false
      }, function () {
        var _this$trigger;
        (_this$trigger = _this.trigger) === null || _this$trigger === void 0 ? void 0 : _this$trigger.current.blur();
        _this.props.onTriggerClick && _this.props.onTriggerClick(_this.state.popupVisible);
        _this.props.onPopupClosed && _this.props.onPopupClosed();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerHandler", function (el, triggerEl, popupEl, currentVisible, isBlurClose) {
      if (!triggerEl) {
        return true;
      }
      while (el) {
        if (el === popupEl) {
          return currentVisible;
        } else if (el === triggerEl) {
          return true;
        }
        el = el.parentNode;
      }
      return isBlurClose ? false : currentVisible;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var _this$props2 = _this.props,
        data = _this$props2.data,
        filterCallback = _this$props2.filterCallback,
        filter = _this.state.filter;
      if (!filter) {
        return data;
      }
      if (filterCallback) {
        return filterCallback(filter, data);
      }
      var _this$props3 = _this.props,
        displayField = _this$props3.displayField,
        isGrouped = _this$props3.isGrouped,
        filterFunc = function filterFunc(originData) {
          return originData.filter(function (item) {
            return (0, _typeof2["default"])(item) === 'object' && !!item[displayField] ? item[displayField].toString().toUpperCase().includes(filter.toUpperCase()) : item.toString().toUpperCase().includes(filter.toUpperCase());
          });
        };
      if (isGrouped) {
        var result = Object.assign(data);
        for (var i = 0, len = result.length; i < len; i++) {
          var group = result[i];
          group.children = filterFunc(group.children);
          if (group.children.length < 1) {
            result.splice(i, 1);
            i--;
          }
        }
      }
      return filterFunc(data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      var isAbove = _DropdownCalculation["default"].isAbove(_this.wrapperEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var _this$props4 = _this.props,
        valueField = _this$props4.valueField,
        autoClose = _this$props4.autoClose,
        renderer = _this$props4.renderer,
        itemValue = renderer ? renderer(value) : (0, _typeof2["default"])(value) === 'object' ? value[valueField] : value;
      if (autoClose) {
        _this.closePopup();
      }
      _this.setState({
        value: itemValue,
        filter: itemValue,
        listValue: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(itemValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "textFieldBlur", function (e, value) {
      var onTextFieldBlur = _this.props.onTextFieldBlur;
      onTextFieldBlur === null || onTextFieldBlur === void 0 ? void 0 : onTextFieldBlur(value);
    });
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.popup = /*#__PURE__*/(0, _react.createRef)();
    _this.popupEl = null;
    _this.state = {
      value: props.value,
      listValue: props.value,
      filter: props.filterInitValue,
      popupVisible: false,
      isAbove: false
    };
    return _this;
  }
  (0, _createClass2["default"])(EditableSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$wrapper, _this$popup2, _this$trigger2;
      this.wrapperEl = (_this$wrapper = this.wrapper) === null || _this$wrapper === void 0 ? void 0 : _this$wrapper.current;
      this.popupEl = (_this$popup2 = this.popup) === null || _this$popup2 === void 0 ? void 0 : _this$popup2.current;
      this.triggerEl = (0, _reactDom.findDOMNode)((_this$trigger2 = this.trigger) === null || _this$trigger2 === void 0 ? void 0 : _this$trigger2.current);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (this.state.popupVisible) {
        var _this$popup3, _this$popup3$current, _this$popup3$current$;
        (_this$popup3 = this.popup) === null || _this$popup3 === void 0 ? void 0 : (_this$popup3$current = _this$popup3.current) === null || _this$popup3$current === void 0 ? void 0 : (_this$popup3$current$ = _this$popup3$current.resetPosition) === null || _this$popup3$current$ === void 0 ? void 0 : _this$popup3$current$.call(_this$popup3$current);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        className = _this$props5.className,
        popupClassName = _this$props5.popupClassName,
        style = _this$props5.style,
        popupStyle = _this$props5.popupStyle,
        name = _this$props5.name,
        placeholder = _this$props5.placeholder,
        disabled = _this$props5.disabled,
        valueField = _this$props5.valueField,
        displayField = _this$props5.displayField,
        clearButtonIconCls = _this$props5.clearButtonIconCls,
        clearButtonVisible = _this$props5.clearButtonVisible,
        descriptionField = _this$props5.descriptionField,
        position = _this$props5.position,
        rightIconCls = _this$props5.rightIconCls,
        resetPopPositionWait = _this$props5.resetPopPositionWait,
        triggerTheme = _this$props5.triggerTheme,
        isGrouped = _this$props5.isGrouped,
        onItemClick = _this$props5.onItemClick,
        renderer = _this$props5.renderer,
        noMatchedPopupVisible = _this$props5.noMatchedPopupVisible,
        noMatchedMsg = _this$props5.noMatchedMsg,
        useDynamicRenderList = _this$props5.useDynamicRenderList,
        onMouseOver = _this$props5.onMouseOver,
        onMouseOut = _this$props5.onMouseOut,
        parentEl = _this$props5.parentEl,
        _this$state = this.state,
        value = _this$state.value,
        listValue = _this$state.listValue,
        popupVisible = _this$state.popupVisible,
        isAbove = _this$state.isAbove,
        isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove,
        listData = this.filterData();
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('editable-select', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, name ? /*#__PURE__*/_react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: value
      }) : null, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: (0, _classnames["default"])('editable-select-trigger', isAboveFinally ? 'above' : 'blow', {
          activated: popupVisible && ((listData === null || listData === void 0 ? void 0 : listData.length) > 0 || noMatchedPopupVisible),
          empty: !value
        }),
        value: value,
        rightIconCls: "".concat(rightIconCls, " editable-select-trigger-icon"),
        placeholder: placeholder,
        disabled: disabled,
        theme: triggerTheme,
        onMouseOver: onMouseOver,
        onMouseOut: onMouseOut,
        clearButtonVisible: clearButtonVisible,
        clearButtonIconCls: clearButtonIconCls,
        onChange: this.handleChangeValue,
        onFocus: this.showPopup,
        onBlur: this.textFieldBlur
      }), !noMatchedPopupVisible && (listData === null || listData === void 0 ? void 0 : listData.length) < 1 ? null : /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        className: (0, _classnames["default"])('editable-select-popup', isAboveFinally ? 'above' : 'blow', (0, _defineProperty2["default"])({
          'no-matched-popup': (listData === null || listData === void 0 ? void 0 : listData.length) < 1
        }, popupClassName, popupClassName)),
        style: Object.assign({
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        }, popupStyle),
        visible: popupVisible,
        triggerEl: this.triggerEl,
        triggerHandler: this.triggerHandler,
        parentEl: parentEl,
        ref: this.popup,
        hasTriangle: false,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        resetPositionWait: resetPopPositionWait,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, (listData === null || listData === void 0 ? void 0 : listData.length) < 1 ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "no-matched"
      }, noMatchedMsg ? noMatchedMsg : /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-exclamation-triangle no-matched-icon"
      }), "No matched value.")) : isGrouped ? /*#__PURE__*/_react["default"].createElement(_GroupList["default"], {
        className: "editable-select-list",
        data: listData,
        value: listValue,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: onItemClick,
        onChange: this.handleChange
      }) : useDynamicRenderList ? /*#__PURE__*/_react["default"].createElement(_DynamicRenderList["default"], {
        className: "editable-select-list",
        data: listData,
        value: listValue,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: onItemClick,
        onChange: this.handleChange
      }) : /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: "editable-select-list",
        data: listData,
        valueField: valueField,
        value: listValue,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: onItemClick,
        onChange: this.handleChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return EditableSelect;
}(_react.Component);
(0, _defineProperty2["default"])(EditableSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(EditableSelect, "Position", _Position["default"]);
EditableSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  rightIconCls: _propTypes["default"].string,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the editableSelect.
   */
  name: _propTypes["default"].string,
  /**
   * The value of the editableSelect.
   */
  value: _propTypes["default"].any,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * The placeholder of the editableSelect.
   */
  placeholder: _propTypes["default"].string,
  /**
   * The options data.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]).isRequired,
  /**
   * The invalid message of editableSelect.
   */
  invalidMsg: _propTypes["default"].string,
  /**
   * If true,the editableSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The visiblity of no matched popup.
   */
  noMatchedPopupVisible: _propTypes["default"].bool,
  /**
   * If true,clearButton will display when the textField is not empty.
   */
  clearButtonVisible: _propTypes["default"].bool,
  clearButtonIconCls: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * The message of the editableSelect.
   */
  infoMsg: _propTypes["default"].string,
  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,
  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * If true,the drop-down box will have search input.
   */
  useFilter: _propTypes["default"].bool,
  /**
   * The theme of editableSelect.Can be primary,highlight,success,warning,error.
   */
  triggerTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * If true,the drop-down box will be have group selection.
   */
  isGrouped: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  noMatchedMsg: _propTypes["default"].string,
  useDynamicRenderList: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when filter changed.
   */
  filterCallback: _propTypes["default"].func,
  /**
   * Callback function  fired when filter is blur.
   */
  onTextFieldBlur: _propTypes["default"].func,
  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onTriggerClick: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onPopupClosed: _propTypes["default"].func
};
EditableSelect.defaultProps = {
  name: '',
  value: '',
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  data: [],
  invalidMsg: '',
  disabled: false,
  displayField: 'text',
  descriptionField: 'desc',
  infoMsg: '',
  autoClose: true,
  useFilter: false,
  useDynamicRenderList: false,
  noMatchedPopupVisible: true,
  clearButtonVisible: true,
  clearButtonIconCls: 'fas fa-times-circle',
  triggerTheme: _Theme["default"].DEFAULT,
  isGrouped: false,
  resetPopPositionWait: 250
};
var _default = EditableSelect;
exports["default"] = _default;