"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _BaseButton = _interopRequireDefault(require("../_BaseButton"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["className"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var FlatButton = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(FlatButton, _Component);
  var _super = _createSuper(FlatButton);
  function FlatButton(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, FlatButton);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.buttonInstance && _this.buttonInstance.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.buttonInstance && _this.buttonInstance.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.buttonInstance && _this.buttonInstance.triggerRipple(e, props);
    });
    _this.button = /*#__PURE__*/(0, _react.createRef)();
    _this.buttonInstance = null;
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(FlatButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.buttonInstance = this.button && this.button.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_BaseButton["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.button,
        className: (0, _classnames["default"])('flat-button', (0, _defineProperty2["default"])({}, className, className))
      }));
    }
  }]);
  return FlatButton;
}(_react.Component);
(0, _defineProperty2["default"])(FlatButton, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(FlatButton, "TipPosition", _Position["default"]);
FlatButton.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The button theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * If true,the button will have rounded corners.
   */
  isRounded: _propTypes["default"].bool,
  /**
   * If true,the button will be round.
   */
  isCircular: _propTypes["default"].bool,
  /**
   * The title of the button.
   */
  title: _propTypes["default"].string,
  /**
   * The text of the button.
   */
  value: _propTypes["default"].any,
  /**
   * The type of button.Can be reset,submit or button.
   */
  type: _propTypes["default"].string,
  /**
   * Disables the button if set to true.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the button will be have loading effect.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * If true,the element's ripple effect will be disabled.
   */
  disableTouchRipple: _propTypes["default"].bool,
  /**
   * Use this property to display an icon.It will display on the left.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Use this property to display an icon.It will display on the right.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * If true,the ripple effect will be display centered.
   */
  rippleDisplayCenter: _propTypes["default"].bool,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TipProvider["default"].Position)),
  /**
   * You can create a complicated renderer callback instead of value prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onClick: _propTypes["default"].func
};
FlatButton.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isRounded: false,
  isCircular: false,
  value: '',
  disabled: false,
  type: 'button',
  isLoading: false,
  disableTouchRipple: false,
  rippleDisplayCenter: false,
  tipPosition: _TipProvider["default"].Position.BOTTOM
};
var _default = FlatButton;
exports["default"] = _default;