"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading/CircularLoading"));
var _TouchRipple = _interopRequireDefault(require("../TouchRipple/TouchRipple"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["className", "theme", "iconCls", "disabled", "isLoading", "tip", "tipPosition", "disableTouchRipple", "parentEl"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var IconAnchor = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(IconAnchor, _Component);
  var _super = _createSuper(IconAnchor);
  function IconAnchor(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, IconAnchor);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      !_this.props.disableTouchRipple && _this.touchRipple && _this.touchRipple.current && _this.touchRipple.current.addRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      !_this.props.disableTouchRipple && _this.touchRipple && _this.touchRipple.current && _this.touchRipple.current.removeRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.startRipple(e, props);
      setTimeout(function () {
        _this.endRipple();
      }, 250);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        isLoading = _this$props.isLoading,
        onClick = _this$props.onClick;
      !disabled && !isLoading && onClick && onClick(e);
    });
    _this.touchRipple = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(IconAnchor, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        className = _this$props2.className,
        theme = _this$props2.theme,
        iconCls = _this$props2.iconCls,
        disabled = _this$props2.disabled,
        isLoading = _this$props2.isLoading,
        tip = _this$props2.tip,
        tipPosition = _this$props2.tipPosition,
        disableTouchRipple = _this$props2.disableTouchRipple,
        parentEl = _this$props2.parentEl,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        parentEl: parentEl,
        position: tipPosition
      }, /*#__PURE__*/_react["default"].createElement("a", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('icon-anchor', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        disabled: disabled || isLoading,
        onClick: this.handleClick
      }), isLoading ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
        size: "small"
      }) : iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "icon-anchor-icon ".concat(iconCls),
        "aria-hidden": "true"
      }) : null, disableTouchRipple ? null : /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], {
        ref: this.touchRipple,
        className: disabled || isLoading ? 'hidden' : '',
        displayCenter: true
      })));
    }
  }]);
  return IconAnchor;
}(_react.Component);
(0, _defineProperty2["default"])(IconAnchor, "Theme", _Theme["default"]);
IconAnchor.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The button theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * Disables the button if set to true.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the button will be have loading effect.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * The icon within the IconAnchor is a Font Awesome component.This property is the className of the icon.
   */
  iconCls: _propTypes["default"].string.isRequired,
  /**
   * The URL to link to when the button is clicked.
   */
  href: _propTypes["default"].string,
  /**
   * How to open the linked document.The value can be _blank,_self,_parent or _top.
   */
  target: _propTypes["default"].string,
  alt: _propTypes["default"].string,
  disableTouchRipple: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TipProvider["default"].Position)),
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onClick: _propTypes["default"].func
};
IconAnchor.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  disabled: false,
  isLoading: false,
  href: 'javascript:void(0)',
  target: '_blank',
  disableTouchRipple: false,
  tipPosition: _TipProvider["default"].Position.BOTTOM
};
var _default = IconAnchor;
exports["default"] = _default;