"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ListItem = _interopRequireDefault(require("../_ListItem"));
var _Tip = _interopRequireDefault(require("../Tip"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _ListSeparator = _interopRequireDefault(require("../_statics/ListSeparator"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["children", "className", "style", "data", "disabled", "activatedTheme", "selectTheme", "selectMode", "value", "idField", "valueField", "displayField", "descriptionField", "itemDisabled", "disableTouchRipple", "autoSelect", "isLoading", "itemHeight", "parentEl", "radioUncheckedIconCls", "radioCheckedIconCls", "checkboxUncheckedIconCls", "checkboxCheckedIconCls", "checkboxIndeterminateIconCls", "indeterminateCallback", "renderer", "onItemClick", "onItemSelect", "onItemDeselect"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var List = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(List, _Component);
  var _super = _createSuper(List);
  function List(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, List);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "adjustScroll", function () {
      var data = _this.props.data;
      var value = _this.state.value;
      var index = data.indexOf(value);
      if (index < 0) {
        return;
      }
      var listHeight = _this.listEl.clientHeight;
      var listScrollTop = _this.listEl.scrollTop;
      var itemEl = _this.listEl.childNodes[index];
      var itemHeight = itemEl.clientHeight;
      var itemTop = itemEl.offsetTop;
      if (itemTop < listScrollTop) {
        _this.listEl.scrollTop = itemTop;
      } else if (itemTop + itemHeight > listScrollTop + listHeight) {
        _this.listEl.scrollTop = itemTop + itemHeight - listHeight;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemSelect", function (item, index) {
      var selectMode = _this.props.selectMode;
      var value = _this.state.value;
      var state = {};
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var result = value ? value.slice() : value;
        if (!result || !(0, _isArray["default"])(result)) {
          result = [];
        }
        result.push(item);
        state.value = result;
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        state.value = item;
      }
      _this.setState(state, function () {
        var _this$props$onItemSel, _this$props, _this$props$onChange, _this$props2;
        (_this$props$onItemSel = (_this$props = _this.props).onItemSelect) === null || _this$props$onItemSel === void 0 ? void 0 : _this$props$onItemSel.call(_this$props, item, index);
        (_this$props$onChange = (_this$props2 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props2, state.value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemDeselect", function (item, index) {
      var selectMode = _this.props.selectMode;
      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var _this$props3 = _this.props,
        valueField = _this$props3.valueField,
        displayField = _this$props3.displayField;
      var stateValue = _this.state.value;
      var value = stateValue ? stateValue.slice() : stateValue;
      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        value = value.filter(function (valueItem) {
          return _Util["default"].getValueByValueField(valueItem, valueField, displayField) !== _Util["default"].getValueByValueField(item, valueField, displayField);
        });
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props$onItemDes, _this$props4, _this$props$onChange2, _this$props5;
        (_this$props$onItemDes = (_this$props4 = _this.props).onItemDeselect) === null || _this$props$onItemDes === void 0 ? void 0 : _this$props$onItemDes.call(_this$props4, item, index);
        (_this$props$onChange2 = (_this$props5 = _this.props).onChange) === null || _this$props$onChange2 === void 0 ? void 0 : _this$props$onChange2.call(_this$props5, value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isListDisabled", function (listDisabled) {
      var data = _this.props.data,
        value = _this.state.value;
      return typeof listDisabled === 'function' ? listDisabled(value, data) : listDisabled;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemDisabled", function (listItemDisabled, item, itemDisabled) {
      var data = _this.props.data;
      var value = _this.state.value;
      return listItemDisabled != null && (typeof listItemDisabled === 'function' ? listItemDisabled(item, value, data) : listItemDisabled) || itemDisabled != null && (typeof itemDisabled === 'function' ? itemDisabled(item, value, data) : itemDisabled);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderListItem", function (item, index) {
      if (!item) {
        return;
      }
      var _this$props6 = _this.props,
        theme = _this$props6.theme,
        activatedTheme = _this$props6.activatedTheme,
        itemHeight = _this$props6.itemHeight,
        valueField = _this$props6.valueField,
        displayField = _this$props6.displayField,
        descriptionField = _this$props6.descriptionField,
        disabled = _this$props6.disabled,
        itemDisabled = _this$props6.itemDisabled,
        isLoading = _this$props6.isLoading,
        renderer = _this$props6.renderer,
        autoSelect = _this$props6.autoSelect,
        disableTouchRipple = _this$props6.disableTouchRipple,
        selectTheme = _this$props6.selectTheme,
        selectMode = _this$props6.selectMode,
        parentEl = _this$props6.parentEl,
        indeterminateCallback = _this$props6.indeterminateCallback,
        radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props6.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
        onItemClick = _this$props6.onItemClick;
      var _this$state = _this.state,
        value = _this$state.value,
        focusIndex = _this$state.focusIndex;

      /**
       * Item click callback
       * @param e
       */
      var handleItemClick = function handleItemClick(e) {
        _this.setState({
          focusIndex: index
        }, function () {
          return onItemClick === null || onItemClick === void 0 ? void 0 : onItemClick(item, index, e);
        });
      };

      /**
       * Object item click callback
       * @param e
       */
      var handleObjectItemClick = function handleObjectItemClick(e) {
        var _item$onClick;
        handleItemClick(e);
        (_item$onClick = item.onClick) === null || _item$onClick === void 0 ? void 0 : _item$onClick.call(item, e);
      };
      return (0, _typeof2["default"])(item) === 'object' ? /*#__PURE__*/_react["default"].createElement(_ListItem["default"], (0, _extends2["default"])({
        key: index
      }, item, {
        index: index,
        parentEl: parentEl,
        className: (0, _classnames["default"])((0, _defineProperty2["default"])({
          focused: focusIndex === index
        }, item.className, item.className)),
        style: _objectSpread(_objectSpread({}, item.style), {}, {
          height: itemHeight
        }),
        theme: item.theme || theme,
        activatedTheme: item.activatedTheme || activatedTheme,
        selectTheme: item.selectTheme || selectTheme,
        radioUncheckedIconCls: item.radioUncheckedIconCls || radioUncheckedIconCls,
        radioCheckedIconCls: item.radioCheckedIconCls || radioCheckedIconCls,
        checkboxUncheckedIconCls: item.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
        checkboxCheckedIconCls: item.checkboxCheckedIconCls || checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: item.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
        data: item,
        checked: _Calculation["default"].isItemChecked(item, value, _this.props),
        value: _Util["default"].getValueByValueField(item, valueField, displayField),
        text: _Util["default"].getTextByDisplayField(item, displayField, valueField),
        desc: item[descriptionField] || null,
        disabled: _this.isListDisabled(disabled) || _this.isItemDisabled(itemDisabled, item, item.disabled),
        isLoading: isLoading || item.isLoading,
        selectMode: selectMode,
        renderer: renderer,
        autoSelect: autoSelect,
        disableTouchRipple: item.disableTouchRipple || disableTouchRipple,
        indeterminateCallback: indeterminateCallback,
        onClick: handleObjectItemClick,
        onSelect: function onSelect() {
          return _this.handleListItemSelect(item, index);
        },
        onDeselect: function onDeselect() {
          return _this.handleListItemDeselect(item, index);
        }
      })) : /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
        key: index,
        index: index,
        parentEl: parentEl,
        className: (0, _classnames["default"])({
          focused: focusIndex === index
        }),
        style: {
          height: itemHeight
        },
        theme: theme,
        activatedTheme: activatedTheme,
        selectTheme: selectTheme,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        data: item,
        checked: _Calculation["default"].isItemChecked(item, value, _this.props),
        value: item,
        text: item,
        disabled: _this.isListDisabled(disabled) || _this.isItemDisabled(itemDisabled, item),
        isLoading: isLoading,
        selectMode: selectMode,
        renderer: renderer,
        autoSelect: autoSelect,
        disableTouchRipple: disableTouchRipple,
        indeterminateCallback: indeterminateCallback,
        onClick: handleItemClick,
        onSelect: function onSelect() {
          return _this.handleListItemSelect(item, index);
        },
        onDeselect: function onDeselect() {
          return _this.handleListItemDeselect(item, index);
        }
      });
    });
    _this.list = /*#__PURE__*/(0, _react.createRef)();
    _this.listEl = null;
    _this.state = {
      value: _Calculation["default"].getInitValue(props),
      focusIndex: -1
    };
    return _this;
  }
  (0, _createClass2["default"])(List, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$list;
      this.listEl = (_this$list = this.list) === null || _this$list === void 0 ? void 0 : _this$list.current;
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props7 = this.props,
        children = _this$props7.children,
        className = _this$props7.className,
        style = _this$props7.style,
        data = _this$props7.data,
        disabled = _this$props7.disabled,
        activatedTheme = _this$props7.activatedTheme,
        selectTheme = _this$props7.selectTheme,
        selectMode = _this$props7.selectMode,
        value = _this$props7.value,
        idField = _this$props7.idField,
        valueField = _this$props7.valueField,
        displayField = _this$props7.displayField,
        descriptionField = _this$props7.descriptionField,
        itemDisabled = _this$props7.itemDisabled,
        disableTouchRipple = _this$props7.disableTouchRipple,
        autoSelect = _this$props7.autoSelect,
        isLoading = _this$props7.isLoading,
        itemHeight = _this$props7.itemHeight,
        parentEl = _this$props7.parentEl,
        radioUncheckedIconCls = _this$props7.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props7.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props7.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props7.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props7.checkboxIndeterminateIconCls,
        indeterminateCallback = _this$props7.indeterminateCallback,
        renderer = _this$props7.renderer,
        onItemClick = _this$props7.onItemClick,
        onItemSelect = _this$props7.onItemSelect,
        onItemDeselect = _this$props7.onItemDeselect,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props7, _excluded);
      return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        ref: this.list,
        className: (0, _classnames["default"])('list', (0, _defineProperty2["default"])({}, className, className)),
        disabled: this.isListDisabled(disabled),
        style: style
      }), data && data.map(function (item, index) {
        return item === _ListSeparator["default"] ? /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "list-separator"
        }) : _this2.renderListItem(item, index);
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return List;
}(_react.Component);
(0, _defineProperty2["default"])(List, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(List, "LIST_SEPARATOR", _ListSeparator["default"]);
(0, _defineProperty2["default"])(List, "Theme", _Theme["default"]);
List.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The theme of the list item.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme of the list item activated.
   */
  activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme of the list item select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The mode of listItem.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * Children passed into the ListItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The theme of the list button activated.
     */
    activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The list item's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The title value of the list button.
     */
    title: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list item will be disabled.
     */
    disabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true, the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * The class name of tip.
     */
    tipClassName: _propTypes["default"].string,
    /**
     * The message of tip.
     */
    tip: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
    /**
     * If true, the item will have center displayed ripple effect.
     */
    rippleDisplayCenter: _propTypes["default"].bool,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].symbol])),
  value: _propTypes["default"].any,
  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the list will be disabled.
   */
  disabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  /**
   * List item disabled callback.
   */
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  /**
   * If true,the element's ripple effect will be disabled.
   */
  disableTouchRipple: _propTypes["default"].bool,
  /**
   * If true, the list will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * Whether select when item clicked.
   */
  autoSelect: _propTypes["default"].bool,
  itemHeight: _propTypes["default"].number,
  parentEl: _propTypes["default"].object,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item touch tap.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item select.
   */
  onItemSelect: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item deselect.
   */
  onItemDeselect: _propTypes["default"].func,
  /**
   * Callback function fired when the list changed.
   */
  onChange: _propTypes["default"].func,
  indeterminateCallback: _propTypes["default"].func
};
List.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  activatedTheme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  itemDisabled: false,
  disableTouchRipple: false,
  autoSelect: true,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = List;
exports["default"] = _default;