"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _MaterialDatePickerTextField = _interopRequireDefault(require("../_MaterialDatePickerTextField"));
var _DayPicker = _interopRequireDefault(require("../_DayPicker"));
var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));
var _YearPicker = _interopRequireDefault(require("../_YearPicker"));
var _TimeList = _interopRequireDefault(require("../_TimeList"));
var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _reactDom = require("react-dom");
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialDateTimePicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialDateTimePicker, _Component);
  var _super = _createSuper(MaterialDateTimePicker);
  function MaterialDateTimePicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialDateTimePicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDatePickerChange", function (selectLevel) {
      _this.setState({
        datePickerLevel: selectLevel
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTextFieldChange", function (text) {
      var _this$props = _this.props,
        minValue = _this$props.minValue,
        maxValue = _this$props.maxValue,
        dateFormat = _this$props.dateFormat;
      if (text && text.length) {
        var flag = (0, _moment["default"])(text, dateFormat, true).isValid();
        if (flag) {
          if (minValue && (0, _moment["default"])(text).isBefore(minValue) || maxValue && (0, _moment["default"])(text).isAfter(maxValue)) {} else {
            _this.setState({
              value: (0, _moment["default"])(text, dateFormat),
              year: (0, _moment["default"])(text).format('YYYY'),
              month: (0, _moment["default"])(text).format('MM'),
              day: (0, _moment["default"])(text).format('DD'),
              hour: (0, _moment["default"])(text).format('HH'),
              minute: (0, _moment["default"])(text).format('mm'),
              second: (0, _moment["default"])(text).format('ss')
            });
          }
        }
      } else {
        _this.setState({
          value: ''
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayPickerChange", function (date) {
      var dateFormat = _this.props.dateFormat;
      _this.setState({
        value: (0, _moment["default"])(date.time, dateFormat),
        year: date.year,
        month: date.month,
        day: date.day
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthPickerChange", function (date) {
      _this.setState({
        datePickerLevel: 'day',
        year: date.year,
        month: date.month
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYearPickerChange", function (year) {
      _this.setState({
        datePickerLevel: 'month',
        year: year
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTimePickerChange", function (obj) {
      var _this$state = _this.state,
        year = _this$state.year,
        month = _this$state.month,
        day = _this$state.day;
      var timer = (0, _moment["default"])([year, +month - 1, day, obj.hour, obj.minute, obj.second]).format(_this.props.dateFormat);
      timer = (0, _moment["default"])(timer, _this.props.dateFormat);
      _this.setState({
        hour: obj.hour,
        minute: obj.minute,
        second: obj.second,
        value: timer
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChooseDateAndTime", function (value) {
      _this.setState({
        datePickerLevel: value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectDateTime", function () {
      !_this.props.disabled && _this.setState({
        popupVisible: false,
        datePickerLevel: 'day'
      }, function () {
        _this.props.onChange && _this.props.onChange(_this.state.value && (0, _moment["default"])(_this.state.value).format(_this.props.dateFormat));
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNow", function () {
      _this.setState({
        value: (0, _moment["default"])((0, _moment["default"])(), _this.props.dateFormat),
        year: (0, _moment["default"])().format('YYYY'),
        month: (0, _moment["default"])().format('MM'),
        day: (0, _moment["default"])().format('DD'),
        hour: (0, _moment["default"])().format('HH'),
        minute: (0, _moment["default"])().format('mm'),
        second: (0, _moment["default"])().format('ss')
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePopup", function () {
      if (_this.validValue) {
        _this.setState({
          popupVisible: !_this.state.popupVisible
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      !_this.props.disabled && _this.setState({
        popupVisible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      if (_this.props.position) {
        return;
      }
      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    _this.validValue = true;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    var defaultValue = props.value ? props.value : props.minValue ? props.minValue : (0, _moment["default"])().format('YYYY-MM-DD HH:mm:ss');
    _this.state = {
      value: props.value,
      popupVisible: false,
      isAbove: false,
      year: (0, _moment["default"])(defaultValue).format('YYYY'),
      month: (0, _moment["default"])(defaultValue).format('MM'),
      day: (0, _moment["default"])(defaultValue).format('DD'),
      hour: (0, _moment["default"])(defaultValue).format('HH'),
      minute: (0, _moment["default"])(defaultValue).format('mm'),
      second: (0, _moment["default"])(defaultValue).format('ss'),
      datePickerLevel: 'day'
    };
    return _this;
  }
  (0, _createClass2["default"])(MaterialDateTimePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);

      // debugger
      var _this$props2 = this.props,
        value = _this$props2.value,
        dateFormat = _this$props2.dateFormat;
      if (value) {
        if ((0, _moment["default"])(value, dateFormat).isValid()) {
          this.setState({
            value: (0, _moment["default"])(value, dateFormat),
            year: (0, _moment["default"])(value).format('YYYY'),
            month: (0, _moment["default"])(value).format('MM'),
            day: (0, _moment["default"])(value).format('DD')
          });
        } else {
          console.error('Invalid date');
          this.validValue = false;
        }
      }
    }
  }, {
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _this2 = this;
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        name = _this$props3.name,
        placeholder = _this$props3.placeholder,
        dateFormat = _this$props3.dateFormat,
        maxValue = _this$props3.maxValue,
        minValue = _this$props3.minValue,
        label = _this$props3.label,
        isLabelAnimate = _this$props3.isLabelAnimate,
        isFooter = _this$props3.isFooter,
        position = _this$props3.position,
        theme = _this$props3.theme,
        popupClassName = _this$props3.popupClassName,
        rightIconCls = _this$props3.rightIconCls,
        previousYearIconCls = _this$props3.previousYearIconCls,
        previousMonthIconCls = _this$props3.previousMonthIconCls,
        nextYearIconCls = _this$props3.nextYearIconCls,
        nextMonthIconCls = _this$props3.nextMonthIconCls,
        readOnly = _this$props3.readOnly,
        disabled = _this$props3.disabled,
        parentEl = _this$props3.parentEl,
        _this$state2 = this.state,
        value = _this$state2.value,
        popupVisible = _this$state2.popupVisible,
        datePickerLevel = _this$state2.datePickerLevel,
        year = _this$state2.year,
        month = _this$state2.month,
        day = _this$state2.day,
        hour = _this$state2.hour,
        minute = _this$state2.minute,
        second = _this$state2.second,
        isAbove = _this$state2.isAbove,
        textValue = value && (0, _moment["default"])(value).format(dateFormat);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('material-date-time-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_MaterialDatePickerTextField["default"], {
        className: "material-date-time-picker-field",
        ref: this.trigger,
        theme: theme,
        name: name,
        placeholder: placeholder,
        value: textValue,
        readOnly: readOnly ? readOnly : !popupVisible,
        clearButtonVisible: false,
        isFocusedSelectAll: false,
        disabled: disabled,
        popupVisible: popupVisible,
        label: label,
        isLabelAnimate: isLabelAnimate,
        rightIconCls: rightIconCls,
        onChange: this.handleTextFieldChange,
        onClick: function onClick(e) {
          return _this2.togglePopup(e);
        }
      }), /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        className: "material-date-time-picker-popup ".concat(popupClassName),
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        hasTriangle: false,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, datePickerLevel === 'day' ? /*#__PURE__*/_react["default"].createElement(_DayPicker["default"], {
        value: value,
        dateFormat: dateFormat,
        year: year,
        month: month,
        day: day,
        hour: hour,
        minute: minute,
        second: second,
        maxValue: maxValue ? (0, _moment["default"])(maxValue).format('YYYY-MM-DD') : null,
        minValue: minValue ? (0, _moment["default"])(minValue).format('YYYY-MM-DD') : null,
        isFooter: true,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleDayPickerChange,
        previousClick: this.handleDatePickerChange
      }) : datePickerLevel === 'month' ? /*#__PURE__*/_react["default"].createElement(_MonthPicker["default"], {
        value: value,
        year: year,
        month: month,
        day: day,
        maxValue: maxValue ? (0, _moment["default"])(maxValue).format('YYYY-MM-DD') : null,
        minValue: minValue ? (0, _moment["default"])(minValue).format('YYYY-MM-DD') : null,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleMonthPickerChange,
        previousClick: this.handleDatePickerChange
      }) : datePickerLevel === 'year' ? /*#__PURE__*/_react["default"].createElement(_YearPicker["default"], {
        value: value,
        year: year,
        month: month,
        day: day,
        maxValue: maxValue ? (0, _moment["default"])(maxValue).format('YYYY-MM-DD') : null,
        minValue: minValue ? (0, _moment["default"])(minValue).format('YYYY-MM-DD') : null,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleYearPickerChange
      }) : null, /*#__PURE__*/_react["default"].createElement(_TimeList["default"], {
        className: "time-picker-body ".concat(datePickerLevel === 'time' ? '' : 'hidden'),
        dateFormat: dateFormat.split(' ')[1],
        popupVisible: datePickerLevel === 'time',
        hour: hour,
        minute: minute,
        second: second,
        isRequired: minValue && textValue.split(' ')[0] === minValue.split(' ')[0] || maxValue && textValue.split(' ')[0] === maxValue.split(' ')[0],
        maxValue: maxValue && textValue.split(' ')[0] === maxValue.split(' ')[0] ? (0, _moment["default"])(maxValue).format('HH:mm:ss') : null,
        minValue: minValue && textValue.split(' ')[0] === minValue.split(' ')[0] ? (0, _moment["default"])(minValue).format('HH:mm:ss') : null,
        onChange: this.handleTimePickerChange
      }), isFooter ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-footer"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "action fl"
      }, minValue && (0, _moment["default"])(this.props.value).isBefore(minValue) || maxValue && (0, _moment["default"])(maxValue).isBefore(this.props.value) ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "fl date-text "
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "item-gray"
      }, "Now")) : /*#__PURE__*/_react["default"].createElement("span", {
        className: "fl date-text",
        onClick: this.handleNow
      }, "Now"), datePickerLevel === 'time' ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "fr date-text",
        onClick: function onClick() {
          return _this2.handleChooseDateAndTime('day');
        }
      }, "Select date") : /*#__PURE__*/_react["default"].createElement("span", {
        className: "fr date-text",
        onClick: function onClick() {
          return _this2.handleChooseDateAndTime('time');
        }
      }, "Select time")), /*#__PURE__*/_react["default"].createElement("div", {
        className: "select-button fr",
        onClick: this.handleSelectDateTime
      }, /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
        className: year && month && day && hour && minute && second ? 'active' : '',
        value: "Ok",
        theme: _Theme["default"].HIGHLIGHT
      }))) : null));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        dateFormat = _ComponentUtil["default"].getDerivedState(props, state, 'dateFormat');
      return {
        prevProps: props,
        value: value ? (0, _moment["default"])(value, dateFormat) : '',
        dateFormat: dateFormat
      };
    }
  }]);
  return MaterialDateTimePicker;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialDateTimePicker, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialDateTimePicker, "Position", _Position["default"]);
MaterialDateTimePicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * MaterialDateTimePicker input name.
   */
  name: _propTypes["default"].string,
  /**
   * The label of the MaterialDateTimePicker.
   */
  label: _propTypes["default"].any,
  /**
   * The animate of the MaterialDateTimePicker.
   */
  isLabelAnimate: _propTypes["default"].bool,
  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].string,
  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].string,
  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].string,
  /**
   * MaterialDateTimePicker textField element placeholder.
   */
  placeholder: _propTypes["default"].string,
  /**
   * MaterialDateTimePicker format.
   */
  dateFormat: _propTypes["default"].string,
  isFooter: _propTypes["default"].bool,
  /**
   * If true,materialDateTimePicker textField is readOnly.
   */
  readOnly: _propTypes["default"].bool,
  /**
   * If true,materialDateTimePicker textField is disabled.
   */
  disabled: _propTypes["default"].bool,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
MaterialDateTimePicker.defaultProps = {
  name: '',
  value: (0, _moment["default"])().format('YYYY-MM-DD HH:mm:ss'),
  maxValue: '',
  minValue: '',
  popupClassName: '',
  placeholder: 'Date',
  dateFormat: 'YYYY-MM-DD HH:mm:ss',
  isFooter: true,
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right',
  position: _Position["default"].BOTTOM_LEFT,
  readOnly: false,
  disabled: false
};
var _default = MaterialDateTimePicker;
exports["default"] = _default;