"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _EditableSelect = _interopRequireDefault(require("../EditableSelect"));
var _MaterialFieldSeparator = _interopRequireDefault(require("../_MaterialFieldSeparator"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "style", "theme", "label", "isLabelAnimated", "popupClassName"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialEditableSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialEditableSelect, _Component);
  var _super = _createSuper(MaterialEditableSelect);
  function MaterialEditableSelect(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialEditableSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerFocus", function () {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      _this.setState({
        isFocus: true
      }, function () {
        var onFocus = _this.props.onFocus;
        onFocus && onFocus.apply(void 0, args);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerBlur", function () {
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      _this.setState({
        isFocus: false
      }, function () {
        var onBlur = _this.props.onBlur;
        onBlur && onBlur.apply(void 0, args);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupClosed", function () {
      _this.setState({
        isFocus: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerFilterChange", function (filter) {
      _this.setState({
        filter: filter
      }, function () {
        var onFilterChange = _this.props.onFilterChange;
        onFilterChange && onFilterChange(filter);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerChange", function (value) {
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerMouseOver", function () {
      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }
      _this.setState({
        isHover: true
      }, function () {
        var onMouseOver = _this.props.onMouseOver;
        onMouseOver && onMouseOver.apply(void 0, args);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerMouseOut", function () {
      for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }
      _this.setState({
        isHover: false
      }, function () {
        var onMouseOut = _this.props.onMouseOut;
        onMouseOut && onMouseOut.apply(void 0, args);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.editableSelectInstance && _this.editableSelectInstance.closePopup();
    });
    _this.editableSelect = /*#__PURE__*/(0, _react.createRef)();
    _this.editableSelectInstance = null;
    _this.state = {
      value: '',
      filter: props.filterInitValue,
      isFocus: false,
      isHover: false
    };
    return _this;
  }
  (0, _createClass2["default"])(MaterialEditableSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.editableSelectInstance = this.editableSelect && this.editableSelect.current;
      this.setState({
        value: this.props.value
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        theme = _this$props.theme,
        label = _this$props.label,
        isLabelAnimated = _this$props.isLabelAnimated,
        popupClassName = _this$props.popupClassName,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        _this$state = this.state,
        isFocus = _this$state.isFocus,
        isHover = _this$state.isHover,
        value = _this$state.value;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('material-editable-select', (0, _defineProperty2["default"])({
          animated: isLabelAnimated,
          'has-label': label,
          'has-value': value,
          focused: isFocus
        }, className, className)),
        style: style
      }, label ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "material-editable-select-label"
      }, label) : null, /*#__PURE__*/_react["default"].createElement(_EditableSelect["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.editableSelect,
        popupClassName: (0, _classnames["default"])('material-editable-select-popup', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        theme: theme,
        value: value,
        onFocus: this.handleTriggerFocus,
        onBlur: this.handleTriggerBlur,
        onPopupClosed: this.handlePopupClosed,
        onMouseOver: this.handleTriggerMouseOver,
        onMouseOut: this.handleTriggerMouseOut,
        onFilterChange: this.handleTriggerFilterChange,
        onChange: this.handleTriggerChange
      })), /*#__PURE__*/_react["default"].createElement(_MaterialFieldSeparator["default"], {
        theme: theme,
        isHover: isHover,
        isFocus: isFocus
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return MaterialEditableSelect;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialEditableSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialEditableSelect, "Position", _Position["default"]);
MaterialEditableSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  rightIconCls: _propTypes["default"].string,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The label of the text field.
   */
  label: _propTypes["default"].any,
  /**
   * The animate of the text field.
   */
  isLabelAnimated: _propTypes["default"].bool,
  /**
   * The name of the editableSelect.
   */
  name: _propTypes["default"].string,
  /**
   * The value of the editableSelect.
   */
  value: _propTypes["default"].any,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * The placeholder of the editableSelect.
   */
  placeholder: _propTypes["default"].string,
  /**
   * The options data.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]).isRequired,
  /**
   * The invalid message of editableSelect.
   */
  invalidMsg: _propTypes["default"].string,
  /**
   * If true,the editableSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * The message of the editableSelect.
   */
  infoMsg: _propTypes["default"].string,
  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,
  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * If true,the drop-down box will have search input.
   */
  useFilter: _propTypes["default"].bool,
  /**
   * The message of no matching option.
   */
  noMatchedMsg: _propTypes["default"].string,
  /**
   * The theme of editableSelect.Can be primary,highlight,success,warning,error.
   */
  triggerTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * If true,the drop-down box will be have group selection.
   */
  isGrouped: _propTypes["default"].bool,
  filterInitValue: _propTypes["default"].string,
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onFilterChange: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
MaterialEditableSelect.defaultProps = {
  name: '',
  value: '',
  isLabelAnimated: true,
  placeholder: 'Please select ...',
  data: [],
  invalidMsg: '',
  disabled: false,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  infoMsg: '',
  autoClose: true,
  useFilter: false,
  noMatchedMsg: '',
  triggerTheme: _Theme["default"].DEFAULT,
  isGrouped: false
};
var _default = MaterialEditableSelect;
exports["default"] = _default;