"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _LocalAutoComplete = _interopRequireDefault(require("../LocalAutoComplete"));
var _MaterialProvider = _interopRequireDefault(require("../MaterialProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "style", "theme", "label", "isLabelAnimate", "popupClassName", "disabled", "required"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialLocalAutoComplete = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialLocalAutoComplete, _Component);
  var _super = _createSuper(MaterialLocalAutoComplete);
  function MaterialLocalAutoComplete(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialLocalAutoComplete);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerFilterChange", function (filter) {
      _this.setState({
        filter: filter
      }, function () {
        var onFilterChange = _this.props.onFilterChange;
        onFilterChange && onFilterChange(filter);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerChange", function (value) {
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.autoCompleteInstance && _this.autoCompleteInstance.closePopup();
    });
    _this.autoComplete = /*#__PURE__*/(0, _react.createRef)();
    _this.autoCompleteInstance = null;
    _this.state = {
      value: props.value,
      filter: props.filter
    };
    return _this;
  }
  (0, _createClass2["default"])(MaterialLocalAutoComplete, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.autoCompleteInstance = this.autoComplete && this.autoComplete.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        theme = _this$props.theme,
        label = _this$props.label,
        isLabelAnimate = _this$props.isLabelAnimate,
        popupClassName = _this$props.popupClassName,
        disabled = _this$props.disabled,
        required = _this$props.required,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        _this$state = this.state,
        value = _this$state.value,
        filter = _this$state.filter;
      return /*#__PURE__*/_react["default"].createElement(_MaterialProvider["default"], {
        className: (0, _classnames["default"])('material-local-auto-complete', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        theme: theme,
        label: label,
        isLabelAnimate: isLabelAnimate,
        hasValue: !!filter,
        disabled: disabled,
        required: required
      }, /*#__PURE__*/_react["default"].createElement(_LocalAutoComplete["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.autoComplete,
        popupClassName: (0, _classnames["default"])('material-local-auto-complete-popup', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        theme: theme,
        value: value,
        disabled: disabled,
        onFilterChange: this.handleTriggerFilterChange,
        onChange: this.handleTriggerChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return MaterialLocalAutoComplete;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialLocalAutoComplete, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialLocalAutoComplete, "Position", _Position["default"]);
MaterialLocalAutoComplete.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the auto complete.
   */
  name: _propTypes["default"].string,
  /**
   * The placeholder of the field.
   */
  placeholder: _propTypes["default"].string,
  label: _propTypes["default"].any,
  /**
   * Children passed into the List.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]).isRequired,
  value: _propTypes["default"].any,
  /**
   * If true, the auto complete will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the popup list automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  minFilterLength: _propTypes["default"].number,
  /**
   * Callback function fired when filter changed.
   */
  filterCallback: _propTypes["default"].func,
  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * The visiblity of no matched popup.
   */
  noMatchedPopupVisible: _propTypes["default"].bool,
  /**
   * The message of no matched value.
   */
  noMatchedMsg: _propTypes["default"].string,
  required: _propTypes["default"].bool,
  isLabelAnimate: _propTypes["default"].bool,
  filter: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * The function that trigger when filter changes.
   */
  onFilterChange: _propTypes["default"].func,
  /**
   * The function that trigger when press enter.
   */
  onFilterPressEnter: _propTypes["default"].func,
  /**
   * The function that trigger when filter cleared.
   */
  onFilterClear: _propTypes["default"].func,
  /**
   * The function that trigger when value changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * The function that trigger when touch-tap the list items.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when LocalAutoComplete get focus.
   */
  onFocus: _propTypes["default"].func,
  /**
   * Callback function fired when LocalAutoComplete lose focus.
   */
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
MaterialLocalAutoComplete.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  name: '',
  placeholder: '',
  label: '',
  isLabelAnimate: true,
  data: [],
  disabled: false,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: false,
  minFilterLength: 1,
  iconCls: '',
  rightIconCls: 'fas fa-search',
  noMatchedPopupVisible: true,
  noMatchedMsg: '',
  required: false,
  filter: ''
};
var _default = MaterialLocalAutoComplete;
exports["default"] = _default;