"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _MaterialDatePickerTextField = _interopRequireDefault(require("../_MaterialDatePickerTextField"));
var _TimeList = _interopRequireDefault(require("../_TimeList"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialTimePicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialTimePicker, _Component);
  var _super = _createSuper(MaterialTimePicker);
  function MaterialTimePicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialTimePicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "rangeData", function (range) {
      var arr = [];
      for (var i = 0; i < range; i++) {
        if (i < 10) {
          i = '0' + i;
        }
        arr.push({
          text: i,
          value: true
        });
      }
      return arr;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTextFieldChange", function (text) {
      if (text && text.length) {
        var validDate = '1970-01-01 ' + text;
        var validFormat = 'YYYY-MM-DD ' + _this.props.dateFormat;
        var flag = (0, _moment["default"])(validDate, validFormat, true).isValid();
        if (flag) {
          !_this.props.disabled && _this.setState({
            value: text,
            hour: (0, _moment["default"])(validDate).format('HH'),
            minute: (0, _moment["default"])(validDate).format('mm'),
            second: (0, _moment["default"])(validDate).format('ss')
          }, function () {
            var onChange = _this.props.onChange;
            onChange && onChange(text);
          });
        }
      } else {
        _this.setState({
          value: text
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTimePickerChange", function (obj) {
      var timer = obj.hour + ':' + obj.minute + ':' + obj.second;
      var validDate = '1970-01-01 ' + timer;
      timer = (0, _moment["default"])(validDate).format(_this.props.dateFormat);
      !_this.props.disabled && _this.setState({
        hour: obj.hour,
        minute: obj.minute,
        second: obj.second,
        value: timer
      }, function () {
        _this.props.onChange && _this.props.onChange(timer);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePopup", function (e) {
      if (_this.validValue) {
        _this.setState({
          popupVisible: !_this.state.popupVisible
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.setState({
        popupVisible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      if (_this.props.position) {
        return;
      }
      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    _this.validValue = true;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      value: props.value,
      popupVisible: false,
      hour: (0, _moment["default"])().format('HH'),
      minute: (0, _moment["default"])().format('mm'),
      second: (0, _moment["default"])().format('ss'),
      isAbove: false
    };
    return _this;
  }
  (0, _createClass2["default"])(MaterialTimePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
      var value = this.props.value;
      var dateFormatValue = '2000-02-01 ' + value;
      if (value) {
        if ((0, _moment["default"])(dateFormatValue, 'YYYY-MM-DD HH:mm:ss').isValid()) {
          this.setState({
            value: value,
            hour: (0, _moment["default"])(dateFormatValue).format('HH'),
            minute: (0, _moment["default"])(dateFormatValue).format('mm'),
            second: (0, _moment["default"])(dateFormatValue).format('ss')
          });
        } else {
          this.validValue = false;
          console.error('Invalid date');
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        name = _this$props.name,
        placeholder = _this$props.placeholder,
        maxValue = _this$props.maxValue,
        minValue = _this$props.minValue,
        dateFormat = _this$props.dateFormat,
        label = _this$props.label,
        isLabelAnimate = _this$props.isLabelAnimate,
        position = _this$props.position,
        theme = _this$props.theme,
        popupClassName = _this$props.popupClassName,
        rightIconCls = _this$props.rightIconCls,
        readOnly = _this$props.readOnly,
        disabled = _this$props.disabled,
        parentEl = _this$props.parentEl,
        _this$state = this.state,
        popupVisible = _this$state.popupVisible,
        value = _this$state.value,
        hour = _this$state.hour,
        minute = _this$state.minute,
        second = _this$state.second,
        isAbove = _this$state.isAbove;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('material-time-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_MaterialDatePickerTextField["default"], {
        ref: this.trigger,
        className: "time-picker-field",
        name: name,
        label: label,
        theme: theme,
        isLabelAnimate: isLabelAnimate,
        placeholder: placeholder,
        value: value,
        readOnly: readOnly ? readOnly : !popupVisible,
        clearButtonVisible: false,
        isFocusedSelectAll: false,
        disabled: disabled,
        popupVisible: popupVisible,
        rightIconCls: rightIconCls,
        onChange: this.handleTextFieldChange,
        onClick: function onClick(e) {
          return _this2.togglePopup(e);
        }
      }), /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        className: "material-time-picker-popup ".concat(popupClassName),
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        hasTriangle: false,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, /*#__PURE__*/_react["default"].createElement(_TimeList["default"], {
        hour: hour,
        minute: minute,
        second: second,
        maxValue: maxValue,
        minValue: minValue,
        isRequired: true,
        dateFormat: dateFormat,
        popupVisible: popupVisible,
        onChange: this.handleTimePickerChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return MaterialTimePicker;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialTimePicker, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialTimePicker, "Position", _Position["default"]);
MaterialTimePicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * MaterialTimePicker input name.
   */
  name: _propTypes["default"].string,
  /**
   * The label of the MaterialTimePicker.
   */
  label: _propTypes["default"].any,
  /**
   * The animate of the MaterialTimePicker.
   */
  isLabelAnimate: _propTypes["default"].bool,
  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].string,
  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].string,
  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].string,
  /**
   * MaterialTimePicker textField element placeholder.
   */
  placeholder: _propTypes["default"].string,
  /**
   * If true,materialTimePicker textField is readOnly.
   */
  readOnly: _propTypes["default"].bool,
  /**
   * If true,materialTimePicker textField is disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * Time format.
   */
  dateFormat: _propTypes["default"].string,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  onChange: _propTypes["default"].func
};
MaterialTimePicker.defaultProps = {
  name: '',
  popupClassName: '',
  value: (0, _moment["default"])().format('HH:mm:ss'),
  placeholder: 'Time',
  dateFormat: 'HH:mm:ss',
  position: _Position["default"].BOTTOM_LEFT,
  readOnly: false,
  disabled: false
};
var _default = MaterialTimePicker;
exports["default"] = _default;