"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));
var _YearPicker = _interopRequireDefault(require("../_YearPicker"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MonthField = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MonthField, _Component);
  var _super = _createSuper(MonthField);
  function MonthField(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MonthField);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDatePickerChange", function (selectLevel) {
      _this.setState({
        datePickerLevel: selectLevel
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthPickerChange", function (date) {
      var _this$props = _this.props,
        dateFormat = _this$props.dateFormat,
        selectMode = _this$props.selectMode,
        onChange = _this$props.onChange,
        value = _this.state.value,
        month = (0, _moment["default"])("".concat(date.year, "-").concat(date.month)).format(dateFormat);
      var state = {};
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var result = value ? value.slice() : value;
        if (!result || !(0, _isArray["default"])(result)) {
          result = [];
        }
        var index = value.findIndex(function (item) {
          return (0, _moment["default"])(item).format(dateFormat) === month;
        });
        if (index > -1) {
          result.splice(index, 1);
        } else {
          result.push(month);
        }
        state.value = result;
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        state.value = month;
      }
      _this.setState({
        value: state.value,
        year: date.year,
        month: date.month
      }, function () {
        onChange(state.value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYearPickerChange", function (year) {
      _this.setState({
        datePickerLevel: 'month',
        year: year
      });
    });
    _this.validValue = true;
    _this.state = {
      value: props.value,
      year: (0, _moment["default"])(props.value).format('YYYY'),
      month: (0, _moment["default"])(props.value).format('MM'),
      datePickerLevel: 'month'
    };
    return _this;
  }
  (0, _createClass2["default"])(MonthField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // debugger
      var _this$props2 = this.props,
        value = _this$props2.value,
        dateFormat = _this$props2.dateFormat,
        selectMode = _this$props2.selectMode;
      if (value) {
        if (!((0, _moment["default"])(value, dateFormat).isValid() || value.some(function (item) {
          return (0, _moment["default"])(item, dateFormat).isValid();
        }))) {
          console.error('Invalid date');
          this.validValue = false;
        }
      }
      this.setState({
        value: selectMode === _SelectMode["default"].SINGLE_SELECT ? value ? (0, _moment["default"])(value).format(dateFormat) : '' : value ? value.map(function (item) {
          return (0, _moment["default"])(item).format(dateFormat);
        }) : [],
        year: selectMode === _SelectMode["default"].SINGLE_SELECT ? value ? (0, _moment["default"])(value).format('YYYY') : (0, _moment["default"])().format('YYYY') : value !== null && value !== void 0 && value[0] ? (0, _moment["default"])(value[0]).format('YYYY') : (0, _moment["default"])().format('YYYY'),
        month: selectMode === _SelectMode["default"].SINGLE_SELECT ? value ? (0, _moment["default"])(value).format('MM') : (0, _moment["default"])().format('MM') : value !== null && value !== void 0 && value[0] ? (0, _moment["default"])(value[0]).format('MM') : (0, _moment["default"])().format('MM')
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        maxValue = _this$props3.maxValue,
        minValue = _this$props3.minValue,
        previousYearIconCls = _this$props3.previousYearIconCls,
        previousMonthIconCls = _this$props3.previousMonthIconCls,
        nextYearIconCls = _this$props3.nextYearIconCls,
        nextMonthIconCls = _this$props3.nextMonthIconCls,
        selectMode = _this$props3.selectMode,
        _this$state = this.state,
        value = _this$state.value,
        datePickerLevel = _this$state.datePickerLevel,
        year = _this$state.year,
        month = _this$state.month;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('month-field', (0, _defineProperty2["default"])({}, className, className))
      }, datePickerLevel === 'month' ? /*#__PURE__*/_react["default"].createElement(_MonthPicker["default"], {
        value: value,
        year: year,
        month: month,
        maxValue: maxValue,
        minValue: minValue,
        selectMode: selectMode,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleMonthPickerChange,
        previousClick: this.handleDatePickerChange
      }) : /*#__PURE__*/_react["default"].createElement(_YearPicker["default"], {
        value: value,
        year: year,
        month: month,
        maxValue: maxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleYearPickerChange
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        dateFormat = _ComponentUtil["default"].getDerivedState(props, state, 'dateFormat'),
        selectMode = _ComponentUtil["default"].getDerivedState(props, state, 'selectMode');
      return {
        prevProps: props,
        selectMode: selectMode,
        value: selectMode === _SelectMode["default"].SINGLE_SELECT ? value ? (0, _moment["default"])(value).format(dateFormat) : '' : value ? value.map(function (item) {
          return (0, _moment["default"])(item).format(dateFormat);
        }) : [],
        dateFormat: dateFormat
      };
    }
  }]);
  return MonthField;
}(_react.Component);
(0, _defineProperty2["default"])(MonthField, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MonthField, "Position", _Position["default"]);
(0, _defineProperty2["default"])(MonthField, "SelectMode", _SelectMode["default"]);
MonthField.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].any,
  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].any,
  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].any,
  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,
  /**
   * The mode of monthField.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  rightIconCls: _propTypes["default"].string,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,
  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
MonthField.defaultProps = {
  name: '',
  maxValue: '',
  minValue: '',
  dateFormat: 'YYYY-MM',
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right'
};
var _default = MonthField;
exports["default"] = _default;