"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Popover = _interopRequireDefault(require("../Popover"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _reactDom = require("react-dom");
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["children", "popoverContent", "onRequestOpen", "onRequestClose"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var PopoverProvider = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(PopoverProvider, _Component);
  var _super = _createSuper(PopoverProvider);
  function PopoverProvider(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, PopoverProvider);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "show", function () {
      if (_this.state.visible) {
        return;
      }
      _this.setState({
        visible: true
      }, function () {
        var onRequestOpen = _this.props.onRequestOpen;
        onRequestOpen === null || onRequestOpen === void 0 ? void 0 : onRequestOpen();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hide", function () {
      if (!_this.state.visible) {
        return;
      }
      _this.setState({
        visible: false
      }, function () {
        var onRequestClose = _this.props.onRequestClose;
        onRequestClose === null || onRequestClose === void 0 ? void 0 : onRequestClose();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggle", function () {
      _this.setState({
        visible: !_this.state.visible
      }, function () {
        if (!_this.state.visible) {
          var onRequestClose = _this.props.onRequestClose;
          onRequestClose === null || onRequestClose === void 0 ? void 0 : onRequestClose();
        } else {
          var onRequestOpen = _this.props.onRequestOpen;
          onRequestOpen === null || onRequestOpen === void 0 ? void 0 : onRequestOpen();
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function (e) {
      var _this$props, _this$props$children, _this$props$children$, _this$props$children$2;
      (_this$props = _this.props) === null || _this$props === void 0 ? void 0 : (_this$props$children = _this$props.children) === null || _this$props$children === void 0 ? void 0 : (_this$props$children$ = _this$props$children.props) === null || _this$props$children$ === void 0 ? void 0 : (_this$props$children$2 = _this$props$children$.onMouseOver) === null || _this$props$children$2 === void 0 ? void 0 : _this$props$children$2.call(_this$props$children$, e);
      _this.show();
    });
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      visible: props.visible
    };
    return _this;
  }
  (0, _createClass2["default"])(PopoverProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$trigger;
      this.triggerEl = (0, _reactDom.findDOMNode)((_this$trigger = this.trigger) === null || _this$trigger === void 0 ? void 0 : _this$trigger.current);
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        children = _this$props2.children,
        popoverContent = _this$props2.popoverContent,
        onRequestOpen = _this$props2.onRequestOpen,
        onRequestClose = _this$props2.onRequestClose,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded),
        visible = this.state.visible;
      if (!popoverContent) {
        return children;
      }
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/(0, _react.cloneElement)(children, {
        ref: this.trigger,
        onMouseOver: this.handleMouseOver
      }), /*#__PURE__*/_react["default"].createElement(_Popover["default"], (0, _extends2["default"])({}, restProps, {
        triggerEl: this.triggerEl,
        visible: visible,
        onRequestClose: this.hide
      }), popoverContent));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        visible: _ComponentUtil["default"].getDerivedState(props, state, 'visible')
      };
    }
  }]);
  return PopoverProvider;
}(_react.Component);
(0, _defineProperty2["default"])(PopoverProvider, "Position", _Position["default"]);
(0, _defineProperty2["default"])(PopoverProvider, "Theme", _Theme["default"]);
PopoverProvider.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,
  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  triangle: _propTypes["default"].element,
  /**
   * The popover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The popover alignment.The value can be Popover.Position.LEFT or Popover.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true, popover will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  closeWait: _propTypes["default"].number,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,
  /**
   * The function of popover render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of popover rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of popover destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of popover destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when the popover is requested to be opened.
   */
  onRequestOpen: _propTypes["default"].func,
  /**
   * Callback function fired when the popover is requested to be closed.
   */
  onRequestClose: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  popoverContent: _propTypes["default"].any
};
PopoverProvider.defaultProps = {
  parentEl: document.body,
  visible: false,
  hasTriangle: true,
  theme: _Theme["default"].DEFAULT,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  isBlurClose: true,
  shouldFollowScroll: false,
  closeWait: 1000 / 6,
  resetPositionWait: 250,
  showModal: false
};
var _default = PopoverProvider;
exports["default"] = _default;