"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _domHelpers = require("dom-helpers");
var _classnames = _interopRequireDefault(require("classnames"));
var _PortalManagement = _interopRequireDefault(require("../_vendors/PortalManagement"));
var _excluded = ["className", "parentEl", "children", "visible"];
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Portal = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Portal, _Component);
  var _super = _createSuper(Portal);
  function Portal(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Portal);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderWrapper", function () {
      if (_this.wrapper) {
        return _this.wrapper;
      }
      var _this$props = _this.props,
        className = _this$props.className,
        parentEl = _this$props.parentEl,
        children = _this$props.children,
        visible = _this$props.visible,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      if (!parentEl) {
        return null;
      }
      _this.wrapper = document.createElement('div');
      _this.wrapper.className = (0, _classnames["default"])('portal', (0, _defineProperty2["default"])({}, className, className));
      for (var _i = 0, _Object$entries = Object.entries(restProps); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = (0, _slicedToArray2["default"])(_Object$entries[_i], 2),
          key = _Object$entries$_i[0],
          value = _Object$entries$_i[1];
        _this.wrapper[key] = value;
      }

      // handle all portals in portalManagement
      _PortalManagement["default"].push(parentEl, _this.wrapper);
      return parentEl.appendChild(_this.wrapper);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderPortal", function () {
      if (!_this.renderWrapper()) {
        return null;
      }
      return _this.portal = /*#__PURE__*/(0, _reactDom.createPortal)(_this.props.children, _this.wrapper);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "unmountWrapper", function () {
      var parentEl = _this.props.parentEl;
      if (_this.wrapper && parentEl && (0, _domHelpers.contains)(parentEl, _this.wrapper)) {
        parentEl.removeChild(_this.wrapper);

        // handle all portals in portalManagement
        _PortalManagement["default"].pop(parentEl, _this.wrapper);
        _this.wrapper = null;
      }
    });
    _this.wrapper = null;
    _this.portal = null;
    return _this;
  }
  (0, _createClass2["default"])(Portal, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (!this.props.visible) {
        this.unmountWrapper();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmountWrapper();
    }

    /**
     * render portal element to dom and return it
     * @returns {*}
     */
  }, {
    key: "render",
    value: function render() {
      return this.props.visible ? this.renderPortal() : null;
    }
  }]);
  return Portal;
}(_react.Component);
Portal.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  visible: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object
};
Portal.defaultProps = {
  visible: false,
  parentEl: document.body
};
var _default = Portal;
exports["default"] = _default;