"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TextField = _interopRequireDefault(require("../TextField/TextField"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading/CircularLoading"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var RemoteAutoComplete = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RemoteAutoComplete, _Component);
  var _super = _createSuper(RemoteAutoComplete);
  function RemoteAutoComplete(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, RemoteAutoComplete);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getClassName", function (element) {
      var className = element.className;
      var current = element.offsetParent;
      while (current !== null) {
        className += current.className;
        current = current.offsetParent;
      }
      return className;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "changeText", function (text) {
      _this.setState({
        value: text
      }, function () {
        _this.setState({
          loading: true
        }, function () {
          var onChange = _this.props.onChange;
          onChange && onChange(text, true);
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", (0, _debounce["default"])(function (text) {
      _this.changeText(text);
    }, 250));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function () {
      _this.setState({
        focus: true
      }, function () {
        var onFocus = _this.props.onFocus;
        onFocus && onFocus();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (ev) {
      var onBlur = _this.props.onBlur;
      var className = _this.getClassName(ev.target);
      if (className.indexOf('auto-complete-li') > -1) {
        var oEvent = ev.srcElement ? ev.srcElement : ev.target;
        _this.setState({
          focus: true
        }, function () {
          var onChange = _this.props.onChange;
          onChange && onChange(oEvent.innerText, false);
        });
      } else if (className.indexOf('text-field') > -1) {
        return false;
      } else {
        _this.setState({
          focus: false
        }, function () {
          onBlur && onBlur(_this.state.value);
        });
      }
    });
    _this.liHeight = 40;
    _this.maxHeight = 401;
    _this.inputHeight = 50;
    _this.borderWidth = 1;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      value: props.value,
      focus: false,
      loading: props.loading
    };
    return _this;
  }

  /**
   * 获取当前元素及父元素的类名
   */
  (0, _createClass2["default"])(RemoteAutoComplete, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
      _Event["default"].addEvent(document, 'click', this.handleClick);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'click', this.handleClick);
      if (this.handleChange) {
        this.handleChange.cancel();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        data = _this$props.data,
        className = _this$props.className,
        style = _this$props.style,
        placeholder = _this$props.placeholder,
        resetPopPositionWait = _this$props.resetPopPositionWait,
        parentEl = _this$props.parentEl,
        _this$state = this.state,
        value = _this$state.value,
        focus = _this$state.focus,
        loading = _this$state.loading,
        ulHeight = loading ? 50 : data.length > 0 ? data.length * this.liHeight + this.borderWidth : 0;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('remote-auto-complete', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('auto-complete-inner', {
          focused: focus
        }),
        style: {
          height: this.inputHeight
        }
      }, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        style: {
          height: this.inputHeight
        },
        value: value,
        onFocus: this.handleFocus,
        placeholder: placeholder,
        onChange: this.handleChange
      }), /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        visible: focus,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        hasTriangle: false,
        style: {
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        },
        resetPositionWait: resetPopPositionWait
      }, /*#__PURE__*/_react["default"].createElement("ul", {
        className: "auto-complete-list",
        style: {
          height: ulHeight > this.maxHeight ? this.maxHeight : ulHeight
        }
      }, loading ? /*#__PURE__*/_react["default"].createElement("li", {
        className: "auto-complete-li-loading"
      }, /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
        className: "loading",
        size: _CircularLoading["default"].Size.DEFAULT
      })) : data && data.map(function (value) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: value,
          className: "auto-complete-li",
          style: {
            height: _this2.liHeight,
            lineHeight: _this2.liHeight + 'px'
          },
          title: value
        }, value);
      })))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        loading: _ComponentUtil["default"].getDerivedState(props, state, 'loading')
      };
    }
  }]);
  return RemoteAutoComplete;
}(_react.Component);
RemoteAutoComplete.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The value of input.
   */
  value: _propTypes["default"].string,
  /**
   * The options data.
   */
  data: _propTypes["default"].array,
  /**
   * If true, the list is loading.
   */
  loading: _propTypes["default"].bool,
  /**
   * The placeholder of input.
   */
  placeholder: _propTypes["default"].string,
  resetPopPositionWait: _propTypes["default"].number,
  parentEl: _propTypes["default"].object,
  /**
   * Callback function fired when value change.
   */
  onChange: _propTypes["default"].func,
  /**
   * Callback function fired when input blur.
   */
  onBlur: _propTypes["default"].func,
  /**
   * Callback function fired when input focus.
   */
  onFocus: _propTypes["default"].func
};
RemoteAutoComplete.defaultProps = {
  value: '',
  data: [],
  searchLength: 1,
  loading: false,
  resetPopPositionWait: 250
};
var _default = RemoteAutoComplete;
exports["default"] = _default;