"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Color = require("../_vendors/Color");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var SkeletonLoading = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(SkeletonLoading, _Component);
  var _super = _createSuper(SkeletonLoading);
  function SkeletonLoading(props) {
    (0, _classCallCheck2["default"])(this, SkeletonLoading);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    return _super.call.apply(_super, [this, props].concat(restArgs));
  }
  (0, _createClass2["default"])(SkeletonLoading, [{
    key: "render",
    value: function render() {
      var _hex2rgb;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        size = _this$props.size,
        animationDuration = _this$props.animationDuration,
        highlightColor = _this$props.highlightColor,
        highlightDegree = _this$props.highlightDegree,
        highlightTransparency = _this$props.highlightTransparency,
        isCircular = _this$props.isCircular,
        isAnimated = _this$props.isAnimated;
      var highlightColorRgb = ((_hex2rgb = (0, _Color.hex2rgb)(highlightColor)) === null || _hex2rgb === void 0 ? void 0 : _hex2rgb.join(',')) || '255,255,255';
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('skeleton-loading', (0, _defineProperty2["default"])({
          circular: isCircular,
          animated: isAnimated
        }, className, className)),
        style: _objectSpread(_objectSpread({}, style), {}, {
          width: !isNaN(size) ? isCircular ? size : null : null,
          height: !isNaN(size) ? size : null,
          backgroundImage: !isNaN(highlightDegree) || highlightColorRgb || !isNaN(highlightTransparency) ? "linear-gradient(".concat(highlightDegree, "deg, rgba(").concat(highlightColorRgb, ", 0) 40%, rgba(").concat(highlightColorRgb, ", ").concat(highlightTransparency, ") 50%, rgba(").concat(highlightColorRgb, ", 0) 60%)") : null,
          animationDuration: !isNaN(animationDuration) ? "".concat(animationDuration, "ms") : null
        })
      });
    }
  }]);
  return SkeletonLoading;
}(_react.Component);
SkeletonLoading.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  size: _propTypes["default"].number,
  animationDuration: _propTypes["default"].number,
  highlightColor: _propTypes["default"].string,
  highlightDegree: _propTypes["default"].number,
  highlightTransparency: _propTypes["default"].number,
  isCircular: _propTypes["default"].bool,
  isAnimated: _propTypes["default"].bool
};
SkeletonLoading.defaultProps = {
  animationDuration: 1600,
  highlightDegree: 100,
  highlightColorRgb: '#fff',
  highlightTransparency: 0.4,
  isCircular: false,
  isAnimated: true
};
var _default = SkeletonLoading;
exports["default"] = _default;