"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Tabs = _interopRequireDefault(require("../_Tabs"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _excluded = ["children", "tabsChildren", "className", "style", "isAnimated"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Tab = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Tab, _Component);
  var _super = _createSuper(Tab);
  function Tab(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tab);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRenderer", function (item) {
      if (!item || !item.tabContentRenderer) {
        return null;
      }
      return typeof item.tabContentRenderer === 'function' ? item.tabContentRenderer(item) : item.tabContentRenderer;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTabClick", function (item, activatedIndex, e) {
      var _this$props$onTabClic, _this$props, _this$props$beforeInd, _this$props2;
      (_this$props$onTabClic = (_this$props = _this.props).onTabClick) === null || _this$props$onTabClic === void 0 ? void 0 : _this$props$onTabClic.call(_this$props, item, activatedIndex, e);
      if (activatedIndex === _this.state.activatedIndex) {
        return;
      }
      if (((_this$props$beforeInd = (_this$props2 = _this.props).beforeIndexChange) === null || _this$props$beforeInd === void 0 ? void 0 : _this$props$beforeInd.call(_this$props2, activatedIndex, item, e)) === false) {
        return;
      }
      _this.setState({
        activatedIndex: activatedIndex
      }, function () {
        var _item$onActive, _this$props$onIndexCh, _this$props3;
        (_item$onActive = item.onActive) === null || _item$onActive === void 0 ? void 0 : _item$onActive.call(item, item, activatedIndex, e);
        (_this$props$onIndexCh = (_this$props3 = _this.props).onIndexChange) === null || _this$props$onIndexCh === void 0 ? void 0 : _this$props$onIndexCh.call(_this$props3, activatedIndex, item, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTabsOverflowChange", function (isTabsOverflow) {
      _this.setState({
        isTabsOverflow: isTabsOverflow
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTabButtonDragEnd", function (result) {
      if (!result || !('draggableId' in result) || !result.source || !('index' in result.source) || !result.destination || !('index' in result.destination)) {
        return;
      }
      var tabs = _this.state.tabs;
      _Util["default"].reorder(tabs, result.source.index, result.destination.index);
      var activatedIndex = _this.state.activatedIndex;
      var state = {
        tabs: tabs
      };
      if (activatedIndex === result.source.index) {
        state.activatedIndex = result.destination.index;
      } else if (activatedIndex === result.destination.index) {
        state.activatedIndex = result.source.index;
      } else if (activatedIndex > result.source.index && activatedIndex < result.destination.index) {
        state.activatedIndex = activatedIndex - 1;
      } else if (activatedIndex < result.source.index && activatedIndex > result.destination.index) {
        state.activatedIndex = activatedIndex + 1;
      }
      _this.setState(state, function () {
        var _this$props$onTabButt, _this$props4, _this$props$onTabsSeq, _this$props5;
        (_this$props$onTabButt = (_this$props4 = _this.props).onTabButtonDragEnd) === null || _this$props$onTabButt === void 0 ? void 0 : _this$props$onTabButt.call(_this$props4, result);
        (_this$props$onTabsSeq = (_this$props5 = _this.props).onTabsSequenceChange) === null || _this$props$onTabsSeq === void 0 ? void 0 : _this$props$onTabsSeq.call(_this$props5, tabs);
      });
    });
    _this.state = {
      tabs: props.tabs,
      activatedIndex: props.activatedIndex,
      isTabsOverflow: false
    };
    return _this;
  }
  (0, _createClass2["default"])(Tab, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props6 = this.props,
        children = _this$props6.children,
        tabsChildren = _this$props6.tabsChildren,
        className = _this$props6.className,
        style = _this$props6.style,
        isAnimated = _this$props6.isAnimated,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props6, _excluded);
      var _this$state = this.state,
        tabs = _this$state.tabs,
        activatedIndex = _this$state.activatedIndex,
        isTabsOverflow = _this$state.isTabsOverflow;
      var tabWidthPerCent = 100 / tabs.length;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('tab', (0, _defineProperty2["default"])({
          animated: isAnimated,
          'tabs-overflow': isTabsOverflow
        }, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_Tabs["default"], (0, _extends2["default"])({}, restProps, {
        data: tabs,
        activatedIndex: activatedIndex,
        isTabsOverflow: isTabsOverflow,
        onTabClick: this.handleTabClick,
        onTabsOverflowChange: this.handleTabsOverflowChange,
        onTabButtonDragEnd: this.handleTabButtonDragEnd
      }), tabsChildren), /*#__PURE__*/_react["default"].createElement("div", {
        className: "tab-content-wrapper"
      }, isAnimated ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "tab-content-scroller",
        style: {
          width: "".concat(tabs.length * 100, "%"),
          transform: "translate(".concat(-activatedIndex * tabWidthPerCent, "%, 0)")
        }
      }, (tabs === null || tabs === void 0 ? void 0 : tabs.map(function (item, index) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "tab-content",
          style: {
            width: "".concat(tabWidthPerCent, "%")
          }
        }, _this2.getRenderer(item));
      })) || null) : /*#__PURE__*/_react["default"].createElement("div", {
        className: "tab-content"
      }, tabs ? this.getRenderer(tabs[activatedIndex]) : null)), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var tabs = _ComponentUtil["default"].getDerivedState(props, state, 'tabs');
      return {
        prevProps: props,
        tabs: tabs,
        activatedIndex: _Valid["default"].range(_ComponentUtil["default"].getDerivedState(props, state, 'activatedIndex'), 0, tabs.length - 1)
      };
    }
  }]);
  return Tab;
}(_react.Component);
Tab.propTypes = {
  children: _propTypes["default"].any,
  tabsChildren: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Children passed into the TabsItem.
   */
  tabs: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    className: _propTypes["default"].string,
    style: _propTypes["default"].object,
    /**
     * The text value of the tab.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the tab will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the tab will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon.It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * The position of the icon.
     */
    iconPosition: _propTypes["default"].string,
    /**
     * The render of tab button content.
     */
    renderer: _propTypes["default"].any,
    /**
     * The render of tab button.
     */
    tabButtonRenderer: _propTypes["default"].any,
    /**
     * The render content in tab.
     */
    tabContentRenderer: _propTypes["default"].any,
    /**
     * Callback function fired when click onActive tab.
     */
    onActive: _propTypes["default"].func
  })).isRequired,
  /**
   * Activated tab index.
   */
  activatedIndex: _propTypes["default"].number,
  /**
   * If true,the tabs is FullWidth.
   */
  isTabFullWidth: _propTypes["default"].bool,
  isInkBarHidden: _propTypes["default"].bool,
  isAnimated: _propTypes["default"].bool,
  draggable: _propTypes["default"].bool,
  idField: _propTypes["default"].string,
  scrollLeftIconCls: _propTypes["default"].string,
  scrollRightIconCls: _propTypes["default"].string,
  scrollStep: _propTypes["default"].number,
  scrollInterval: _propTypes["default"].number,
  keepScrollingWait: _propTypes["default"].number,
  beforeIndexChange: _propTypes["default"].func,
  onIndexChange: _propTypes["default"].func,
  onTabClick: _propTypes["default"].func,
  onTabMouseDown: _propTypes["default"].func,
  onTabMouseUp: _propTypes["default"].func,
  onTabButtonDragStart: _propTypes["default"].func,
  onTabButtonDragEnd: _propTypes["default"].func,
  onTabsSequenceChange: _propTypes["default"].func,
  onScrollLeftButtonMouseDown: _propTypes["default"].func,
  onScrollRightButtonMouseDown: _propTypes["default"].func
};
Tab.defaultProps = {
  tabs: [],
  activatedIndex: 0,
  isTabFullWidth: true,
  isInkBarHidden: false,
  isAnimated: true,
  draggable: false,
  scrollLeftIconCls: 'fas fa-chevron-left',
  scrollRightIconCls: 'fas fa-chevron-right',
  scrollStep: 100,
  scrollInterval: 100,
  keepScrollingWait: 250
};
var _default = Tab;
exports["default"] = _default;