"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _trim = _interopRequireDefault(require("lodash/trim"));
var _EditableField = _interopRequireDefault(require("../EditableField"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _CharSize = _interopRequireDefault(require("../_vendors/CharSize"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TagField = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TagField, _Component);
  var _super = _createSuper(TagField);
  function TagField(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TagField);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getSeparators", function () {
      var separators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.separators;
      if (separators && separators.length > 0) {
        return separators;
      }
      return DEFAULT_SEPARATORS;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "generateSeparatorReg", function () {
      var separators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.separators;
      var seps = _this.getSeparators(separators);
      return new RegExp("\\s*".concat(seps ? seps.map(function (sep) {
        return "\\".concat(sep);
      }).join('|') : '', "\\s*"), 'g');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeItem", function (index) {
      var data = _this.state.data;
      if (!data || data.length < 1 || !(index in data)) {
        return;
      }
      data.splice(index, 1);
      _this.setState({
        data: data
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calInputIndex", function (e) {
      if (!_this.wrapperEl) {
        return -1;
      }
      var offset = _Dom["default"].getOffset(_this.wrapperEl),
        minX = offset.left,
        wrapperWidth = _this.wrapperEl.getBoundingClientRect().width,
        maxX = minX + wrapperWidth;
      var x = e.clientX,
        y = e.clientY,
        inputIndex = -1;
      while (x >= minX) {
        var item = document.elementFromPoint(x, y),
          el = _Dom["default"].findParentByClassName(item, 'tag-field-item-wrapper');
        if (el) {
          inputIndex = +el.dataset.index + 1;
          break;
        }
        x--;
      }
      if (inputIndex < 0) {
        while (x <= maxX) {
          var _item = document.elementFromPoint(x, y),
            _el = _Dom["default"].findParentByClassName(_item, 'tag-field-item-wrapper');
          if (_el) {
            inputIndex = +_el.dataset.index;
            break;
          }
          x++;
        }
      }
      return inputIndex < 0 ? _this.state.data.length : inputIndex;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      if (_this.props.disabled || _Dom["default"].findParentByClassName(e.target, 'tag-field-item-wrapper') || _Dom["default"].hasClass(e.target, 'tag-field-input')) {
        return;
      }
      var callback = function (e) {
        var _this2 = this;
        return function () {
          if (_this2.state.itemEditing || _this2.wrapperEl && _Dom["default"].findParentByClassName(e.target, 'tag-field') != _this2.wrapperEl) {
            _this2.setState({
              inputIndex: _this2.state.data.length
            });
            return;
          }
          var x = e.clientX,
            y = e.clientY;
          if (!x || !y || !_this2.wrapperEl) {
            return;
          }
          var offset = _Dom["default"].getOffset(_this2.wrapperEl);
          if (!offset) {
            return;
          }
          var inputIndex = _this2.calInputIndex(e);
          _this2.setState({
            inputIndex: inputIndex
          }, function () {
            setTimeout(function () {
              _this2.input && _this2.input.current && _this2.input.current.focus();
              // wrapperEl.scrollLeft = 0;
              // wrapperEl.scrollTop = 0;
            }, 0);
          });
        };
      }.bind((0, _assertThisInitialized2["default"])(_this))(e);
      if (_this.state.inputValue) {
        _this.insertInputValue(callback);
      } else {
        callback();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputChange", function (e) {
      if (_this.props.disabled) {
        return;
      }
      var value = e.target.value,
        inputValue = value ? value.replace(/\r?\n$/gm, '') // remove last \r\n
        .replace(/\r?\n/gm, _this.getSeparators()[0]) : value;
      _this.setState({
        inputValue: inputValue
      }, function () {
        var onInputChange = _this.props.onInputChange,
          width = _CharSize["default"].calculateStringWidth(inputValue, _this.testEl),
          inputWrapperEl = _this.inputWrapper && _this.inputWrapper.current,
          inputEl = _this.input && _this.input.current;
        inputWrapperEl && (inputWrapperEl.style.width = "".concat(width + 9, "px"));
        inputEl && (inputEl.style.height = Math.max(inputEl.scrollHeight, 24) + 'px');
        onInputChange && onInputChange(inputValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputKeyDown", function (e) {
      if (_this.props.disabled) {
        return;
      }
      if (e.keyCode === 13) {
        _this.insertInputValue();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "insertInputValue", function (callback) {
      if (_this.props.disabled) {
        return;
      }
      var _this$state = _this.state,
        data = _this$state.data,
        inputValue = _this$state.inputValue,
        inputIndex = _this$state.inputIndex;
      if (!inputValue) {
        return;
      }
      var splitedValue = (0, _trim["default"])(inputValue).split(_this.generateSeparatorReg()).filter(function (item) {
        return !!item;
      });
      data.splice.apply(data, [inputIndex, 0].concat((0, _toConsumableArray2["default"])(splitedValue)));
      _this.setState({
        data: data,
        inputValue: '',
        inputIndex: inputIndex + splitedValue.length
      }, function () {
        _this.inputWrapper && _this.inputWrapper.current && (_this.inputWrapper.current.style.width = '9px');
        var onChange = _this.props.onChange;
        onChange && onChange(data);
        callback && callback();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemChange", function (value, index) {
      if (_this.props.disabled) {
        return;
      }
      var data = _this.state.data;
      if (value) {
        var splitedValue = value.split(_this.generateSeparatorReg()).filter(function (item) {
          return item;
        });
        data.splice.apply(data, [index, 1].concat((0, _toConsumableArray2["default"])(splitedValue)));
      } else {
        data.splice(index, 1);
      }
      _this.setState({
        data: data
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemEditStart", function (editingItemIndex) {
      if (_this.props.disabled) {
        return;
      }
      _this.setState({
        itemEditing: true,
        editingItemIndex: editingItemIndex
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemEditEnd", function () {
      if (_this.props.disabled) {
        return;
      }
      _this.setState({
        itemEditing: false
      });
    });
    _this.inputSymbol = Symbol('input');
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    _this.inputWrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.input = /*#__PURE__*/(0, _react.createRef)();
    _this.test = /*#__PURE__*/(0, _react.createRef)();
    _this.testEl = null;
    _this.state = {
      wrapperWidth: 'auto',
      data: props.data,
      inputValue: props.inputValue,
      inputIndex: props.data.length,
      itemEditing: false,
      editingItemIndex: -1
    };
    return _this;
  }
  (0, _createClass2["default"])(TagField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.testEl = this.test && this.test.current;
      _Event["default"].addEvent(document, 'mousedown', this.handleMouseDown);
      this.setState({
        wrapperWidth: this.wrapperEl ? this.wrapperEl.clientWidth : 'auto'
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousedown', this.handleMouseDown);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        valueField = _this$props.valueField,
        displayField = _this$props.displayField,
        disabled = _this$props.disabled,
        placeholder = _this$props.placeholder,
        isTagAutoWidth = _this$props.isTagAutoWidth,
        tagRemoveIconCls = _this$props.tagRemoveIconCls,
        _this$state2 = this.state,
        wrapperWidth = _this$state2.wrapperWidth,
        data = _this$state2.data,
        inputValue = _this$state2.inputValue,
        inputIndex = _this$state2.inputIndex,
        itemEditing = _this$state2.itemEditing,
        editingItemIndex = _this$state2.editingItemIndex,
        indexData = _Util["default"].genIndexArray(data.length);
      indexData.splice(inputIndex, 0, this.inputSymbol);
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('tag-field', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, indexData && indexData.map(function (index) {
        return index === _this3.inputSymbol ? !disabled ? /*#__PURE__*/_react["default"].createElement("div", {
          key: "input",
          ref: _this3.inputWrapper,
          className: "tag-field-input-wrapper"
        }, /*#__PURE__*/_react["default"].createElement("textarea", {
          ref: _this3.input,
          className: "tag-field-input",
          style: {
            width: wrapperWidth
          },
          autoFocus: true,
          value: inputValue,
          placeholder: data.length < 1 && placeholder ? placeholder : '',
          onChange: _this3.handleInputChange,
          onKeyDown: _this3.handleInputKeyDown
        })) : null : /*#__PURE__*/_react["default"].createElement("span", {
          key: index,
          "data-index": index,
          className: (0, _classnames["default"])('tag-field-item-wrapper', (0, _defineProperty2["default"])({}, data[index].className, data[index].className))
        }, /*#__PURE__*/_react["default"].createElement(_EditableField["default"], {
          className: "tag-field-item-field",
          value: _Util["default"].getTextByDisplayField(data[index], displayField, valueField),
          disabled: disabled || itemEditing && index !== editingItemIndex,
          autoWidth: isTagAutoWidth,
          onChange: function onChange(value) {
            return _this3.handleItemChange(value, index);
          },
          onEditStart: function onEditStart() {
            return _this3.handleItemEditStart(index);
          },
          onEditEnd: _this3.handleItemEditEnd
        }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          className: "tag-field-item-field-delete-button",
          iconCls: tagRemoveIconCls,
          disabled: disabled || itemEditing && index !== editingItemIndex,
          onClick: function onClick() {
            return _this3.removeItem(index);
          }
        })));
      }), /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.test,
        className: "tag-field-test-container"
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        data: _ComponentUtil["default"].getDerivedState(props, state, 'data'),
        inputValue: _ComponentUtil["default"].getDerivedState(props, state, 'inputValue')
      };
    }
  }]);
  return TagField;
}(_react.Component);
(0, _defineProperty2["default"])(TagField, "DEFAULT_SEPARATORS", [',']);
TagField.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  data: _propTypes["default"].array,
  inputValue: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  separators: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  isTagAutoWidth: _propTypes["default"].bool,
  tagRemoveIconCls: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  onInputChange: _propTypes["default"].func
};
TagField.defaultProps = {
  data: [],
  inputValue: '',
  valueField: 'value',
  displayField: 'text',
  separators: TagField.DEFAULT_SEPARATORS,
  disabled: false,
  placeholder: '',
  isTagAutoWidth: true,
  tagRemoveIconCls: 'fas fa-times'
};
var _default = TagField;
exports["default"] = _default;