"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _FieldMsg = _interopRequireDefault(require("../FieldMsg"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _FieldType = _interopRequireDefault(require("../_statics/FieldType"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["children", "className", "triggerClassName", "placeholderClassName", "style", "theme", "type", "iconCls", "disabled", "infoMsg", "autoHeight", "wordCountVisible", "placeholder", "clearButtonVisible", "rightIconCls", "passwordButtonVisible", "fieldMsgVisible", "maxLength", "isStrictMaxLength", "onIconClick", "onRightIconClick", "value", "autoFocus", "pattern", "patternInvalidMsg", "isFocusedSelectAll", "onPressEnter", "onValid", "onInvalid", "onClear", "onPasswordVisible", "onPasswordInvisible"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TextArea = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TextArea, _Component);
  var _super = _createSuper(TextArea);
  function TextArea(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TextArea);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focus", function () {
      _this.inputEl && _this.inputEl.focus();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "blur", function () {
      _this.inputEl && _this.inputEl.blur();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetHeight", function () {
      if (_this.props.autoHeight && _this.inputEl) {
        _this.inputEl.style.height = '1px';
        _this.inputEl.style.height = Math.max(_this.inputEl.scrollHeight, _this.inputElInitHeight) + 'px';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (e) {
      var _this$props = _this.props,
        onValid = _this$props.onValid,
        onInvalid = _this$props.onInvalid,
        value = e.target.value,
        invalidMsgs = _Valid["default"].fieldValid(value, _this.props);
      _this.resetHeight();
      _this.setState({
        invalidMsgs: invalidMsgs,
        value: value
      }, function () {
        _this.props.onChange && _this.props.onChange(value, e);
        invalidMsgs.length > 0 ? onInvalid && onInvalid() : onValid && onValid();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyDown", function (e) {
      if (e.keyCode === 13) {
        var onPressEnter = _this.props.onPressEnter,
          value = _this.state.value;
        onPressEnter && onPressEnter(e, value);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearValue", function () {
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        clearButtonVisible = _this$props2.clearButtonVisible,
        onClear = _this$props2.onClear,
        onChange = _this$props2.onChange,
        onValid = _this$props2.onValid,
        onInvalid = _this$props2.onInvalid,
        invalidMsgs = _Valid["default"].fieldValid('', _this.props);
      !disabled && clearButtonVisible && _this.setState({
        invalidMsgs: invalidMsgs,
        value: ''
      }, function () {
        _this.focus();
        onClear && onClear();
        onChange && onChange('');
        invalidMsgs.length > 0 ? onInvalid && onInvalid() : onValid && onValid();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePasswordVisible", function () {
      var _this$props3 = _this.props,
        disabled = _this$props3.disabled,
        passwordButtonVisible = _this$props3.passwordButtonVisible,
        onPasswordVisible = _this$props3.onPasswordVisible,
        onPasswordInvisible = _this$props3.onPasswordInvisible;
      var passwordVisible = !_this.state.passwordVisible;
      !disabled && passwordButtonVisible && _this.setState({
        passwordVisible: passwordVisible
      }, function () {
        _this.focus();
        passwordVisible ? onPasswordVisible && onPasswordVisible() : onPasswordInvisible && onPasswordInvisible();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function (e) {
      _this.setState({
        infoVisible: true,
        errorVisible: true
      }, function () {
        var onMouseOver = _this.props.onMouseOver,
          value = _this.state.value;
        onMouseOver && onMouseOver(e, value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      _this.setState({
        infoVisible: false,
        errorVisible: false
      }, function () {
        var onMouseOut = _this.props.onMouseOut,
          value = _this.state.value;
        onMouseOut && onMouseOut(e, value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function (e) {
      _this.setState({
        isFocused: true
      }, function () {
        var _this$props4 = _this.props,
          isFocusedSelectAll = _this$props4.isFocusedSelectAll,
          onFocus = _this$props4.onFocus,
          value = _this.state.value;
        onFocus && onFocus(e, value);
        isFocusedSelectAll && _this.inputEl && _this.inputEl.setSelectionRange(0, value ? value.length : 0);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBlur", function (e) {
      if (e.relatedTarget == _this.clearButtonEl) {
        return;
      }
      _this.setState({
        isFocused: false
      }, function () {
        var onBlur = _this.props.onBlur,
          value = _this.state.value;
        onBlur && onBlur(e, value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRightIconClick", function (e) {
      var onRightIconClick = _this.props.onRightIconClick,
        value = _this.state.value;
      onRightIconClick && onRightIconClick(e, value);
    });
    _this.input = /*#__PURE__*/(0, _react.createRef)();
    _this.inputEl = null;
    _this.clearButton = /*#__PURE__*/(0, _react.createRef)();
    _this.clearButtonEl = null;
    _this.state = {
      value: props.value,
      isFocused: props.autoFocus ? true : false,
      passwordVisible: false,
      infoVisible: false,
      errorVisible: false,
      invalidMsgs: ''
    };
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(TextArea, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (prevProps.value !== this.props.value) {
        this.props.autoHeight && this.resetHeight();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.inputEl = this.input && this.input.current;
      this.inputElInitHeight = parseInt(this.inputEl.offsetHeight);
      this.clearButtonEl = this.clearButton && this.clearButton.current && (0, _reactDom.findDOMNode)(this.clearButton.current);
      this.resetHeight();
      if (this.props.autoFocus === true && this.inputEl) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _this$props5 = this.props,
        children = _this$props5.children,
        className = _this$props5.className,
        triggerClassName = _this$props5.triggerClassName,
        placeholderClassName = _this$props5.placeholderClassName,
        style = _this$props5.style,
        theme = _this$props5.theme,
        type = _this$props5.type,
        iconCls = _this$props5.iconCls,
        disabled = _this$props5.disabled,
        infoMsg = _this$props5.infoMsg,
        autoHeight = _this$props5.autoHeight,
        wordCountVisible = _this$props5.wordCountVisible,
        placeholder = _this$props5.placeholder,
        clearButtonVisible = _this$props5.clearButtonVisible,
        rightIconCls = _this$props5.rightIconCls,
        passwordButtonVisible = _this$props5.passwordButtonVisible,
        fieldMsgVisible = _this$props5.fieldMsgVisible,
        maxLength = _this$props5.maxLength,
        isStrictMaxLength = _this$props5.isStrictMaxLength,
        onIconClick = _this$props5.onIconClick,
        onRightIconClick = _this$props5.onRightIconClick,
        v = _this$props5.value,
        autoFocus = _this$props5.autoFocus,
        pattern = _this$props5.pattern,
        patternInvalidMsg = _this$props5.patternInvalidMsg,
        isFocusedSelectAll = _this$props5.isFocusedSelectAll,
        onPressEnter = _this$props5.onPressEnter,
        onValid = _this$props5.onValid,
        onInvalid = _this$props5.onInvalid,
        onClear = _this$props5.onClear,
        onPasswordVisible = _this$props5.onPasswordVisible,
        onPasswordInvisible = _this$props5.onPasswordInvisible,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props5, _excluded),
        _this$state = this.state,
        value = _this$state.value,
        isFocused = _this$state.isFocused,
        passwordVisible = _this$state.passwordVisible,
        infoVisible = _this$state.infoVisible,
        errorVisible = _this$state.errorVisible,
        invalidMsgs = _this$state.invalidMsgs,
        isPassword = type === _FieldType["default"].PASSWORD;
      var inputType = type;
      if (inputType === _FieldType["default"].PASSWORD) {
        inputType = passwordVisible ? _FieldType["default"].TEXT : _FieldType["default"].PASSWORD;
      } else if (_Valid["default"].isNumberType(type)) {
        inputType = 'text';
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('text-area', !value || value.length <= 0 ? 'empty' : 'not-empty', invalidMsgs.length > 0 ? 'theme-error' : theme ? "theme-".concat(theme) : '', (0, _defineProperty2["default"])({
          password: isPassword,
          'has-icon': iconCls,
          'auto-height': autoHeight,
          focused: isFocused,
          'has-right-icon': rightIconCls,
          'has-word-count': wordCountVisible,
          'has-clear-button': clearButtonVisible
        }, className, className)),
        style: style,
        disabled: disabled
      }, iconCls ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('text-area-left-icon', {
          deactivated: !onIconClick
        }),
        iconCls: iconCls,
        disableTouchRipple: !onIconClick,
        onClick: onIconClick
      }) : null, placeholder && !value && !isFocused ? /*#__PURE__*/_react["default"].createElement("textarea", {
        className: (0, _classnames["default"])('text-area-placeholder', (0, _defineProperty2["default"])({}, placeholderClassName, placeholderClassName)),
        value: placeholder,
        disabled: true
      }) : null, /*#__PURE__*/_react["default"].createElement("textarea", (0, _extends2["default"])({}, restProps, {
        ref: this.input,
        className: (0, _classnames["default"])('text-area-input', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName)),
        type: inputType,
        value: value,
        maxLength: isStrictMaxLength ? maxLength : null,
        onChange: this.handleChange,
        onKeyDown: this.handleKeyDown,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        disabled: disabled
      })), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('password-visible-icon', {
          hidden: !isPassword || !passwordButtonVisible
        }),
        iconCls: passwordVisible ? 'fas fa-eye' : 'far fa-eye-slash',
        onClick: this.togglePasswordVisible
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        ref: this.clearButton,
        className: (0, _classnames["default"])('clear-icon', {
          hidden: !clearButtonVisible || !value || value.length < 1
        }),
        iconCls: "fas fa-times-circle",
        onClick: this.clearValue
      }), rightIconCls ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('text-area-right-icon', {
          deactivated: !onRightIconClick
        }),
        rightIconCls: rightIconCls,
        disableTouchRipple: !onRightIconClick,
        onClick: this.handleRightIconClick
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('text-area-word-count', {
          error: value.length > maxLength
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "text-area-word-count-separator"
      }), wordCountVisible ? "".concat(value ? value.length : 0).concat(maxLength ? " / ".concat(maxLength) : '') : null), fieldMsgVisible && infoVisible && infoMsg ? /*#__PURE__*/_react["default"].createElement(_FieldMsg["default"], {
        type: "info",
        msg: infoMsg
      }) : null, fieldMsgVisible && errorVisible && invalidMsgs.length > 0 ? /*#__PURE__*/_react["default"].createElement(_FieldMsg["default"], {
        type: "error",
        msg: invalidMsgs.join(', ')
      }) : null, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return TextArea;
}(_react.Component);
(0, _defineProperty2["default"])(TextArea, "Type", _FieldType["default"]);
(0, _defineProperty2["default"])(TextArea, "Theme", _Theme["default"]);
TextArea.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the input element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * The CSS class name of the placeholder element.
   */
  placeholderClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The TextArea theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * Specifies the type of input to display such as "password" or "text".
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_FieldType["default"])),
  /**
   * The name of the text area.
   */
  name: _propTypes["default"].string,
  /**
   * The placeholder of the text area.
   */
  placeholder: _propTypes["default"].string,
  /**
   * The value of the TextArea.Type can be string or number.
   */
  value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Disables the textField if set to true.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the textField will can't editable.
   */
  readOnly: _propTypes["default"].bool,
  /**
   * If true,the textField will autoFocus.
   */
  autoFocus: _propTypes["default"].bool,
  /**
   * The message of the textField.
   */
  infoMsg: _propTypes["default"].string,
  /**
   * If true,clearButton will display when the textField is not empty.
   */
  clearButtonVisible: _propTypes["default"].bool,
  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * If true, passwordButton will display.
   */
  passwordButtonVisible: _propTypes["default"].bool,
  autoHeight: _propTypes["default"].bool,
  wordCountVisible: _propTypes["default"].bool,
  isStrictMaxLength: _propTypes["default"].bool,
  isFocusedSelectAll: _propTypes["default"].bool,
  // valid
  /**
   * If true,the textField must be required.
   */
  required: _propTypes["default"].bool,
  /**
   * The maximum length of textField to enter.
   */
  maxLength: _propTypes["default"].number,
  /**
   * Maximum number of textField that can be entered.
   */
  max: _propTypes["default"].number,
  /**
   * Minimum number of textField that can be entered.
   */
  min: _propTypes["default"].number,
  /**
   * The matching rule of textField.
   */
  pattern: _propTypes["default"].object,
  /**
   * The invalid message of textField.
   */
  patternInvalidMsg: _propTypes["default"].string,
  fieldMsgVisible: _propTypes["default"].bool,
  /**
   * Callback function fired when the textField is changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * Callback function fired when the press enter.
   */
  onPressEnter: _propTypes["default"].func,
  /**
   * Callback function fired when textField valid.
   */
  onValid: _propTypes["default"].func,
  /**
   * Callback function fired when textField invalid.
   */
  onInvalid: _propTypes["default"].func,
  /**
   * Callback function fired when textField focus.
   */
  onFocus: _propTypes["default"].func,
  /**
   * Callback function fired when textField blur.
   */
  onBlur: _propTypes["default"].func,
  /**
   * Callback function fired when textField clear.
   */
  onClear: _propTypes["default"].func,
  /**
   * Callback function fired when password visible.
   */
  onPasswordVisible: _propTypes["default"].func,
  /**
   * Callback function fired when password invisible.
   */
  onPasswordInvisible: _propTypes["default"].func,
  onIconClick: _propTypes["default"].func,
  onRightIconClick: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
TextArea.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  type: 'text',
  name: '',
  placeholder: '',
  value: '',
  iconCls: '',
  rightIconCls: '',
  disabled: false,
  readOnly: false,
  autoFocus: false,
  infoMsg: '',
  autoHeight: false,
  wordCountVisible: false,
  isStrictMaxLength: false,
  isFocusedSelectAll: false,
  clearButtonVisible: false,
  passwordButtonVisible: false,
  // valid
  required: false,
  patternInvalidMsg: '',
  fieldMsgVisible: false
};
var _default = TextArea;
exports["default"] = _default;