"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _FieldMsg = _interopRequireDefault(require("../FieldMsg"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _FieldType = _interopRequireDefault(require("../_statics/FieldType"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["children", "className", "triggerClassName", "placeholderClassName", "style", "theme", "type", "iconCls", "disabled", "infoMsg", "placeholder", "clearButtonVisible", "clearButtonIconCls", "rightIconCls", "passwordButtonVisible", "fieldMsgVisible", "maxLength", "isStrictMaxLength", "parentEl", "tip", "tipPosition", "onIconClick", "onRightIconClick", "value", "autoFocus", "pattern", "patternInvalidMsg", "isFocusedSelectAll", "preventBrowserAutoFill", "onPressEnter", "onValid", "onInvalid", "onClear", "onPasswordVisible", "onPasswordInvisible"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TextField = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TextField, _Component);
  var _super = _createSuper(TextField);
  function TextField(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TextField);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focus", function () {
      var _this$inputEl, _this$inputEl$focus;
      (_this$inputEl = _this.inputEl) === null || _this$inputEl === void 0 ? void 0 : (_this$inputEl$focus = _this$inputEl.focus) === null || _this$inputEl$focus === void 0 ? void 0 : _this$inputEl$focus.call(_this$inputEl);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "blur", function () {
      var _this$inputEl2, _this$inputEl2$blur;
      (_this$inputEl2 = _this.inputEl) === null || _this$inputEl2 === void 0 ? void 0 : (_this$inputEl2$blur = _this$inputEl2.blur) === null || _this$inputEl2$blur === void 0 ? void 0 : _this$inputEl2$blur.call(_this$inputEl2);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (e) {
      var _e$persist;
      e === null || e === void 0 ? void 0 : (_e$persist = e.persist) === null || _e$persist === void 0 ? void 0 : _e$persist.call(e);
      var value = e.target.value;
      var invalidMsgs = _Valid["default"].fieldValid(value, _this.props);
      _this.setState({
        value: value,
        invalidMsgs: invalidMsgs
      }, function () {
        var _this$props$onChange, _this$props, _this$props$onInvalid, _this$props2, _this$props$onValid, _this$props3;
        (_this$props$onChange = (_this$props = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props, value);
        (invalidMsgs === null || invalidMsgs === void 0 ? void 0 : invalidMsgs.length) > 0 ? (_this$props$onInvalid = (_this$props2 = _this.props).onInvalid) === null || _this$props$onInvalid === void 0 ? void 0 : _this$props$onInvalid.call(_this$props2) : (_this$props$onValid = (_this$props3 = _this.props).onValid) === null || _this$props$onValid === void 0 ? void 0 : _this$props$onValid.call(_this$props3);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyDown", function (e) {
      var _this$props$onKeyDown, _this$props4;
      var value = _this.state.value;
      (_this$props$onKeyDown = (_this$props4 = _this.props).onKeyDown) === null || _this$props$onKeyDown === void 0 ? void 0 : _this$props$onKeyDown.call(_this$props4, e, value);
      if (e.keyCode === 13) {
        var _this$props$onPressEn, _this$props5;
        (_this$props$onPressEn = (_this$props5 = _this.props).onPressEnter) === null || _this$props$onPressEn === void 0 ? void 0 : _this$props$onPressEn.call(_this$props5, e, value);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearValue", function () {
      var _this$props6 = _this.props,
        disabled = _this$props6.disabled,
        clearButtonVisible = _this$props6.clearButtonVisible;
      var invalidMsgs = _Valid["default"].fieldValid('', _this.props);
      !disabled && clearButtonVisible && _this.setState({
        value: '',
        invalidMsgs: invalidMsgs
      }, function () {
        var _this$props$onClear, _this$props7, _this$props$onChange2, _this$props8, _this$props$onInvalid2, _this$props9, _this$props$onValid2, _this$props10;
        _this.inputEl.value = '';
        _this.focus();
        (_this$props$onClear = (_this$props7 = _this.props).onClear) === null || _this$props$onClear === void 0 ? void 0 : _this$props$onClear.call(_this$props7);
        (_this$props$onChange2 = (_this$props8 = _this.props).onChange) === null || _this$props$onChange2 === void 0 ? void 0 : _this$props$onChange2.call(_this$props8, '');
        (invalidMsgs === null || invalidMsgs === void 0 ? void 0 : invalidMsgs.length) > 0 ? (_this$props$onInvalid2 = (_this$props9 = _this.props).onInvalid) === null || _this$props$onInvalid2 === void 0 ? void 0 : _this$props$onInvalid2.call(_this$props9) : (_this$props$onValid2 = (_this$props10 = _this.props).onValid) === null || _this$props$onValid2 === void 0 ? void 0 : _this$props$onValid2.call(_this$props10);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePasswordVisible", function () {
      var _this$props11 = _this.props,
        disabled = _this$props11.disabled,
        passwordButtonVisible = _this$props11.passwordButtonVisible;
      var passwordVisible = !_this.state.passwordVisible;
      !disabled && passwordButtonVisible && _this.setState({
        passwordVisible: passwordVisible
      }, function () {
        var _this$props$onPasswor, _this$props12, _this$props$onPasswor2, _this$props13;
        _this.focus();
        passwordVisible ? (_this$props$onPasswor = (_this$props12 = _this.props).onPasswordVisible) === null || _this$props$onPasswor === void 0 ? void 0 : _this$props$onPasswor.call(_this$props12) : (_this$props$onPasswor2 = (_this$props13 = _this.props).onPasswordInvisible) === null || _this$props$onPasswor2 === void 0 ? void 0 : _this$props$onPasswor2.call(_this$props13);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function (e) {
      _this.setState({
        infoVisible: true,
        errorVisible: true
      }, function () {
        var _this$props$onMouseOv, _this$props14;
        return (_this$props$onMouseOv = (_this$props14 = _this.props).onMouseOver) === null || _this$props$onMouseOv === void 0 ? void 0 : _this$props$onMouseOv.call(_this$props14, e, _this.state.value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      _this.setState({
        infoVisible: false,
        errorVisible: false
      }, function () {
        var _this$props$onMouseOu, _this$props15;
        return (_this$props$onMouseOu = (_this$props15 = _this.props).onMouseOut) === null || _this$props$onMouseOu === void 0 ? void 0 : _this$props$onMouseOu.call(_this$props15, e, _this.state.value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function (e) {
      var state = {
        isFocused: true
      };
      if (_this.props.preventBrowserAutoFill) {
        state.readOnly = !!_this.props.readOnly;
      }
      _this.setState(state, function () {
        var _this$props$onFocus, _this$props16, _this$inputEl3, _this$inputEl3$setSel;
        var isFocusedSelectAll = _this.props.isFocusedSelectAll;
        var value = _this.state.value;
        (_this$props$onFocus = (_this$props16 = _this.props).onFocus) === null || _this$props$onFocus === void 0 ? void 0 : _this$props$onFocus.call(_this$props16, e, value);
        isFocusedSelectAll && ((_this$inputEl3 = _this.inputEl) === null || _this$inputEl3 === void 0 ? void 0 : (_this$inputEl3$setSel = _this$inputEl3.setSelectionRange) === null || _this$inputEl3$setSel === void 0 ? void 0 : _this$inputEl3$setSel.call(_this$inputEl3, 0, value == null ? 0 : value.length));
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBlur", function (e) {
      var _this$clearButton;
      var clearButtonEl = (0, _reactDom.findDOMNode)((_this$clearButton = _this.clearButton) === null || _this$clearButton === void 0 ? void 0 : _this$clearButton.current);
      if (clearButtonEl && (e === null || e === void 0 ? void 0 : e.relatedTarget) === clearButtonEl) {
        return;
      }
      var state = {
        isFocused: false
      };
      if (_this.props.preventBrowserAutoFill) {
        state.readOnly = true;
      }
      _this.setState(state, function () {
        var _this$props17, _this$props17$onBlur;
        return (_this$props17 = _this.props) === null || _this$props17 === void 0 ? void 0 : (_this$props17$onBlur = _this$props17.onBlur) === null || _this$props17$onBlur === void 0 ? void 0 : _this$props17$onBlur.call(_this$props17, e, _this.state.value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRightIconClick", function (e) {
      var _this$props$onRightIc, _this$props18;
      (_this$props$onRightIc = (_this$props18 = _this.props).onRightIconClick) === null || _this$props$onRightIc === void 0 ? void 0 : _this$props$onRightIc.call(_this$props18, e, _this.state.value);
    });
    _this.input = /*#__PURE__*/(0, _react.createRef)();
    _this.inputEl = null;
    _this.clearButton = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      value: props.value,
      isFocused: !!props.autoFocus,
      readOnly: props.preventBrowserAutoFill ? true : !!props.readOnly,
      passwordVisible: false,
      infoVisible: false,
      errorVisible: false,
      invalidMsgs: ''
    };
    return _this;
  }
  (0, _createClass2["default"])(TextField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$input;
      this.inputEl = (_this$input = this.input) === null || _this$input === void 0 ? void 0 : _this$input.current;
      if (this.props.autoFocus === true) {
        this.focus();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      // Update password input value
      if (this.props.type === _FieldType["default"].PASSWORD && prevProps.value !== this.props.value && this.inputEl) {
        this.inputEl.value = this.props.value;
      }
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _this$props19 = this.props,
        children = _this$props19.children,
        className = _this$props19.className,
        triggerClassName = _this$props19.triggerClassName,
        placeholderClassName = _this$props19.placeholderClassName,
        style = _this$props19.style,
        theme = _this$props19.theme,
        type = _this$props19.type,
        iconCls = _this$props19.iconCls,
        disabled = _this$props19.disabled,
        infoMsg = _this$props19.infoMsg,
        placeholder = _this$props19.placeholder,
        clearButtonVisible = _this$props19.clearButtonVisible,
        clearButtonIconCls = _this$props19.clearButtonIconCls,
        rightIconCls = _this$props19.rightIconCls,
        passwordButtonVisible = _this$props19.passwordButtonVisible,
        fieldMsgVisible = _this$props19.fieldMsgVisible,
        maxLength = _this$props19.maxLength,
        isStrictMaxLength = _this$props19.isStrictMaxLength,
        parentEl = _this$props19.parentEl,
        tip = _this$props19.tip,
        tipPosition = _this$props19.tipPosition,
        onIconClick = _this$props19.onIconClick,
        onRightIconClick = _this$props19.onRightIconClick,
        v = _this$props19.value,
        autoFocus = _this$props19.autoFocus,
        pattern = _this$props19.pattern,
        patternInvalidMsg = _this$props19.patternInvalidMsg,
        isFocusedSelectAll = _this$props19.isFocusedSelectAll,
        preventBrowserAutoFill = _this$props19.preventBrowserAutoFill,
        onPressEnter = _this$props19.onPressEnter,
        onValid = _this$props19.onValid,
        onInvalid = _this$props19.onInvalid,
        onClear = _this$props19.onClear,
        onPasswordVisible = _this$props19.onPasswordVisible,
        onPasswordInvisible = _this$props19.onPasswordInvisible,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props19, _excluded);
      var _this$state = this.state,
        value = _this$state.value,
        isFocused = _this$state.isFocused,
        readOnly = _this$state.readOnly,
        passwordVisible = _this$state.passwordVisible,
        infoVisible = _this$state.infoVisible,
        errorVisible = _this$state.errorVisible,
        invalidMsgs = _this$state.invalidMsgs;
      var isPassword = type === _FieldType["default"].PASSWORD;
      var empty = value == null || value.length <= 0;
      var inputType = type;
      if (inputType === _FieldType["default"].PASSWORD) {
        inputType = passwordVisible ? _FieldType["default"].TEXT : _FieldType["default"].PASSWORD;
      } else if (_Valid["default"].isNumberType(type)) {
        inputType = 'text';
      }
      var inputProps = _objectSpread(_objectSpread({}, restProps), {}, {
        ref: this.input,
        className: (0, _classnames["default"])('text-field-input', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName)),
        type: inputType,
        // value,
        disabled: disabled,
        readOnly: readOnly,
        maxLength: isStrictMaxLength ? maxLength : null,
        onChange: this.handleChange,
        onKeyDown: this.handleKeyDown,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      });
      if (type !== _FieldType["default"].PASSWORD) {
        inputProps.value = value == null ? '' : value;
      }
      return /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        parentEl: parentEl,
        position: tipPosition
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('text-field', empty ? 'empty' : 'not-empty', invalidMsgs && invalidMsgs.length > 0 ? ' theme-error' : theme ? " theme-".concat(theme) : '', (0, _defineProperty2["default"])({
          password: isPassword,
          'has-icon': iconCls,
          'has-right-icon': rightIconCls,
          focused: isFocused,
          'has-clear-button': clearButtonVisible
        }, className, className)),
        style: style,
        disabled: disabled
      }, iconCls ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('text-field-left-icon', {
          deactivated: !onIconClick
        }),
        iconCls: iconCls,
        disableTouchRipple: !onIconClick,
        onClick: onIconClick
      }) : null, placeholder !== '' && placeholder !== null && !isFocused && (value == null || value === '') ? /*#__PURE__*/_react["default"].createElement("input", {
        className: (0, _classnames["default"])('text-field-placeholder', (0, _defineProperty2["default"])({}, placeholderClassName, placeholderClassName)),
        value: placeholder,
        disabled: true
      }) : null, /*#__PURE__*/_react["default"].createElement("input", inputProps), clearButtonVisible ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        ref: this.clearButton,
        className: (0, _classnames["default"])('clear-icon', {
          hidden: disabled || value == null || value.length < 1
        }),
        iconCls: clearButtonIconCls,
        onClick: this.clearValue
      }) : null, isPassword && passwordButtonVisible ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "password-visible-icon",
        iconCls: passwordVisible ? 'fas fa-eye' : 'far fa-eye-slash',
        onClick: this.togglePasswordVisible
      }) : null, rightIconCls ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('text-field-right-icon', {
          deactivated: !onRightIconClick
        }),
        rightIconCls: rightIconCls,
        disableTouchRipple: !onRightIconClick,
        onClick: this.handleRightIconClick
      }) : null, /*#__PURE__*/_react["default"].createElement(_FieldMsg["default"], {
        type: "info",
        msg: infoMsg,
        visible: !!(fieldMsgVisible && infoVisible && infoMsg),
        triggerEl: this.inputEl,
        parentEl: parentEl,
        position: _FieldMsg["default"].Position.TOP_LEFT
      }), /*#__PURE__*/_react["default"].createElement(_FieldMsg["default"], {
        type: "error",
        msg: invalidMsgs && invalidMsgs.join(', '),
        visible: !!(fieldMsgVisible && errorVisible && invalidMsgs && invalidMsgs.length > 0),
        triggerEl: this.inputEl,
        parentEl: parentEl
      }), children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return TextField;
}(_react.Component);
(0, _defineProperty2["default"])(TextField, "Type", _FieldType["default"]);
(0, _defineProperty2["default"])(TextField, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(TextField, "TipPosition", _Position["default"]);
TextField.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the input element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * The CSS class name of the placeholder element.
   */
  placeholderClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The TextField theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * Specifies the type of input to display such as "password" or "text".
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_FieldType["default"])),
  /**
   * The name of the text field.
   */
  name: _propTypes["default"].string,
  /**
   * The placeholder of the text field.
   */
  placeholder: _propTypes["default"].string,
  /**
   * The value of the TextField.Type can be string or number.
   */
  value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Disables the textField if set to true.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the textField will can't editable.
   */
  readOnly: _propTypes["default"].bool,
  /**
   * If true,the textField will autoFocus.
   */
  autoFocus: _propTypes["default"].bool,
  /**
   * The message of the textField.
   */
  infoMsg: _propTypes["default"].string,
  isFocusedSelectAll: _propTypes["default"].bool,
  /**
   * If true,clearButton will display when the textField is not empty.
   */
  clearButtonVisible: _propTypes["default"].bool,
  clearButtonIconCls: _propTypes["default"].string,
  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * If true, passwordButton will display.
   */
  passwordButtonVisible: _propTypes["default"].bool,
  // valid
  /**
   * If true,the textField must be required.
   */
  required: _propTypes["default"].bool,
  /**
   * The maximum length of textField to enter.
   */
  maxLength: _propTypes["default"].number,
  /**
   * Maximum number of textField that can be entered.
   */
  max: _propTypes["default"].number,
  /**
   * Minimum number of textField that can be entered.
   */
  min: _propTypes["default"].number,
  /**
   * The matching rule of textField.
   */
  pattern: _propTypes["default"].object,
  /**
   * The invalid message of textField.
   */
  patternInvalidMsg: _propTypes["default"].string,
  isStrictMaxLength: _propTypes["default"].bool,
  fieldMsgVisible: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  preventBrowserAutoFill: _propTypes["default"].bool,
  /**
   * Callback function fired when the textField is changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * Callback function fired when key down.
   */
  onKeyDown: _propTypes["default"].func,
  /**
   * Callback function fired when press enter.
   */
  onPressEnter: _propTypes["default"].func,
  /**
   * Callback function fired when textField valid.
   */
  onValid: _propTypes["default"].func,
  /**
   * Callback function fired when textField invalid.
   */
  onInvalid: _propTypes["default"].func,
  /**
   * Callback function fired when textField focus.
   */
  onFocus: _propTypes["default"].func,
  /**
   * Callback function fired when textField blur.
   */
  onBlur: _propTypes["default"].func,
  /**
   * Callback function fired when textField clear.
   */
  onClear: _propTypes["default"].func,
  /**
   * Callback function fired when password visible.
   */
  onPasswordVisible: _propTypes["default"].func,
  /**
   * Callback function fired when password invisible.
   */
  onPasswordInvisible: _propTypes["default"].func,
  onIconClick: _propTypes["default"].func,
  onRightIconClick: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
TextField.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  type: 'text',
  disabled: false,
  readOnly: false,
  autoFocus: false,
  isFocusedSelectAll: false,
  clearButtonVisible: true,
  clearButtonIconCls: 'fas fa-times-circle',
  passwordButtonVisible: true,
  // valid
  required: false,
  tipPosition: _Position["default"].BOTTOM,
  autoComplete: 'off',
  autoCorrect: 'off',
  autoCapitalize: 'off',
  spellCheck: 'false',
  isStrictMaxLength: true,
  fieldMsgVisible: false,
  preventBrowserAutoFill: false
};
var _default = TextField;
exports["default"] = _default;