"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TimeLineItem = _interopRequireDefault(require("../_TimeLineItem"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TimeLine = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TimeLine, _Component);
  var _super = _createSuper(TimeLine);
  function TimeLine(props) {
    (0, _classCallCheck2["default"])(this, TimeLine);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    return _super.call.apply(_super, [this, props].concat(restArgs));
  }
  (0, _createClass2["default"])(TimeLine, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        data = _this$props.data,
        style = _this$props.style,
        className = _this$props.className;
      return /*#__PURE__*/_react["default"].createElement("ul", {
        className: (0, _classnames["default"])('time-line', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, data && data.map(function (item, index) {
        return /*#__PURE__*/_react["default"].createElement(_TimeLineItem["default"], {
          key: index,
          theme: item.theme,
          type: item.type,
          title: item.title,
          date: item.date,
          hasBorder: item.hasBorder,
          contentText: item.contentText,
          headerText: item.headerText
        });
      }));
    }
  }]);
  return TimeLine;
}(_react.Component);
(0, _defineProperty2["default"])(TimeLine, "Type", _TimeLineItem["default"].Type);
(0, _defineProperty2["default"])(TimeLine, "Theme", _Theme["default"]);
TimeLine.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The items' data.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The TimeLine theme.Can be primary,highlight,success,warning,error.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The TimeLine type.Can be header or title.
     */
    type: _propTypes["default"].string,
    /**
     * The text value of TimeLine header.
     */
    headerText: _propTypes["default"].string,
    /**
     * The date value of TimeLine.
     */
    date: _propTypes["default"].string,
    /**
     * If true,the right content will have border style.
     */
    hasBorder: _propTypes["default"].bool,
    /**
     * The text value of right content.
     */
    contentText: _propTypes["default"].string
  })).isRequired
};
TimeLine.defaultProps = {
  hasBorder: true,
  title: '',
  type: ''
};
var _default = TimeLine;
exports["default"] = _default;