"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Dropdown = _interopRequireDefault(require("../Dropdown"));
var _Tree = _interopRequireDefault(require("../Tree"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TreeCalculation = _interopRequireDefault(require("../_vendors/TreeCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _excluded = ["className", "triggerClassName", "popupClassName", "style", "name", "data", "popupTheme", "renderer", "selectMode", "valueField", "displayField", "descriptionField", "triggerRenderer", "useFilter", "filterIconCls", "filterPlaceholder", "useSelectAll", "selectAllText", "isSelectRecursive", "allowCollapse", "collapsed", "indentWidth", "onNodeClick", "popupChildren", "noMatchedMsg", "isNodeCollapsed", "collapsedIconCls", "expandedIconCls", "radioUncheckedIconCls", "radioCheckedIconCls", "checkboxUncheckedIconCls", "checkboxCheckedIconCls", "checkboxIndeterminateIconCls", "value", "onChange"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TreeSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TreeSelect, _Component);
  var _super = _createSuper(TreeSelect);
  function TreeSelect(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TreeSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.dropdownInstance && _this.dropdownInstance.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.dropdownInstance && _this.dropdownInstance.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.dropdownInstance && _this.dropdownInstance.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      _this.dropdownInstance && _this.dropdownInstance.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      _this.dropdownInstance && _this.dropdownInstance.openPopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.dropdownInstance && _this.dropdownInstance.closePopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getTriggerValue", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;
      var data = props.data,
        selectMode = props.selectMode,
        placeholder = props.placeholder,
        triggerRenderer = props.triggerRenderer,
        renderer = props.renderer,
        displayField = props.displayField,
        valueField = props.valueField,
        _this$state = _this.state,
        value = _this$state.value,
        path = _this$state.path,
        isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT;
      if (triggerRenderer) {
        return typeof triggerRenderer === 'function' ? triggerRenderer(value, path) : triggerRenderer;
      }
      if (!value) {
        return placeholder;
      }
      if (isMultiSelect) {
        return value.length > 0 ? value.length + ' selected' : placeholder;
      }
      var result = [];
      function addNode(node, i) {
        result.push(renderer ? /*#__PURE__*/_react["default"].createElement("div", {
          key: 2 * i + 1,
          className: "tree-select-trigger-value-node"
        }, renderer(node, path && path.slice(0, i + 1))) : _Util["default"].getTextByDisplayField(node, displayField, valueField));
      }
      addNode(data, -1);
      if (path) {
        for (var i = 0, len = path.length; i < len; i++) {
          result.push( /*#__PURE__*/_react["default"].createElement("i", {
            key: 2 * i,
            className: "fas fa-angle-right tree-select-trigger-value-separator"
          }));
          addNode(path[i].node, i);
        }
      }
      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateScrollHeight", function () {
      if (!_this.scroller || !_this.scroller.current) {
        return;
      }
      var popEl = _Dom["default"].findParentByClassName(_this.scroller.current, 'tree-select-popup');
      if (!popEl) {
        return;
      }
      var scrollerHeight = popEl.offsetHeight;
      if (_this.actions && _this.actions.current && _this.actions.current.offsetHeight) {
        scrollerHeight -= _this.actions.current.offsetHeight;
      }
      _this.setState({
        scrollerHeight: scrollerHeight
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeSelect", function (node, path, e) {
      if (!node) {
        return;
      }
      var _this$props = _this.props,
        selectMode = _this$props.selectMode,
        isSelectRecursive = _this$props.isSelectRecursive,
        value = _this.state.value,
        state = {};
      var result = null;
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        result = value && (0, _isArray["default"])(value) ? value.slice() : [];
        if (isSelectRecursive) {
          _TreeCalculation["default"].addRecursiveValue(node, result, _this.props);
          result = _TreeCalculation["default"].updateValue(result, _this.props);
        } else {
          result.push(node);
        }
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        result = node;
        state.path = path;
      }
      _this.setState(state, function () {
        var onNodeSelect = _this.props.onNodeSelect;
        onNodeSelect && onNodeSelect(node, path, e);
        _this.handleChange(result);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeDeselect", function (node, path, e) {
      var selectMode = _this.props.selectMode;
      if (!node || selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var isSelectRecursive = _this.props.isSelectRecursive,
        value = _this.state.value;
      var result = value ? value.slice() : value;
      if (!result || !(0, _isArray["default"])(result)) {
        result = [];
      } else {
        if (isSelectRecursive) {
          _TreeCalculation["default"].removeRecursiveValue(node, result, _this.props);
          result = _TreeCalculation["default"].updateValue(result, _this.props);
        } else {
          var index = _Calculation["default"].getMultiSelectItemIndex(node, result, _this.props);
          if (index > -1) {
            result.splice(index, 1);
          }
        }
      }
      var onNodeDeselect = _this.props.onNodeDeselect;
      onNodeDeselect && onNodeDeselect(node, path, e);
      _this.handleChange(result);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var autoClose = _this.props.autoClose;
      if (autoClose) {
        _this.closePopup();
      }
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupOpen", function (e) {
      var _this$props2 = _this.props,
        useFilter = _this$props2.useFilter,
        onOpenPopup = _this$props2.onOpenPopup;
      if (useFilter) {
        _this.filter && _this.filter.current && _this.filter.current.focus();
      }
      _this.updateScrollHeight();
      onOpenPopup && onOpenPopup(e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupClosed", function (e) {
      _this.setState({
        popupVisible: false
      }, function () {
        var onClosePopup = _this.props.onClosePopup;
        onClosePopup && onClosePopup(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (filter) {
      _this.setState({
        filter: filter
      }, function () {
        _this.dropdownInstance && _this.dropdownInstance.resetPopupPosition();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectAllClick", function () {
      var value = _this.state.value,
        data = _this.data || _this.props.data;
      if (_this.isCheckedAll) {
        _this.handleChange(_TreeCalculation["default"].removeAllNode(data, value, _this.props));
        return;
      }
      var result = value || [];
      _TreeCalculation["default"].addRecursiveValue((0, _isArray["default"])(data) ? {
        children: data
      } : data, result, _this.props);
      _this.handleChange(_TreeCalculation["default"].updateValue(result, _this.props));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isEmpty", function () {
      var _ref;
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.data || _this.props.data;
      if (!filter) {
        return !data;
      }
      var displayField = _this.props.displayField;
      var result = true;
      _Util["default"].preOrderTraverse((0, _isArray["default"])(data) ? (_ref = {}, (0, _defineProperty2["default"])(_ref, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref, "children", data), _ref) : data, function (node) {
        if (node && !!node[displayField] && node[displayField].toString().toUpperCase().includes(filter.toUpperCase())) {
          return result = false;
        }
      });
      return result;
    });
    _this.dropdown = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdownInstance = null;
    _this.actions = /*#__PURE__*/(0, _react.createRef)();
    _this.filter = /*#__PURE__*/(0, _react.createRef)();
    _this.scroller = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      filter: '',
      value: _props.value,
      popupVisible: false,
      scrollerHeight: 'auto',
      path: _props.selectMode === _SelectMode["default"].SINGLE_SELECT ? _TreeCalculation["default"].calPath(_props.value, _props.data, _props) : undefined
    };
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(TreeSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdownInstance = this.dropdown && this.dropdown.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        triggerClassName = _this$props3.triggerClassName,
        popupClassName = _this$props3.popupClassName,
        style = _this$props3.style,
        name = _this$props3.name,
        data = _this$props3.data,
        popupTheme = _this$props3.popupTheme,
        renderer = _this$props3.renderer,
        selectMode = _this$props3.selectMode,
        valueField = _this$props3.valueField,
        displayField = _this$props3.displayField,
        descriptionField = _this$props3.descriptionField,
        triggerRenderer = _this$props3.triggerRenderer,
        useFilter = _this$props3.useFilter,
        filterIconCls = _this$props3.filterIconCls,
        filterPlaceholder = _this$props3.filterPlaceholder,
        useSelectAll = _this$props3.useSelectAll,
        selectAllText = _this$props3.selectAllText,
        isSelectRecursive = _this$props3.isSelectRecursive,
        allowCollapse = _this$props3.allowCollapse,
        collapsed = _this$props3.collapsed,
        indentWidth = _this$props3.indentWidth,
        onNodeClick = _this$props3.onNodeClick,
        popupChildren = _this$props3.popupChildren,
        noMatchedMsg = _this$props3.noMatchedMsg,
        isNodeCollapsed = _this$props3.isNodeCollapsed,
        collapsedIconCls = _this$props3.collapsedIconCls,
        expandedIconCls = _this$props3.expandedIconCls,
        radioUncheckedIconCls = _this$props3.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props3.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props3.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props3.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props3.checkboxIndeterminateIconCls,
        v = _this$props3.value,
        onChange = _this$props3.onChange,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props3, _excluded),
        _this$state2 = this.state,
        value = _this$state2.value,
        filter = _this$state2.filter,
        popupVisible = _this$state2.popupVisible,
        scrollerHeight = _this$state2.scrollerHeight,
        isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT;
      this.data = _TreeCalculation["default"].filterData(data, filter, this.props);
      this.total = _TreeCalculation["default"].getTotalCount(this.data);
      if (isMultiSelect) {
        this.isCheckedAll = _TreeCalculation["default"].isCheckedAll(this.data, value, this.props);
        this.isCheckedIndeterminate = _TreeCalculation["default"].isCheckedIndeterminate(this.data, value, this.props);
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('tree-select', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, name ? /*#__PURE__*/_react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        triggerClassName: (0, _classnames["default"])((0, _defineProperty2["default"])({
          activated: popupVisible,
          empty: !triggerRenderer && (!value || value.length < 1)
        }, triggerClassName, triggerClassName)),
        popupClassName: (0, _classnames["default"])('tree-select-popup', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        popupTheme: popupTheme,
        triggerValue: this.getTriggerValue(),
        onOpenPopup: this.handlePopupOpen,
        onClosePopup: this.handlePopupClosed
      }), useFilter || isMultiSelect && useSelectAll ? /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.actions,
        className: "tree-select-popup-actions"
      }, useFilter ? /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.filter,
        className: "tree-select-filter",
        value: filter,
        placeholder: filterPlaceholder,
        rightIconCls: filterIconCls,
        onChange: this.handleFilterChange
      }) : null, isMultiSelect && useSelectAll ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "tree-node tree-select-all-wrapper",
        style: {
          padding: "0 ".concat(indentWidth, "px")
        },
        onClick: this.handleSelectAllClick
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "tree-node-inner"
      }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        className: "tree-node-select",
        checked: this.isCheckedAll,
        indeterminate: this.isCheckedIndeterminate,
        uncheckedIconCls: checkboxUncheckedIconCls,
        checkedIconCls: checkboxCheckedIconCls,
        indeterminateIconCls: checkboxIndeterminateIconCls
      }), selectAllText)) : null) : null, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.scroller,
        className: "tree-select-list-scroller",
        style: {
          height: scrollerHeight
        }
      }, this.isEmpty() ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "no-matched"
      }, noMatchedMsg ? noMatchedMsg : /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-exclamation-triangle no-matched-icon"
      }), "No matched value.")) : /*#__PURE__*/_react["default"].createElement(_Tree["default"], {
        className: "tree-select-list",
        theme: popupTheme,
        selectMode: selectMode,
        data: this.data,
        value: value,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        isSelectRecursive: isSelectRecursive,
        allowCollapse: allowCollapse,
        collapsed: collapsed,
        indentWidth: indentWidth,
        collapsedIconCls: collapsedIconCls,
        expandedIconCls: expandedIconCls,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        renderer: renderer,
        isNodeCollapsed: isNodeCollapsed,
        onNodeClick: onNodeClick,
        onNodeSelect: this.handleNodeSelect,
        onNodeDeselect: this.handleNodeDeselect
        // onChange={this.handleChange}
      })), popupChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return TreeSelect;
}(_react.Component);
(0, _defineProperty2["default"])(TreeSelect, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TreeSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(TreeSelect, "Position", _Position["default"]);
(0, _defineProperty2["default"])(TreeSelect, "TipPosition", _Position["default"]);
TreeSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the dropDownSelect.
   */
  name: _propTypes["default"].string,
  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,
  /**
   * The placeholder of the dropDownSelect.
   */
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  triggerValue: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  /**
   * The options data.
   */
  data: _propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the tree node.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the tree node.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the tree button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the tree button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The tree node's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the tree node. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true,the tree node will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * The message of tip.
     */
    title: _propTypes["default"].string,
    children: _propTypes["default"].array,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a tree node touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].array]),
  /**
   * The invalid message of dropDownSelect.
   */
  invalidMsg: _propTypes["default"].string,
  /**
   * If true,the dropDownSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The select mode of listItem.Can be normal,checkbox.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * The message of the dropDownSelect.
   */
  infoMsg: _propTypes["default"].string,
  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,
  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  useFilter: _propTypes["default"].bool,
  filterIconCls: _propTypes["default"].string,
  filterPlaceholder: _propTypes["default"].string,
  useSelectAll: _propTypes["default"].bool,
  selectAllText: _propTypes["default"].string,
  noMatchedMsg: _propTypes["default"].string,
  isSelectRecursive: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  autoPopupWidth: _propTypes["default"].bool,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  resetPopPositionWait: _propTypes["default"].number,
  indentWidth: _propTypes["default"].number,
  renderer: _propTypes["default"].func,
  triggerRenderer: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onNodeClick: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is closed.
   */
  onClosePopup: _propTypes["default"].func,
  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  isNodeCollapsed: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onOpenPopup: _propTypes["default"].func,
  onNodeSelect: _propTypes["default"].func,
  onNodeDeselect: _propTypes["default"].func
};
TreeSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  disabled: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  tipPosition: _Position["default"].BOTTOM,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: true,
  useFilter: false,
  filterIconCls: 'fas fa-search',
  filterPlaceholder: 'Search ...',
  useSelectAll: false,
  selectAllText: 'Select All',
  isSelectRecursive: false,
  allowCollapse: true,
  collapsed: false,
  autoPopupWidth: true,
  resetPopPositionWait: 250,
  indentWidth: 20
};
var _default = TreeSelect;
exports["default"] = _default;