"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Radio = _interopRequireDefault(require("../Radio"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DraggableListItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DraggableListItem, _Component);
  var _super = _createSuper(DraggableListItem);
  function DraggableListItem(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DraggableListItem);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxChange", function (checked) {
      if (checked) {
        var _this$props$onSelect, _this$props;
        (_this$props$onSelect = (_this$props = _this.props).onSelect) === null || _this$props$onSelect === void 0 ? void 0 : _this$props$onSelect.call(_this$props);
      } else {
        var _this$props$onDeselec, _this$props2;
        (_this$props$onDeselec = (_this$props2 = _this.props).onDeselect) === null || _this$props$onDeselec === void 0 ? void 0 : _this$props$onDeselec.call(_this$props2);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioChange", function () {
      if (!_this.props.checked) {
        var _this$props$onSelect2, _this$props3;
        (_this$props$onSelect2 = (_this$props3 = _this.props).onSelect) === null || _this$props$onSelect2 === void 0 ? void 0 : _this$props$onSelect2.call(_this$props3);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props$onClick, _this$props5;
      e.preventDefault();
      var _this$props4 = _this.props,
        disabled = _this$props4.disabled,
        isLoading = _this$props4.isLoading,
        readOnly = _this$props4.readOnly;
      if (disabled || isLoading || readOnly) {
        return;
      }
      (_this$props$onClick = (_this$props5 = _this.props).onClick) === null || _this$props$onClick === void 0 ? void 0 : _this$props$onClick.call(_this$props5, e);
      switch (_this.props.selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleCheckboxChange(!_this.props.checked);
          return;
        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleRadioChange();
          return;
      }
    });
    return _this;
  }
  (0, _createClass2["default"])(DraggableListItem, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props6 = this.props,
        index = _this$props6.index,
        className = _this$props6.className,
        style = _this$props6.style,
        theme = _this$props6.theme,
        data = _this$props6.data,
        text = _this$props6.text,
        desc = _this$props6.desc,
        title = _this$props6.title,
        iconCls = _this$props6.iconCls,
        rightIconCls = _this$props6.rightIconCls,
        tip = _this$props6.tip,
        tipPosition = _this$props6.tipPosition,
        disabled = _this$props6.disabled,
        isLoading = _this$props6.isLoading,
        renderer = _this$props6.renderer,
        itemRenderer = _this$props6.itemRenderer,
        readOnly = _this$props6.readOnly,
        isDragDisabled = _this$props6.isDragDisabled,
        anchorIconCls = _this$props6.anchorIconCls,
        checked = _this$props6.checked,
        selectTheme = _this$props6.selectTheme,
        selectMode = _this$props6.selectMode,
        radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props6.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
        onMouseEnter = _this$props6.onMouseEnter,
        onMouseLeave = _this$props6.onMouseLeave,
        loadingIconPosition = rightIconCls && !iconCls ? 'right' : 'left';
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Draggable, {
        key: index,
        draggableId: '' + index,
        index: index,
        isDragDisabled: isDragDisabled
      }, function (dragProvided, dragSnapshot) {
        var _classNames;
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
          ref: dragProvided.innerRef,
          style: dragProvided.draggableStyle
        }, dragProvided.draggableProps, dragProvided.dragHandleProps), /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
          className: "block",
          tipContent: tip,
          position: tipPosition
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])('draggable-list-item', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "activated", checked), (0, _defineProperty2["default"])(_classNames, "dragging", dragSnapshot.isDragging), (0, _defineProperty2["default"])(_classNames, 'drag-disabled', isDragDisabled), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
          style: style,
          disabled: disabled || isLoading,
          readOnly: readOnly,
          title: title,
          onClick: _this2.handleClick,
          onMouseEnter: onMouseEnter,
          onMouseLeave: onMouseLeave
        }, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          className: "draggable-list-item-select",
          theme: selectTheme,
          checked: checked,
          disabled: disabled || isLoading,
          uncheckedIconCls: radioUncheckedIconCls,
          checkedIconCls: radioCheckedIconCls,
          disableTouchRipple: true
        }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          className: "draggable-list-item-select",
          theme: selectTheme,
          checked: checked,
          disabled: disabled || isLoading,
          uncheckedIconCls: checkboxUncheckedIconCls,
          checkedIconCls: checkboxCheckedIconCls,
          indeterminateIconCls: checkboxIndeterminateIconCls,
          disableTouchRipple: true
        }) : null, isLoading && loadingIconPosition === 'left' ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "button-icon button-icon-left"
        }, /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
          className: "button-loading-icon",
          size: "small"
        })) : iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
          className: "button-icon button-icon-left ".concat(iconCls),
          "aria-hidden": "true"
        }) : null, itemRenderer && typeof itemRenderer === 'function' ? itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index) : desc ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "draggable-list-item-content"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "draggable-list-item-content-value"
        }, text), /*#__PURE__*/_react["default"].createElement("div", {
          className: "draggable-list-item-content-desc"
        }, desc)) : text, isLoading && loadingIconPosition === 'right' ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
          className: "button-icon button-icon-right button-loading-icon",
          size: "small"
        }) : rightIconCls ? /*#__PURE__*/_react["default"].createElement("i", {
          className: "button-icon button-icon-right ".concat(rightIconCls),
          "aria-hidden": "true"
        }) : null, /*#__PURE__*/_react["default"].createElement("i", {
          className: "".concat(anchorIconCls, " draggable-list-item-anchor"),
          "aria-hidden": "true"
        })))), dragProvided.placeholder);
      });
    }
  }]);
  return DraggableListItem;
}(_react.Component);
(0, _defineProperty2["default"])(DraggableListItem, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DraggableListItem, "Theme", _Theme["default"]);
DraggableListItem.propTypes = {
  index: _propTypes["default"].number,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].object]),
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  text: _propTypes["default"].any,
  desc: _propTypes["default"].string,
  title: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  isDragDisabled: _propTypes["default"].bool,
  anchorIconCls: _propTypes["default"].string,
  itemRenderer: _propTypes["default"].func,
  renderer: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func
};
DraggableListItem.defaultProps = {
  index: 0,
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  disabled: false,
  isLoading: false,
  checked: false,
  readOnly: false,
  tipPosition: _Position["default"].BOTTOM,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  isDragDisabled: false,
  anchorIconCls: 'fas fa-bars'
};
var _default = DraggableListItem;
exports["default"] = _default;