"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _classnames = _interopRequireDefault(require("classnames"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Radio = _interopRequireDefault(require("../Radio"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DraggableTreeNode = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DraggableTreeNode, _Component);
  var _super = _createSuper(DraggableTreeNode);
  function DraggableTreeNode(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DraggableTreeNode);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isCollapsed", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;
      var data = props.data,
        isNodeCollapsed = props.isNodeCollapsed,
        collapsed = props.collapsed,
        index = props.index,
        depth = props.depth,
        path = props.path;
      if (data && data[_VirtualRoot["default"]]) {
        return false;
      }
      if (isNodeCollapsed) {
        if (typeof isNodeCollapsed === 'function') {
          return isNodeCollapsed(data, index, depth, path);
        } else {
          return !!isNodeCollapsed;
        }
      }
      return collapsed;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleTreeNode", function (e) {
      e && e.stopPropagation();
      var onNodeToggleStart = _this.props.onNodeToggleStart;
      onNodeToggleStart && onNodeToggleStart();
      _this.setState({
        collapsed: !_this.state.collapsed
      }, function () {
        var onNodeToggleEnd = _this.props.onNodeToggleEnd;
        onNodeToggleEnd && onNodeToggleEnd();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxChange", function (e) {
      var _this$props = _this.props,
        data = _this$props.data,
        path = _this$props.path,
        value = _this$props.value,
        onSelect = _this$props.onSelect,
        onDeselect = _this$props.onDeselect;
      if (!_Calculation["default"].isItemChecked(data, value, _this.props)) {
        onSelect && onSelect(data, path, e);
      } else {
        onDeselect && onDeselect(data, path, e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioChange", function (e) {
      var _this$props2 = _this.props,
        data = _this$props2.data,
        path = _this$props2.path,
        onSelect = _this$props2.onSelect;
      onSelect && onSelect(data, path, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      e.preventDefault();
      var _this$props3 = _this.props,
        data = _this$props3.data,
        path = _this$props3.path,
        disabled = _this$props3.disabled,
        isLoading = _this$props3.isLoading,
        readOnly = _this$props3.readOnly;
      if (disabled || isLoading || readOnly || data.disabled || data.isLoading || data.readOnly) {
        return;
      }
      var onClick = _this.props.onClick;
      onClick && onClick(data, path, e);
      var selectMode = _this.props.selectMode;
      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleCheckboxChange(e);
          return;
        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleRadioChange(e);
          return;
      }
    });
    _this.state = {
      collapsed: _this.isCollapsed(_props)
    };
    return _this;
  }
  (0, _createClass2["default"])(DraggableTreeNode, [{
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        index = _this$props4.index,
        depth = _this$props4.depth,
        path = _this$props4.path,
        theme = _this$props4.theme,
        selectTheme = _this$props4.selectTheme,
        selectMode = _this$props4.selectMode,
        data = _this$props4.data,
        value = _this$props4.value,
        disabled = _this$props4.disabled,
        isLoading = _this$props4.isLoading,
        readOnly = _this$props4.readOnly,
        allowCollapse = _this$props4.allowCollapse,
        isSelectRecursive = _this$props4.isSelectRecursive,
        valueField = _this$props4.valueField,
        displayField = _this$props4.displayField,
        descriptionField = _this$props4.descriptionField,
        collapsedIconCls = _this$props4.collapsedIconCls,
        expandedIconCls = _this$props4.expandedIconCls,
        radioUncheckedIconCls = _this$props4.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props4.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props4.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props4.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props4.checkboxIndeterminateIconCls,
        renderer = _this$props4.renderer,
        onMouseEnter = _this$props4.onMouseEnter,
        onMouseLeave = _this$props4.onMouseLeave,
        isDragging = _this$props4.isDragging,
        isNodeToggling = _this$props4.isNodeToggling,
        collapsed = this.state.collapsed,
        checked = _Calculation["default"].isItemChecked(data, value, this.props),
        isNodeLoading = data.isLoading || isLoading,
        isNodeDisabled = data.disabled || disabled || isNodeLoading,
        isVirtual = (_VirtualRoot["default"] in data),
        loadingIconPosition = data.rightIconCls && !data.iconCls ? 'right' : 'left';
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: '' + data.id,
        type: data.id,
        key: data.id
      }, function (dropProvided) {
        var _classNames;
        return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
          ref: dropProvided.innerRef,
          className: "draggable-tree-node-wrapper"
        }, dropProvided.droppableProps), isVirtual ? null : /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
          tipContent: data.tip,
          position: data.tipPosition
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])('draggable-tree-node', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "dragging", isDragging), (0, _defineProperty2["default"])(_classNames, data.className, data.className), _classNames)),
          style: _objectSpread(_objectSpread({}, data.style), {}, {
            paddingLeft: (depth + 1) * 20
          }),
          disabled: isNodeDisabled,
          readOnly: readOnly,
          onClick: _this2.handleClick,
          onMouseEnter: onMouseEnter,
          onMouseLeave: onMouseLeave
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "draggable-tree-node-inner"
        }, allowCollapse && data.children && data.children.length > 0 ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          className: "draggable-tree-node-collapse-icon",
          iconCls: collapsed ? data.collapsedIconCls || collapsedIconCls : data.expandedIconCls || expandedIconCls,
          onClick: _this2.toggleTreeNode
        }) : null, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          className: "draggable-tree-node-select",
          theme: selectTheme,
          checked: checked,
          disabled: isNodeDisabled,
          uncheckedIconCls: data.radioUncheckedIconCls || radioUncheckedIconCls,
          checkedIconCls: data.radioCheckedIconCls || radioCheckedIconCls,
          disableTouchRipple: true
        }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          className: "draggable-tree-node-select",
          theme: selectTheme,
          checked: checked,
          indeterminate: isSelectRecursive ? indeterminate : false,
          disabled: isNodeDisabled,
          uncheckedIconCls: data.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
          checkedIconCls: data.checkboxCheckedIconCls || checkboxCheckedIconCls,
          indeterminateIconCls: data.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
          disableTouchRipple: true
        }) : null, isNodeLoading && loadingIconPosition === 'left' ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "button-icon button-icon-left"
        }, /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
          className: "button-loading-icon",
          size: "small"
        })) : data.iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
          className: "button-icon button-icon-left ".concat(data.iconCls),
          "aria-hidden": "true"
        }) : null, data.itemRenderer && typeof data.itemRenderer === 'function' ? data.itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index) : data[descriptionField] ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "draggable-tree-node-content"
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "draggable-tree-node-content-value"
        }, _Util["default"].getTextByDisplayField(data, displayField, valueField)), /*#__PURE__*/_react["default"].createElement("span", {
          className: "draggable-tree-node-content-desc"
        }, data[descriptionField])) : _Util["default"].getTextByDisplayField(data, displayField, valueField), isNodeLoading && loadingIconPosition === 'right' ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
          className: "button-icon button-icon-right button-loading-icon",
          size: "small"
        }) : data.rightIconCls ? /*#__PURE__*/_react["default"].createElement("i", {
          className: "button-icon button-icon-right ".concat(data.rightIconCls),
          "aria-hidden": "true"
        }) : null))), data.children && data.children.length > 0 ? /*#__PURE__*/_react["default"].createElement("div", {
          className: 'draggable-tree-node-children' + (collapsed ? ' collapsed' : '')
        }, data.children.map(function (item, index) {
          var path = path ? [].concat(path, [{
            index: index,
            node: item
          }]) : [{
            index: index,
            node: item
          }];
          return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Draggable, {
            key: item.id,
            draggableId: '' + item.id,
            type: data.id,
            disableInteractiveElementBlocking: false,
            isDragDisabled: isNodeToggling || isNodeDisabled,
            index: index
          }, function (dragProvided, dragSnapshot) {
            return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
              ref: dragProvided.innerRef,
              style: dragProvided.draggableStyle
            }, dragProvided.draggableProps, dragProvided.dragHandleProps), /*#__PURE__*/_react["default"].createElement(DraggableTreeNode, (0, _extends2["default"])({}, _this2.props, {
              key: index,
              data: item,
              index: index,
              depth: depth + (isVirtual ? 0 : 1),
              path: path,
              isDragging: dragSnapshot.isDragging
            }))));
          });
        })) : null, dropProvided.placeholder);
      });
    }
  }]);
  return DraggableTreeNode;
}(_react.Component);
(0, _defineProperty2["default"])(DraggableTreeNode, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DraggableTreeNode, "Theme", _Theme["default"]);
DraggableTreeNode.propTypes = {
  index: _propTypes["default"].number,
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].object,
  value: _propTypes["default"].any,
  idField: _propTypes["default"].string,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  descriptionField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  isNodeToggling: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  renderer: _propTypes["default"].func,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onNodeToggleStart: _propTypes["default"].func,
  onNodeToggleEnd: _propTypes["default"].func,
  isDragging: _propTypes["default"].bool
};
DraggableTreeNode.defaultProps = {
  index: 0,
  depth: 0,
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  allowCollapse: true,
  collapsed: false,
  isNodeToggling: false,
  isSelectRecursive: false,
  tipPosition: _Position["default"].BOTTOM,
  collapsedIconCls: 'fas fa-caret-right',
  expandedIconCls: 'fas fa-caret-down',
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  isDragging: false
};
var _default = DraggableTreeNode;
exports["default"] = _default;