"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _TreeNode = _interopRequireDefault(require("../_TreeNode/TreeNode"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DraggableTreeNodeList = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DraggableTreeNodeList, _Component);
  var _super = _createSuper(DraggableTreeNodeList);
  function DraggableTreeNodeList(props) {
    (0, _classCallCheck2["default"])(this, DraggableTreeNodeList);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    return _super.call.apply(_super, [this, props].concat(restArgs));
  }
  (0, _createClass2["default"])(DraggableTreeNodeList, [{
    key: "render",
    value: function render() {
      var _this = this;
      var _this$props = this.props,
        depth = _this$props.depth,
        path = _this$props.path,
        data = _this$props.data,
        collapsed = _this$props.collapsed;
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "droppable"
      }, function (provided) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          ref: provided.innerRef,
          className: 'draggable-tree-node-list' + (collapsed ? ' collapsed' : '')
        }, data && data.length > 0 ? data.map(function (item, index) {
          return /*#__PURE__*/_react["default"].createElement(_TreeNode["default"], (0, _extends2["default"])({}, _this.props, {
            key: index,
            data: item,
            index: index,
            depth: depth + 1,
            path: path ? [].concat((0, _toConsumableArray2["default"])(path), [{
              index: index,
              value: item
            }]) : [{
              index: index,
              value: item
            }]
          }));
        }) : null, provided.placeholder);
      });
    }
  }]);
  return DraggableTreeNodeList;
}(_react.Component);
DraggableTreeNodeList.propTypes = {
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,
  data: _propTypes["default"].array,
  collapsed: _propTypes["default"].bool
};
DraggableTreeNodeList.defaultProps = {
  depth: -1,
  data: [],
  collapsed: false
};
var _default = DraggableTreeNodeList;
exports["default"] = _default;