"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Radio = _interopRequireDefault(require("../Radio"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var GridItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(GridItem, _Component);
  var _super = _createSuper(GridItem);
  function GridItem(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, GridItem);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxChange", function (checked) {
      var _this$props = _this.props,
        onSelect = _this$props.onSelect,
        onDeselect = _this$props.onDeselect;
      if (checked) {
        onSelect && onSelect();
      } else {
        onDeselect && onDeselect();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioChange", function () {
      if (!_this.props.checked) {
        var onSelect = _this.props.onSelect;
        onSelect && onSelect();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        isLoading = _this$props2.isLoading,
        readOnly = _this$props2.readOnly;
      if (disabled || isLoading || readOnly) {
        return;
      }
      var onClick = _this.props.onClick;
      onClick && onClick(e);
      switch (_this.props.selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleCheckboxChange(!_this.props.checked);
          return;
        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleRadioChange();
          return;
      }
    });
    return _this;
  }
  (0, _createClass2["default"])(GridItem, [{
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _classNames;
      var _this$props3 = this.props,
        index = _this$props3.index,
        className = _this$props3.className,
        style = _this$props3.style,
        theme = _this$props3.theme,
        data = _this$props3.data,
        text = _this$props3.text,
        desc = _this$props3.desc,
        iconCls = _this$props3.iconCls,
        rightIconCls = _this$props3.rightIconCls,
        tip = _this$props3.tip,
        tipPosition = _this$props3.tipPosition,
        disabled = _this$props3.disabled,
        isLoading = _this$props3.isLoading,
        disableTouchRipple = _this$props3.disableTouchRipple,
        rippleDisplayCenter = _this$props3.rippleDisplayCenter,
        renderer = _this$props3.renderer,
        itemRenderer = _this$props3.itemRenderer,
        readOnly = _this$props3.readOnly,
        col = _this$props3.col,
        parentEl = _this$props3.parentEl,
        checked = _this$props3.checked,
        selectTheme = _this$props3.selectTheme,
        selectMode = _this$props3.selectMode,
        radioUncheckedIconCls = _this$props3.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props3.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props3.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props3.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props3.checkboxIndeterminateIconCls,
        onMouseEnter = _this$props3.onMouseEnter,
        onMouseLeave = _this$props3.onMouseLeave,
        loadingIconPosition = rightIconCls && !iconCls ? 'right' : 'left';
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "grid-item-wrapper",
        style: col ? {
          width: "".concat(100 / col, "%")
        } : null
      }, /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        parentEl: parentEl,
        position: tipPosition
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('grid-item', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "activated", checked), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled || isLoading,
        readOnly: readOnly,
        onClick: this.handleClick,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      }, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
        className: "grid-item-select",
        theme: selectTheme,
        checked: checked,
        disabled: disabled || isLoading,
        uncheckedIconCls: radioUncheckedIconCls,
        checkedIconCls: radioCheckedIconCls,
        disableTouchRipple: true
      }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        className: "grid-item-select",
        theme: selectTheme,
        checked: checked,
        disabled: disabled || isLoading,
        uncheckedIconCls: checkboxUncheckedIconCls,
        checkedIconCls: checkboxCheckedIconCls,
        indeterminateIconCls: checkboxIndeterminateIconCls,
        disableTouchRipple: true
      }) : null, isLoading && loadingIconPosition === 'left' ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "button-icon button-icon-left"
      }, /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
        className: "button-loading-icon",
        size: "small"
      })) : iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "button-icon button-icon-left ".concat(iconCls),
        "aria-hidden": "true"
      }) : null, itemRenderer && typeof itemRenderer === 'function' ? itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index) : desc ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "grid-item-content"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "grid-item-content-value"
      }, text), /*#__PURE__*/_react["default"].createElement("div", {
        className: "grid-item-content-desc"
      }, desc)) : /*#__PURE__*/_react["default"].createElement("div", {
        className: "grid-item-content"
      }, text), isLoading && loadingIconPosition === 'right' ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
        className: "button-icon button-icon-right button-loading-icon",
        size: "small"
      }) : rightIconCls ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "button-icon button-icon-right ".concat(rightIconCls),
        "aria-hidden": "true"
      }) : null, disableTouchRipple || readOnly ? null : /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], {
        className: disabled || isLoading ? 'hidden' : '',
        displayCenter: rippleDisplayCenter
      }))));
    }
  }]);
  return GridItem;
}(_react.Component);
(0, _defineProperty2["default"])(GridItem, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(GridItem, "Theme", _Theme["default"]);
GridItem.propTypes = {
  index: _propTypes["default"].number,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].object]),
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  text: _propTypes["default"].any,
  desc: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  disableTouchRipple: _propTypes["default"].bool,
  rippleDisplayCenter: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  col: _propTypes["default"].number,
  itemRenderer: _propTypes["default"].func,
  renderer: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func
};
GridItem.defaultProps = {
  index: 0,
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  disabled: false,
  isLoading: false,
  disableTouchRipple: false,
  rippleDisplayCenter: false,
  checked: false,
  readOnly: false,
  tipPosition: _Position["default"].BOTTOM,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  col: 3
};
var _default = GridItem;
exports["default"] = _default;