"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Portal = _interopRequireDefault(require("../Portal"));
var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _excluded = ["children", "container", "modalClassName", "className", "parentEl", "isAnimated", "visible", "showModal", "onModalMouseDown", "onModalMouseMove", "onModalMouseUp", "onModalMouseEnter", "onModalMouseLeave", "onModalClick", "contentClassName", "position", "triggerEl", "resetPositionWait", "shouldResetPosition", "resetPosition", "onRender", "onRendered", "onDestroy", "onDestroyed"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Pop = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Pop, _Component);
  var _super = _createSuper(Pop);
  function Pop(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Pop);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));

    // this.scrollEl = null;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      return _this.state.transitionEl;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "debounceResetPosition", (0, _debounce["default"])(function () {
      var _this$props$resetPosi, _this$props;
      (_this$props$resetPosi = (_this$props = _this.props).resetPosition) === null || _this$props$resetPosi === void 0 ? void 0 : _this$props$resetPosi.call(_this$props, _this.state.transitionEl);
    }, _this.props.resetPositionWait));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEnter", function (el) {
      var _this$props2 = _this.props,
        triggerEl = _this$props2.triggerEl,
        shouldResetPosition = _this$props2.shouldResetPosition;
      if (shouldResetPosition) {
        var _this$props$resetPosi2, _this$props3;
        (_this$props$resetPosi2 = (_this$props3 = _this.props).resetPosition) === null || _this$props$resetPosi2 === void 0 ? void 0 : _this$props$resetPosi2.call(_this$props3, el);
      }
      _this.setState({
        enter: true,
        transitionEl: el
      }, function () {
        var _this$props$onRender, _this$props4;
        return (_this$props$onRender = (_this$props4 = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call(_this$props4, el, triggerEl);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEntered", function (el) {
      var _this$props5 = _this.props,
        triggerEl = _this$props5.triggerEl,
        onRendered = _this$props5.onRendered;
      onRendered === null || onRendered === void 0 ? void 0 : onRendered(el, triggerEl);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExit", function (el) {
      _this.setState({
        enter: false
      }, function () {
        var _this$props$onDestroy, _this$props6;
        return (_this$props$onDestroy = (_this$props6 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call(_this$props6, el, _this.props.triggerEl);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExited", function (el) {
      _this.setState({
        exited: true,
        transitionEl: null
      }, function () {
        var _this$props$onDestroy2, _this$props7;
        return (_this$props$onDestroy2 = (_this$props7 = _this.props).onDestroyed) === null || _this$props$onDestroy2 === void 0 ? void 0 : _this$props$onDestroy2.call(_this$props7, el, _this.props.triggerEl);
      });
    });
    _this.state = {
      enter: false,
      exited: true,
      transitionEl: null
    };
    return _this;
  }
  (0, _createClass2["default"])(Pop, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.shouldResetPosition) {
        _Event["default"].addEvent(window, 'resize', this.debounceResetPosition);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (this.props.shouldResetPosition && (prevProps.position !== this.props.position || prevProps.triggerEl !== this.props.triggerEl || prevState.transitionEl !== this.state.transitionEl)) {
        var _this$debounceResetPo;
        (_this$debounceResetPo = this.debounceResetPosition) === null || _this$debounceResetPo === void 0 ? void 0 : _this$debounceResetPo.call(this);
      }

      // if (!prevProps.visible && this.props.visible) {
      //     this.addWatchScroll();
      // } else if (prevProps.visible && !this.props.visible) {
      //     this.scrollEl && Event.removeEvent(this.scrollEl, 'scroll', this.debounceResetPosition);
      //     this.scrollEl = null;
      // }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.shouldResetPosition) {
        _Event["default"].removeEvent(window, 'resize', this.debounceResetPosition);
      }
    }

    /**
     * public
     */
  }, {
    key: "render",
    value:
    // addWatchScroll = () => {
    //
    //     const {triggerEl} = this.props;
    //
    //     if (!triggerEl) {
    //         return;
    //     }
    //
    //     const scrollEl = Dom.getClosestScrollable(triggerEl);
    //
    //     if (!scrollEl || scrollEl == document.body) {
    //         return;
    //     }
    //
    //     this.scrollEl = scrollEl;
    //
    //     Event.addEvent(scrollEl, 'scroll', this.debounceResetPosition);
    //
    // };

    function render() {
      var _this$props8 = this.props,
        children = _this$props8.children,
        container = _this$props8.container,
        modalClassName = _this$props8.modalClassName,
        className = _this$props8.className,
        parentEl = _this$props8.parentEl,
        isAnimated = _this$props8.isAnimated,
        visible = _this$props8.visible,
        showModal = _this$props8.showModal,
        onModalMouseDown = _this$props8.onModalMouseDown,
        onModalMouseMove = _this$props8.onModalMouseMove,
        onModalMouseUp = _this$props8.onModalMouseUp,
        onModalMouseEnter = _this$props8.onModalMouseEnter,
        onModalMouseLeave = _this$props8.onModalMouseLeave,
        onModalClick = _this$props8.onModalClick,
        contentClassName = _this$props8.contentClassName,
        position = _this$props8.position,
        triggerEl = _this$props8.triggerEl,
        resetPositionWait = _this$props8.resetPositionWait,
        shouldResetPosition = _this$props8.shouldResetPosition,
        resetPosition = _this$props8.resetPosition,
        onRender = _this$props8.onRender,
        onRendered = _this$props8.onRendered,
        onDestroy = _this$props8.onDestroy,
        onDestroyed = _this$props8.onDestroyed,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props8, _excluded);
      var _this$state = this.state,
        enter = _this$state.enter,
        exited = _this$state.exited,
        transitionEl = _this$state.transitionEl;
      return /*#__PURE__*/_react["default"].createElement(_Portal["default"], {
        visible: !exited,
        parentEl: parentEl
      }, showModal ? /*#__PURE__*/_react["default"].createElement(_Transition["default"], {
        appear: true,
        "in": visible,
        timeout: 250
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('pop-modal', (0, _defineProperty2["default"])({
          hidden: !enter,
          'pop-modal-animated': isAnimated
        }, modalClassName, modalClassName)),
        onMouseDown: onModalMouseDown,
        onMouseMove: onModalMouseMove,
        onMouseUp: onModalMouseUp,
        onMouseEnter: onModalMouseEnter,
        onMouseLeave: onModalMouseLeave,
        onClick: onModalClick
      })) : null, /*#__PURE__*/_react["default"].createElement(_Transition["default"], {
        appear: true,
        "in": visible,
        timeout: 250,
        onEnter: this.handleEnter,
        onEntered: this.handleEntered,
        onExit: this.handleExit,
        onExited: this.handleExited
      }, /*#__PURE__*/(0, _react.cloneElement)(container, _objectSpread(_objectSpread({}, restProps), {}, {
        className: (0, _classnames["default"])((0, _defineProperty2["default"])({
          hidden: !enter
        }, className, className)),
        children: typeof children === 'function' ? children(transitionEl) : children || null
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props) {
      var result = {
        prevProps: props
      };
      if (props.visible) {
        result.exited = !props.visible;
      }
      return result;
    }
  }]);
  return Pop;
}(_react.Component);
(0, _defineProperty2["default"])(Pop, "Position", _Position["default"]);
(0, _defineProperty2["default"])(Pop, "Theme", _Theme["default"]);
Pop.propTypes = {
  children: _propTypes["default"].any,
  container: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The trigger pop theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the trigger pop.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the trigger pop is visible.
   */
  visible: _propTypes["default"].bool,
  showModal: _propTypes["default"].bool,
  /**
   * The trigger pop alignment.The value can be Popup.Position.LEFT or Popup.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true,popup will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  resetPositionWait: _propTypes["default"].number,
  shouldResetPosition: _propTypes["default"].bool,
  /**
   * The function of popup render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of popup rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of popup destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of popup destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  resetPosition: _propTypes["default"].func,
  onModalMouseDown: _propTypes["default"].func,
  onModalMouseMove: _propTypes["default"].func,
  onModalMouseUp: _propTypes["default"].func,
  onModalMouseEnter: _propTypes["default"].func,
  onModalMouseLeave: _propTypes["default"].func,
  onModalClick: _propTypes["default"].func
};
Pop.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  parentEl: document.body,
  depth: 2,
  visible: false,
  showModal: false,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  shouldResetPosition: true,
  resetPositionWait: 250
};
var _default = Pop;
exports["default"] = _default;