"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _MeasureTr = _interopRequireDefault(require("../_MeasureTr"));
var _Tr = _interopRequireDefault(require("../_Tr"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _excluded = ["className", "style", "columns", "tableData", "dynamicRenderData", "startIndex", "disabled", "useDynamicRender", "isRowDisabled", "onColumnMeasure", "value"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Tbody = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Tbody, _Component);
  var _super = _createSuper(Tbody);
  function Tbody(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tbody);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemChecked", function (rowData) {
      var _this$props = _this.props,
        selectMode = _this$props.selectMode,
        idField = _this$props.idField,
        value = _this$props.value;
      if (!rowData || !value || selectMode === _SelectMode["default"].NORMAL) {
        return false;
      }
      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          return value && value.findIndex(function (item) {
            return item[idField] === rowData[idField];
          }) !== -1;
        case _SelectMode["default"].SINGLE_SELECT:
          return value[idField] === rowData[idField];
      }
    });
    return _this;
  }
  (0, _createClass2["default"])(Tbody, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !nextProps.resizingColumn;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        columns = _this$props2.columns,
        tableData = _this$props2.tableData,
        dynamicRenderData = _this$props2.dynamicRenderData,
        startIndex = _this$props2.startIndex,
        disabled = _this$props2.disabled,
        useDynamicRender = _this$props2.useDynamicRender,
        isRowDisabled = _this$props2.isRowDisabled,
        onColumnMeasure = _this$props2.onColumnMeasure,
        value = _this$props2.value,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      var finalData = (useDynamicRender ? dynamicRenderData : tableData) || [];
      return /*#__PURE__*/_react["default"].createElement("tbody", {
        className: className,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_MeasureTr["default"], {
        columns: columns,
        onColumnMeasure: onColumnMeasure
      }), finalData === null || finalData === void 0 ? void 0 : finalData.map(function (row, index) {
        return row ? /*#__PURE__*/_react["default"].createElement(_Tr["default"], (0, _extends2["default"])({}, restProps, {
          style: (row === null || row === void 0 ? void 0 : row.rowStyle) || null,
          key: index,
          index: index,
          rowIndex: startIndex + index,
          columns: columns,
          data: row,
          tableData: tableData,
          isChecked: _this2.isItemChecked(row),
          disabled: disabled || _TableCalculation["default"].isNodeDisabled(row, isRowDisabled),
          useDynamicRender: useDynamicRender
        })) : null;
      }));
    }
  }]);
  return Tbody;
}(_react.Component);
(0, _defineProperty2["default"])(Tbody, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tbody, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Tbody, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Tbody, "SortingType", _SortingType["default"]);
Tbody.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })).isRequired,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  dynamicRenderData: _propTypes["default"].array,
  value: _propTypes["default"].array,
  startIndex: _propTypes["default"].number,
  idField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isRowDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  expandRows: _propTypes["default"].array,
  ignoreColumnSpan: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  scrollHeight: _propTypes["default"].number,
  rowHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  resizingColumn: _propTypes["default"].object,
  /**
   * callback
   */
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  onCollapse: _propTypes["default"].func,
  onColumnMeasure: _propTypes["default"].func,
  onRequestColumnsSpan: _propTypes["default"].func
};
Tbody.defaultProps = {
  columnKeyField: 'key',
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  startIndex: 0,
  idField: 'id',
  disabled: false,
  expandRows: [],
  ignoreColumnSpan: false,
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  scrollHeight: 500,
  rowHeight: 50,
  scrollBuffer: 8,
  /**
   * column resizable
   */
  defaultColumnWidth: 100
};
var _default = Tbody;
exports["default"] = _default;