"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));
var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Toast = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Toast, _Component);
  var _super = _createSuper(Toast);
  function Toast(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Toast);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getIconCls", function () {
      switch (_this.props.type) {
        case _MsgType["default"].SUCCESS:
          return 'fas fa-check-circle';
        case _MsgType["default"].WARNING:
          return 'fas fa-exclamation-triangle';
        case _MsgType["default"].ERROR:
          return 'fas fa-times-circle';
        default:
          return 'fas fa-info-circle';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var _this$props = _this.props,
        onRequestClose = _this$props.onRequestClose,
        toastsId = _this$props.toastsId;
      onRequestClose === null || onRequestClose === void 0 ? void 0 : onRequestClose(toastsId);
    });
    _this.unrenderTimeout = null;

    /**
     * toast reference
     * @type {React.RefObject<unknown>}
     */
    _this.toast = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      hidden: true,
      leave: false
    };
    return _this;
  }
  (0, _createClass2["default"])(Toast, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$toast,
        _this2 = this;
      var _this$props2 = this.props,
        toastsId = _this$props2.toastsId,
        duration = _this$props2.duration,
        autoWidth = _this$props2.autoWidth,
        onRequestClose = _this$props2.onRequestClose;
      if (!autoWidth && (_this$toast = this.toast) !== null && _this$toast !== void 0 && _this$toast.current) {
        var toastEl = (0, _reactDom.findDOMNode)(this.toast.current);
        if (toastEl) {
          toastEl.style.width = toastEl.clientWidth + 'px';
          toastEl.style.height = toastEl.clientHeight + 'px';
        }
      }
      if (duration > 0) {
        this.unrenderTimeout = setTimeout(function () {
          _this2.setState({
            hidden: true
          }, function () {
            setTimeout(function () {
              _this2.setState({
                leave: true
              }, function () {
                setTimeout(function () {
                  onRequestClose === null || onRequestClose === void 0 ? void 0 : onRequestClose(toastsId);
                }, 250);
              });
            }, 250);
          });
        }, duration);
      }
      setTimeout(function () {
        _this2.setState({
          hidden: false
        });
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unrenderTimeout && clearTimeout(this.unrenderTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        type = _this$props3.type,
        message = _this$props3.message,
        iconCls = _this$props3.iconCls,
        autoWidth = _this$props3.autoWidth;
      var _this$state = this.state,
        hidden = _this$state.hidden,
        leave = _this$state.leave;
      return /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
        ref: this.toast,
        className: (0, _classnames["default"])('toast', (0, _defineProperty2["default"])({
          hidden: hidden,
          leave: leave,
          'auto-width': autoWidth
        }, className, className)),
        style: style,
        theme: type,
        iconCls: "".concat(iconCls ? iconCls : this.getIconCls(), " toast-icon"),
        value: message,
        onClick: this.handleClick
      });
    }
  }]);
  return Toast;
}(_react.Component);
(0, _defineProperty2["default"])(Toast, "Type", _MsgType["default"]);
Toast.propTypes = {
  /**
   * The CSS class name of toast.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the toast.
   */
  style: _propTypes["default"].object,
  toastsId: _propTypes["default"].number,
  /**
   * The type of toast.
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),
  /**
   * The message of toast.
   */
  message: _propTypes["default"].any,
  /**
   * The icon class name of toast.
   */
  iconCls: _propTypes["default"].string,
  /**
   * The duration of toast.
   */
  duration: _propTypes["default"].number,
  autoWidth: _propTypes["default"].bool,
  onRequestClose: _propTypes["default"].func
};
Toast.defaultProps = {
  toastsId: 0,
  type: _MsgType["default"].INFO,
  duration: 2500,
  autoWidth: false
};
var _default = Toast;
exports["default"] = _default;