"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Radio = _interopRequireDefault(require("../Radio"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TreeCalculation = _interopRequireDefault(require("../_vendors/TreeCalculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TreeNode = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TreeNode, _Component);
  var _super = _createSuper(TreeNode);
  function TreeNode(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TreeNode);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isNodeDisabled", function () {
      var _this$props$data;
      var isNodeLoading = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ((_this$props$data = _this.props.data) === null || _this$props$data === void 0 ? void 0 : _this$props$data.isLoading) || _this.props.isLoading;
      var _this$props = _this.props,
        data = _this$props.data,
        value = _this$props.value,
        treeData = _this$props.treeData,
        disabled = _this$props.disabled,
        nodeDisabled = _this$props.nodeDisabled;
      return data.disabled || disabled || isNodeLoading || nodeDisabled !== undefined && nodeDisabled !== null && (typeof nodeDisabled === 'function' ? nodeDisabled(data, value, treeData) : nodeDisabled);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isCollapsed", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;
      var data = props.data,
        isNodeCollapsed = props.isNodeCollapsed,
        collapsed = props.collapsed,
        index = props.index,
        depth = props.depth,
        path = props.path;
      if (data && data[_VirtualRoot["default"]]) {
        return false;
      }
      if (isNodeCollapsed) {
        if (typeof isNodeCollapsed === 'function') {
          return isNodeCollapsed(data, index, depth, path);
        } else {
          return !!isNodeCollapsed;
        }
      }
      return collapsed;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleTreeNode", function (e) {
      e && e.stopPropagation();
      var onNodeToggleStart = _this.props.onNodeToggleStart;
      onNodeToggleStart && onNodeToggleStart();
      _this.setState({
        collapsed: !_this.state.collapsed
      }, function () {
        var onNodeToggleEnd = _this.props.onNodeToggleEnd;
        onNodeToggleEnd && onNodeToggleEnd();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxChange", function (e) {
      var _this$props2 = _this.props,
        data = _this$props2.data,
        path = _this$props2.path,
        value = _this$props2.value,
        onSelect = _this$props2.onSelect,
        onDeselect = _this$props2.onDeselect;
      if (!_TreeCalculation["default"].isNodeChecked(data, value, _this.props)) {
        onSelect && onSelect(data, path, e);
      } else {
        onDeselect && onDeselect(data, path, e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioChange", function (e) {
      var _this$props3 = _this.props,
        data = _this$props3.data,
        path = _this$props3.path,
        onSelect = _this$props3.onSelect;
      onSelect && onSelect(data, path, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props4 = _this.props,
        data = _this$props4.data,
        path = _this$props4.path,
        readOnly = _this$props4.readOnly;
      if (readOnly || data.readOnly || _this.isNodeDisabled()) {
        return;
      }
      var _this$props5 = _this.props,
        selectMode = _this$props5.selectMode,
        onClick = _this$props5.onClick;
      onClick && onClick(data, path, e);
      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleCheckboxChange(e);
          return;
        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleRadioChange(e);
          return;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderChildren", function () {
      var _this$props6 = _this.props,
        depth = _this$props6.depth,
        path = _this$props6.path,
        data = _this$props6.data,
        collapsed = _this.state.collapsed,
        isVirtual = (_VirtualRoot["default"] in data);
      return !collapsed && data.children && data.children.length > 0 ? /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, data.children.map(function (item, index) {
        return /*#__PURE__*/_react["default"].createElement(TreeNode, (0, _extends2["default"])({}, _this.props, {
          key: index,
          data: item,
          index: index,
          depth: depth + (isVirtual ? 0 : 1),
          path: path ? [].concat((0, _toConsumableArray2["default"])(path), [{
            index: index,
            node: item
          }]) : [{
            index: index,
            node: item
          }]
        }));
      })) : null;
    });
    _this.state = {
      collapsed: _this.isCollapsed(_props)
    };
    return _this;
  }
  (0, _createClass2["default"])(TreeNode, [{
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _classNames;
      var data = this.props.data;
      if (_VirtualRoot["default"] in data) {
        return this.renderChildren();
      }
      var _this$props7 = this.props,
        index = _this$props7.index,
        depth = _this$props7.depth,
        theme = _this$props7.theme,
        selectTheme = _this$props7.selectTheme,
        selectMode = _this$props7.selectMode,
        value = _this$props7.value,
        isLoading = _this$props7.isLoading,
        allowCollapse = _this$props7.allowCollapse,
        isSelectRecursive = _this$props7.isSelectRecursive,
        indentWidth = _this$props7.indentWidth,
        valueField = _this$props7.valueField,
        displayField = _this$props7.displayField,
        descriptionField = _this$props7.descriptionField,
        collapsedIconCls = _this$props7.collapsedIconCls,
        expandedIconCls = _this$props7.expandedIconCls,
        radioUncheckedIconCls = _this$props7.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props7.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props7.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props7.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props7.checkboxIndeterminateIconCls,
        renderer = _this$props7.renderer,
        onMouseEnter = _this$props7.onMouseEnter,
        onMouseLeave = _this$props7.onMouseLeave,
        collapsed = this.state.collapsed,
        checked = _TreeCalculation["default"].isNodeChecked(data, value, this.props),
        indeterminate = _TreeCalculation["default"].isNodeCheckedIndeterminate(data, value, this.props),
        isNodeLoading = data.isLoading || isLoading,
        isNodeDisabled = this.isNodeDisabled(isNodeLoading),
        loadingIconPosition = data.rightIconCls && !data.iconCls ? 'right' : 'left';
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('tree-node', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, data.className, data.className), _classNames)),
        style: _objectSpread(_objectSpread({}, data.style), {}, {
          paddingLeft: (depth + 1) * indentWidth
        }),
        title: data.title,
        disabled: isNodeDisabled,
        onClick: this.handleClick,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "tree-node-inner"
      }, allowCollapse && data.children && data.children.length > 0 ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "tree-node-collapse-icon",
        iconCls: collapsed ? data.collapsedIconCls || collapsedIconCls : data.expandedIconCls || expandedIconCls,
        onClick: this.toggleTreeNode
      }) : null, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
        className: "tree-node-select",
        theme: selectTheme,
        checked: checked,
        disabled: isNodeDisabled,
        uncheckedIconCls: data.radioUncheckedIconCls || radioUncheckedIconCls,
        checkedIconCls: data.radioCheckedIconCls || radioCheckedIconCls,
        disableTouchRipple: true
      }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        className: "tree-node-select",
        theme: selectTheme,
        checked: checked,
        indeterminate: isSelectRecursive ? indeterminate : false,
        disabled: isNodeDisabled,
        uncheckedIconCls: data.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
        checkedIconCls: data.checkboxCheckedIconCls || checkboxCheckedIconCls,
        indeterminateIconCls: data.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
        disableTouchRipple: true
      }) : null, isNodeLoading && loadingIconPosition === 'left' ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "button-icon button-icon-left"
      }, /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
        className: "button-loading-icon",
        size: "small"
      })) : data.iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "button-icon button-icon-left ".concat(data.iconCls),
        "aria-hidden": "true"
      }) : null, data.itemRenderer && typeof data.itemRenderer === 'function' ? data.itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index, depth) : data[descriptionField] ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "tree-node-content"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "tree-node-content-value"
      }, _Util["default"].getTextByDisplayField(data, displayField, valueField)), /*#__PURE__*/_react["default"].createElement("span", {
        className: "tree-node-content-desc"
      }, data[descriptionField])) : _Util["default"].getTextByDisplayField(data, displayField, valueField), isNodeLoading && loadingIconPosition === 'right' ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
        className: "button-icon button-icon-right button-loading-icon",
        size: "small"
      }) : data.rightIconCls ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "button-icon button-icon-right ".concat(data.rightIconCls),
        "aria-hidden": "true"
      }) : null)), this.renderChildren());
    }
  }]);
  return TreeNode;
}(_react.Component);
(0, _defineProperty2["default"])(TreeNode, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TreeNode, "Theme", _Theme["default"]);
TreeNode.propTypes = {
  index: _propTypes["default"].number,
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].object,
  treeData: _propTypes["default"].object,
  value: _propTypes["default"].any,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  descriptionField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  nodeDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  isNodeToggling: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  indentWidth: _propTypes["default"].number,
  renderer: _propTypes["default"].func,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onNodeToggleStart: _propTypes["default"].func,
  onNodeToggleEnd: _propTypes["default"].func
};
TreeNode.defaultProps = {
  index: 0,
  depth: 0,
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  allowCollapse: true,
  collapsed: false,
  isNodeToggling: false,
  isSelectRecursive: false,
  indentWidth: 20,
  collapsedIconCls: 'fas fa-caret-right',
  expandedIconCls: 'fas fa-caret-down',
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = TreeNode;
exports["default"] = _default;