"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
function getDerivedState(props, state) {
  for (var _len = arguments.length, keys = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    keys[_key - 2] = arguments[_key];
  }
  if (!props || !state || !keys || keys.length < 1) {
    return;
  }
  var propsKey = '',
    stateKey = '';
  if (keys.length === 2) {
    propsKey = keys[0];
    stateKey = keys[1];
  } else {
    propsKey = keys[0];
    stateKey = keys[0];
  }
  var prevProps = state.prevProps;
  return prevProps ? (0, _isEqual["default"])(prevProps[propsKey], props[propsKey]) ? state[stateKey] : props[propsKey] : props[propsKey];
}
function is(x, y) {
  return x === y ? x !== 0 || y !== 0 || 1 / x === 1 / y : x !== x && y !== y;
}
function isPropsEqual(x, y, excludes) {
  if (is(x, y)) {
    return true;
  }
  if ((0, _typeof2["default"])(x) !== 'object' || x === null || (0, _typeof2["default"])(y) !== 'object' || y === null) {
    return false;
  }
  var xKeys = Object.keys(x),
    yKeys = Object.keys(y);
  if (xKeys.length !== yKeys.length) {
    return false;
  }
  for (var i = 0; i < xKeys.length; i++) {
    if (excludes.includes(xKeys[i]) || typeof x[xKeys[i]] === 'function' || typeof y[yKeys[i]] === 'function') {
      continue;
    }
    if (!hasOwnProperty.call(y, xKeys[i]) || !is(x[xKeys[i]], y[xKeys[i]])) {
      return false;
    }
  }
  return true;
}
var _default = {
  getDerivedState: getDerivedState,
  isPropsEqual: isPropsEqual
};
exports["default"] = _default;