"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _moment = _interopRequireDefault(require("moment"));
/**
 * @file: /alcedo-ui/src/_vendors/DateUtil.js
 * @author
 */

// eslint-disable-next-line require-jsdoc
function MonthDays(year) {
  // debugger
  var dateArray = [];
  for (var i = 0; i < 12; i++) {
    switch (i + 1) {
      case 1:
      case 3:
      case 5:
      case 7:
      case 8:
      case 10:
      case 12:
        dateArray.push(31);
        break;
      case 4:
      case 6:
      case 9:
      case 11:
        dateArray.push(30);
        break;
      case 2:
        if ((0, _moment["default"])(year + '-02-29', 'YYYY-MM-DD', true).isValid()) {
          dateArray.push(29);
        } else {
          dateArray.push(28);
        }
        break;
      default:
        break;
    }
  }
  return dateArray;
}

// eslint-disable-next-line require-jsdoc
function setDateRange(start, end) {
  var _start$year, _end$year, _start$month, _end$month;
  if (((_start$year = start.year) === null || _start$year === void 0 ? void 0 : _start$year.toString()) === ((_end$year = end.year) === null || _end$year === void 0 ? void 0 : _end$year.toString()) && ((_start$month = start.month) === null || _start$month === void 0 ? void 0 : _start$month.toString()) === ((_end$month = end.month) === null || _end$month === void 0 ? void 0 : _end$month.toString())) {
    if (parseInt(start.month, 10) === 12) {
      end.year = +end.year + 1;
      end.month = 1;
    } else {
      end.month = +end.month + 1;
    }
  }
  return {
    start: start,
    end: end
  };
}

// eslint-disable-next-line require-jsdoc
function setMonthRange(start, end) {
  var _start$year2, _end$year2;
  if (((_start$year2 = start.year) === null || _start$year2 === void 0 ? void 0 : _start$year2.toString()) === ((_end$year2 = end.year) === null || _end$year2 === void 0 ? void 0 : _end$year2.toString())) {
    end.year = +end.year + 1;
  }
  return {
    start: start,
    end: end
  };
}

// eslint-disable-next-line require-jsdoc
function getYearArr(num) {
  var yearString = num.toString();
  yearString = yearString.substr(0, yearString.length - 1);
  var YearArr = [];
  for (var i = 0; i < 10; i++) {
    YearArr.push(yearString + i);
  }
  return YearArr;
}

// eslint-disable-next-line require-jsdoc
function getMonth(num) {
  return ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'][num - 1];
}

// eslint-disable-next-line require-jsdoc
function getPrevMaxCloserDate(selectedDate, compareDateArray) {
  var prevDateArray = compareDateArray.slice().filter(function (item) {
    return new Date(selectedDate) - new Date(item === null || item === void 0 ? void 0 : item.value[1]) > 0;
  }).map(function (item) {
    return new Date(item === null || item === void 0 ? void 0 : item.value[1]).valueOf();
  });
  return compareDateArray.find(function (item) {
    return new Date(item === null || item === void 0 ? void 0 : item.value[1]).valueOf() === Math.max.apply(Math, (0, _toConsumableArray2["default"])(prevDateArray));
  });
}

// eslint-disable-next-line require-jsdoc
function getNextMinCloserDate(selectedDate, compareDateArray) {
  var nextDateArray = compareDateArray.slice().filter(function (item) {
    return new Date(selectedDate) - new Date(item === null || item === void 0 ? void 0 : item.value[0]) < 0;
  }).map(function (item) {
    return new Date(item === null || item === void 0 ? void 0 : item.value[0]).valueOf();
  });
  return compareDateArray.find(function (item) {
    return new Date(item === null || item === void 0 ? void 0 : item.value[0]).valueOf() === Math.min.apply(Math, (0, _toConsumableArray2["default"])(nextDateArray));
  });
}
var _default = {
  MonthDays: MonthDays,
  setDateRange: setDateRange,
  setMonthRange: setMonthRange,
  getYearArr: getYearArr,
  getMonth: getMonth,
  getPrevMaxCloserDate: getPrevMaxCloserDate,
  getNextMinCloserDate: getNextMinCloserDate
};
exports["default"] = _default;