"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.isAbove = isAbove;
var _Dom = _interopRequireDefault(require("./Dom"));
/**
 * @file DropdownCalculation vendor
 */

// Vendors

/**
 * @param dropdownEl
 * @param triggerEl
 * @param popupEl
 * @returns {boolean}
 */
function isAbove(dropdownEl, triggerEl, popupEl) {
  if (!dropdownEl || !triggerEl || !popupEl) {
    return false;
  }
  var _Dom$getOffset = _Dom["default"].getOffset(dropdownEl),
    top = _Dom$getOffset.top;
  var scrollTop = _Dom["default"].getScrollTop();
  var triggerHeight = triggerEl.clientHeight;
  var popupHeight = popupEl.clientHeight;
  return top + triggerHeight + popupHeight - scrollTop > window.innerHeight // bottom overflow
  && top - popupHeight - scrollTop >= 0 // no top overflow
  ;
}
var _default = {
  isAbove: isAbove
};
exports["default"] = _default;