"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
/**
 * @file Event vendor
 */

function addEvent(el, type, cb) {
  if (!el || !type) {
    return;
  }
  if (typeof window.addEventListener === 'function') {
    el.addEventListener(type, cb, false);
  } else if (typeof document.attachEvent === 'function') {
    el.attachEvent("on".concat(type), cb);
  } else {
    el["on".concat(type)] = cb;
  }
}
function removeEvent(el, type, cb) {
  if (!el || !type) {
    return;
  }
  if (typeof window.removeEventListener === 'function') {
    el.removeEventListener(type, cb, false);
  } else if (typeof document.detachEvent === 'function') {
    el.detachEvent("on".concat(type), cb);
  } else {
    el["on".concat(type)] = null;
  }
}
function triggerPopupEventHandle(el, triggerEl, popupEl, currentVisible) {
  var flag = true;
  while (el) {
    if (el == popupEl) {
      return currentVisible;
    } else if (el == triggerEl) {
      return !currentVisible;
    }
    el = el.parentNode;
  }
  if (flag) {
    return false;
  }
}

// function preventContainerScroll(e) {
//
//     const {currentTarget, deltaX, deltaY} = e,
//         {
//             clientWidth, scrollWidth, scrollLeft,
//             clientHeight, scrollHeight, scrollTop
//         } = currentTarget;
//
//     if (
//         (
//             scrollWidth > clientWidth
//             &&
//             (
//                 (deltaX < 0 && scrollLeft <= 0)
//                 ||
//                 (deltaX > 0 && scrollLeft >= scrollWidth - clientWidth)
//             )
//         )
//         ||
//         (
//             scrollHeight > clientHeight
//             &&
//             (
//                 (deltaY < 0 && scrollTop <= 0)
//                 ||
//                 (deltaY > 0 && scrollTop >= scrollHeight - clientHeight)
//             )
//         )
//     ) {
//         e.preventDefault();
//     }
//
// }

// function wheelHandler(e, props) {
//
//     if (!props) {
//         return;
//     }
//
//     const {shouldPreventContainerScroll, onWheel} = props;
//     shouldPreventContainerScroll && preventContainerScroll(e);
//     onWheel && onWheel(e);
//
// }
var _default = {
  addEvent: addEvent,
  removeEvent: removeEvent,
  triggerPopupEventHandle: triggerPopupEventHandle
  // preventContainerScroll
  // wheelHandler
};
exports["default"] = _default;