"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _addClass = _interopRequireDefault(require("dom-helpers/addClass"));
var _removeClass = _interopRequireDefault(require("dom-helpers/removeClass"));
/**
 * @file PortalManagement vendor
 */

var map = {};
function push(parentEl, portalEl) {
  if (!(parentEl in map)) {
    map[parentEl] = [];
  }
  (0, _addClass["default"])(parentEl, 'portal-parent');
  map[parentEl].push(portalEl);
}
function pop(parentEl, portalEl) {
  map[parentEl].splice(map[parentEl].indexOf(portalEl), 1);
  if (map[parentEl].length < 1) {
    (0, _removeClass["default"])(parentEl, 'portal-parent');
  }
}
var _default = {
  push: push,
  pop: pop
};
exports["default"] = _default;