"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.getHideHorizontalScrollBarStyle = getHideHorizontalScrollBarStyle;
exports.getSize = getSize;
var _Direction = _interopRequireDefault(require("../_statics/Direction"));
var _classnames = _interopRequireDefault(require("classnames"));
require("./ScrollBar.scss");
/**
 * @file ScrollBar vendor
 */

// Statics

// Vendors

// Styles

// cache
var tempSize = {
  vertical: null,
  horizontal: null
};
function getSize() {
  var direction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _Direction["default"].VERTICAL;
  if (document == undefined || window == undefined) {
    return;
  }
  var isVertical = direction === _Direction["default"].VERTICAL;
  if (isVertical && tempSize.vertical !== null) {
    return tempSize.vertical;
  } else if (!isVertical && tempSize.horizontal != null) {
    return tempSize.horizontal;
  }
  var scrollDiv = document.createElement('div');
  scrollDiv.className = (0, _classnames["default"])('scroll-bar-for-measure', direction);
  document.body.appendChild(scrollDiv);
  var size = 0;
  if (isVertical) {
    size = scrollDiv.offsetWidth - scrollDiv.clientWidth;
    tempSize.vertical = size;
  } else {
    size = scrollDiv.offsetHeight - scrollDiv.clientHeight;
    tempSize.horizontal = size;
  }
  document.body.removeChild(scrollDiv);
  return size;
}
function getHideHorizontalScrollBarStyle() {
  var size = getSize(_Direction["default"].HORIZONTAL);
  return size > 0 ? {
    paddingBottom: 0,
    marginBottom: -size
  } : {
    paddingBottom: 20,
    marginBottom: -20
  };
}
var _default = {
  getSize: getSize,
  getHideHorizontalScrollBarStyle: getHideHorizontalScrollBarStyle
};
exports["default"] = _default;